/***********************************************************************

Copyright (c) 2001,2002 Fritz Ganter <ganter@ganter.at>
Website: www.gpsdrive.de

Modifications for ipaq specific version
Copyright (c) 2007 Andrew M. Bishop <amb@gedanken.demon.co.uk>
Website: http://www.geganken.demon.co.uk/gpsdrive-ipaq/

Disclaimer: Please do not use for navigation. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    **********************************************************************/

/*  Include Dateien */
#include "config.h"
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <signal.h>
#include <termios.h>
#include <unistd.h>
#include <math.h>
#include <ctype.h>
#include <sys/time.h>
#include "compass.h"
#include <errno.h>
#include <gmodule.h>
#include <gdk/gdktypes.h>
#include <gtk/gtk.h>

#if HAVE_LOCALE_H
#include <locale.h>
#else
# define setlocale(Category, Locale)
#endif
#include "gettext.h"

#include "gpsdrive.h"
#include "track.h"
#include "icons.h"
#include <pthread.h>

/*  Defines for gettext I18n */
# include <libintl.h>
# define _(String) gettext(String)
# ifdef gettext_noop
#  define N_(String) gettext_noop(String)
# else
#  define N_(String) (String)
# endif


#if GTK_MINOR_VERSION < 2
#define gdk_draw_pixbuf _gdk_draw_pixbuf
#endif

/***************************************************************************/
/***************************************************************************/
/***************************************************************************/

/*  global variables */
gint statusid, timeoutcount;
GtkWidget *mainwindow, *status, *gotowindow, *messagewindow, *routewindow;
gint sock = -1, bigp = 0, bigpGSV = 0, bigpGGA = 0, bigpRME = 0, bigpGSA = 0;
gint lastpRME = 0, lastpGSA = 0, lastp = 0, lastpGSV = 0, lastpGGA = 0, debug = 0;
FILE *nmeaout = NULL;
gchar *buffer = NULL, *big = NULL;
fd_set readmask;
struct timeval timeout;
gchar targetname[40];
gdouble current_long, current_lat, old_long, old_lat, groundspeed;
gdouble zero_long, zero_lat, target_long, target_lat, dist;
GdkGC *kontext;
GdkColor red = { 0, 0xFF00, 0x00, 0x00 };
GdkColor black = { 0, 0x00, 0x00, 0x00 };
GdkColor white = { 0, 0xFFFF, 0xFFFF, 0xFFFF };
GdkColor blue = { 0, 0x00, 0x00, 0xff00 };

//GdkColor nightcolor = { 0, 0x0000, 0xa000, 0x0000 };

GdkColor nightcolor = { 0, 0xa000, 0x0000, 0x0000 };
GdkColor lcd = { 0, 0x8b00, 0x9500, 0x8b00 };
GdkColor lcd2 = { 0, 0x7300, 0x7d00, 0x6a00 };
GdkColor yellow = { 0, 0xff00, 0xff00, 0x00 };
GdkColor green = { 0, 0x0000, 0xb000, 0x0000 };
GdkColor green2 = { 0, 0x0000, 0xff00, 0x0000 };
GdkColor mygray = { 0, 0xd500, 0xd600, 0xd500 };
GdkColor textback = { 0, 0xc000, 0xc000, 0xc000 };
GdkColor textbacknew = { 0, 0x4000, 0x7600, 0xcf00 };
GdkColor grey = { 0, 0xC000, 0xC000, 0xC000 };
GdkColor defaultcolor;

/* GdkColor orange = { 0, 0xfb00, 0x8d00, 0x0a00 }; */
GdkColor orange = { 0, 0xf000, 0x6000, 0x0000 };
GdkColor darkgrey = { 0, SHADOWGREY, SHADOWGREY, SHADOWGREY };

GtkWidget *mainnotebook;
GtkWidget *drawing_area, *drawing_bearing, *drawing_sats1, *drawing_sats2;
GdkColor orange2 = { 0, 0xff00, 0x8000, 0x0000 };
GtkWidget *distlabel, *targetlabel, *speedlabel, *altilabel, *startgpsbt;
GdkDrawable *drawable, *drawable_bearing, *drawable_sats1, *drawable_sats2;
gint havepos, haveposcount, xoff, yoff, crosstoogle = 0;
gdouble pixelfact,angle_to_destination, direction, bearing;
gint posx, posy;
GdkPixbuf *image = NULL, *tempimage = NULL;
typedef struct
{
  gchar filename[200];
  gdouble lat;
  gdouble longitude;
  glong scale;
  gint type;
  gdouble lat_min;
  gdouble lat_max;
  gdouble lon_min;
  gdouble lon_max;
}
mapsstruct;
mapsstruct *maps = NULL;

/* action=1: radar (speedtrap) */

typedef struct
{
  gchar name[40];
  gdouble lat;
  gdouble longitude;
  gint xpos;
  gint ypos;
  gdouble dist;
  gchar typ[40];
  gint symbol;
  gint action;
}
wpstruct;
wpstruct *wayp, *routelist;


gchar oldfilename[200];
gint nrmaps = 0;
gdouble earthr;
/*Earth radius calibrated with GARMIN III */
/*  gdouble R = 6383254.445; */


#define R earthr


/*  if we get data from gpsd in NMEA format haveNMEA is TRUE */
gint haveNMEA;

gint maploaded, zoom, iszoomed;
gchar homedir[500], mapdir[500];
gint thisline, thisrouteline = 0, routeitems = 0, routepointer = 0;
gint maxwp;
gint satlist[MAXSATS][4], satlistdisp[MAXSATS][4], satbit = 0;
GtkWidget *mylist, *myroutelist;
gchar mapfilename[200];
gdouble milesconv, olddist = 99999.0;
GTimer *timer, *disttimer;
gint gcount, milesflag;
gint metricflag, nauticflag;
struct lconv *mylocale;
gchar localedecimal;
gint scaleprefered = 1, scalewanted = 100000;
glong mapscale;
GtkWidget *dltext1, *dltext2, *dltext4, *wptext1, *wptext2;
gdouble wplat, wplon;
GtkWidget *scaler;
gchar oldangle[100];
GdkCursor *cursor;
gint nlist[] = { 1000, 1500, 2000, 3000, 5000, 7500,
  10000, 15000, 20000, 30000, 50000, 75000,
  100000, 150000, 200000, 300000, 500000, 750000,
  1000000, 1500000, 2000000, 3000000, 5000000, 7500000,
  10000000, 15000000, 20000000, 30000000, 50000000, 75000000
};
GtkWidget *l1, *l2, *l3, *l4, *l5, *l6, *l7, *l8, *mutebt;
GtkWidget *trackbt, *wpbt;
GtkWidget *bestmapbt, *maptogglebt, *topotogglebt, *osmtogglebt, *savetrackbt;
GtkWidget *scalerlbt, *scalerrbt;
GtkWidget *miles, *setupbt;
gint savetrack = 0, havespeechout, hours, minutes, speechcount = 0;
gint muteflag = 0, trackflag = 1, wpflag = TRUE;
gint displaymap_top = TRUE, displaymap_osm = TRUE, displaymap_map = TRUE;
gint posmode = 0;
gdouble posmode_x, posmode_y;
GtkObject *adj;
gchar lastradar[40], lastradar2[40], nmeamodeandport[50];
gint foundradar;
gdouble radarbearing;
gint errortextmode = TRUE;
enum
{ english, german, spanish }
voicelang;
gchar serialdev[80];
GdkSegment *track;
glong tracknr;
trackcoordstruct *trackcoord;
glong trackcoordnr, tracklimit, trackcoordlimit;
gdouble Ra[201];
gchar savetrackfn[256];

/*** Mod by Arms */
gint real_screen_x, real_screen_y, real_psize;
gint SCREEN_X_2, SCREEN_Y_2;
time_t waytxtstamp = 0, maptxtstamp = 0;
/* guint selwptimeout; */
gint dontsetwp = FALSE;
gint setwpactive = FALSE;
gint createroute = FALSE, routemode = FALSE;
gdouble routenearest = 9999999999.0;
GtkWidget *create_route_button, *create_route2_button, *select_route_button;
gint markwaypoint = FALSE;
GtkWidget *addwaypointwindow, *setupfn[30];
typedef struct
{
  gchar n[200];
}
namesstruct;
namesstruct *names;
gchar activewpfile[200], gpsdservername[200], setpositionname[80];
gint newsatslevel = TRUE, needtosave = FALSE;
GtkWidget *serialbt, *mapdirbt, *addwaypoint1, *addwaypoint2, *frame_speed;
gdouble altitude = 0.0, precision = (-1.0), gsaprecision = (-1.0);
gint oldsatfix = 0, oldsatsanz = -1, havealtitude = FALSE;
gint wpsize = 1000, satfix = 0, usedgps = FALSE;
gchar dgpsserver[80], dgpsport[10];
GtkWidget *posbt;
gint needreloadmapconfig = FALSE;
GdkPixbuf *satsimage = NULL;
gint numsats = 0, satsavail = 0;
gint deleteline = 0;
gint saytarget = FALSE, printoutsats = FALSE;
extern gchar *displaytext;
extern gint do_display_dsc, textcount;
gint minsecmode = FALSE, nightmode = FALSE, isnight = FALSE, disableisnight;
GtkWidget *setupentry[50], *setupentrylabel[50];
void (*setupfunction[50]) ();
gchar utctime[20], loctime[20];
gint mod_setupcounter = 4;
gint haveRMCsentence = FALSE;
gdouble NMEAsecs = 0.0;
gint NMEAoldsecs = 0;
gint borderlimit;
gint zoomscale = TRUE;
gint exposed = FALSE;
gdouble tripodometer, tripavspeed, triptime, tripmaxspeed, triptmp;
gint tripavspeedcount;
gdouble trip_long, trip_lat;
gint lastnotebook = 0;
GtkWidget *settingsnotebook;
gint useflite = FALSE, forcenextroutepoint = FALSE;
extern gint zone;
gint ignorechecksum = FALSE;
GdkColor trackcolorv;

/* Give more debug informations */
gint mydebug = FALSE;
GdkPixbuf *iconpixbuf[50];
/* gchar *p_1, *p_2, *p_3;
 * gsize *size_1;
 * gchar s_1[100], s_2[100];
 */
gint showroute = TRUE;
extern gint zone;
/* gchar gradsym[]="\302\260";  */
static gchar gradsym[] = "\xc2\xb0";
gdouble normalnull = 0;
gint forcehavepos = FALSE;
gdouble alarm_lat = 53.583033, alarm_long = 9.969533, alarm_dist = 9999999.0;
GtkWidget *satsvbox, *satshbox, *satslabel1frame,
  *satslabel2frame, *satslabel3frame;
GtkWidget *satslabel1, *satslabel2, *satslabel3;
GtkWidget *lf1, *lf2, *lf3, *lf4, *lf5, *lf7, *lf8;
GtkWidget *dframe, *frame_bearing, *frame_dist, *frame_target, *frame_altitude,
  *frame_maptype, *frame_toogles, *lab1;
gchar bluecolor[40], trackcolor[40];
gchar messagename[40], messagesendtext[1024], messageack[100];
gint statuslock = 0, gpson = FALSE;
int didrootcheck = 0, haveserial = 0;
int gotneverserial = TRUE, timerto = 0, serialspeed = 1;
int disableserial = 1, disableserialcl = 0;
GdkColormap *cmap;
extern int newdata;
extern unsigned char serialdata[4096];
extern pthread_mutex_t mutex;
int maptype = 0;
int sortcolumn = 4, sortflag = 0;
int havedefaultmap = TRUE, alreadydaymode = FALSE, alreadynightmode = FALSE;
int nmeaverbose = 0, storetz = FALSE;
int egnoson = 0, egnosoff = 0;
int sound_direction = 1, sound_distance = 1, sound_speed = 1, sound_gps = 1;


/*  quit the program */
gint
quit_program (GtkWidget * widget, gpointer datum)
{
  gtk_main_quit ();
  return (TRUE);
}

gint
error_popup (gpointer datum)
{
  GtkWidget *popup;
  GtkWidget *knopf2;
  GtkWidget *knopf3;
  GtkWidget *image;


  if (errortextmode)
    {
      g_print ("\nError: %s\n", (char *) datum);
      return (FALSE);
    }
  popup = gtk_dialog_new ();
  gtk_window_set_transient_for (GTK_WINDOW (popup), GTK_WINDOW (mainwindow));

  image =
    gtk_image_new_from_stock (GTK_STOCK_DIALOG_ERROR, GTK_ICON_SIZE_DIALOG);

  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (popup)->vbox), image,
		      FALSE, FALSE, 10);
  gtk_container_set_border_width (GTK_CONTAINER (popup), 5);

  gtk_window_set_title (GTK_WINDOW (popup), _("  Message  "));
  knopf2 = gtk_button_new_from_stock (GTK_STOCK_OK);
  GTK_WIDGET_SET_FLAGS (knopf2, GTK_HAS_FOCUS);

  gtk_signal_connect_object (GTK_OBJECT (knopf2), "clicked",
			     GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT (popup));

  gdk_beep ();
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (popup)->action_area), knopf2, TRUE,
		      TRUE, 20);
  knopf3 = gtk_label_new (datum);
  gtk_label_set_use_markup (GTK_LABEL (knopf3), TRUE);

  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (popup)->vbox), knopf3, FALSE,
		      FALSE, 10);


  gtk_window_set_position (GTK_WINDOW (popup), GTK_WIN_POS_CENTER);
  gtk_widget_show (image);
  gtk_widget_show_all (popup);

  return (FALSE);

}


void
startgpsd (guint datum)
{
  gchar s[200], s2[10];
  int t[] = { 2400, 4800, 9600, 19200, 38400 };

  if (gpson == FALSE)
    {
      g_snprintf (s2, sizeof (s2), "%d", t[serialspeed]);
      if (usedgps)
	g_snprintf (s, sizeof (s), "gpsd -p %s -c -d %s -s %s -r %s",
		    serialdev, dgpsserver, s2, dgpsport);
      else
	g_snprintf (s, sizeof (s), "gpsd -p %s -s %s", serialdev, s2);
      system (s);
      gtk_button_set_label (GTK_BUTTON (startgpsbt), _("Stop GPSD"));
      g_strlcpy (gpsdservername, "127.0.0.1", sizeof (gpsdservername));
      if (sock != -1)
	{
	  close (sock);
	  sock = -1;
	}
      gtk_timeout_add (1000, (GtkFunction) initgps, 0);
      gpson = TRUE;
      if (satsimage != NULL)
	g_object_unref (satsimage);
      satsimage = NULL;

      gtk_widget_draw (drawing_sats1, NULL);	/* this  calls expose handler */
      gtk_widget_draw (drawing_sats2, NULL);	/* this  calls expose handler */
    }
  else
    {
/* stop gpsd */
      system ("killall gpsd");
      gpson = FALSE;
      gtk_button_set_label (GTK_BUTTON (startgpsbt), _("Start GPSD"));
      haveNMEA = FALSE;
      newsatslevel = TRUE;
      memset (satlist, 0, sizeof (satlist));
      memset (satlistdisp, 0, sizeof (satlist));
      numsats = satsavail = 0;
      if (satsimage != NULL)
	g_object_unref (satsimage);
      satsimage = NULL;
      gtk_label_set_text (GTK_LABEL (satslabel1), _("n/a"));
      gtk_label_set_text (GTK_LABEL (satslabel2), _("n/a"));
      gtk_label_set_text (GTK_LABEL (satslabel3), _("n/a"));
      gtk_widget_draw (drawing_sats1, NULL);	/* this  calls expose handler */
      gtk_widget_draw (drawing_sats2, NULL);	/* this  calls expose handler */
    }
}


void
convertRMC (char *f)
{
  gchar field[50][100], b[100];
  gint start = 0;
  gint longdegree, latdegree;
  gchar langri, breitri;
  size_t i, j = 0;
  memset (b, 0, 100);

/*  get fields delimited with ',' */
  for (i = 0; i < strlen (f); i++)
    {
      if (f[i] == ',')
	{
	  g_strlcpy (field[j], (f + start), 100);
	  field[j][i - start] = 0;
	  start = i + 1;
	  j++;
	}
    }
  if ((j != 11) && (j != 12))
    {
      g_print ("\nGPRMC: wrong number of fields (%d)", (int) j);
      return;
    }
  if (!haveRMCsentence)
    {
      g_print (_("got RMC data, using it\n"));
      haveRMCsentence = TRUE;
    }

  if (debug)
    {
      g_print ("\nRMC Fields:\n");
      for (i = 0; i < j; i++)
	g_print ("\n%d:%s", (int) i, field[i]);
    }
  g_snprintf (b, sizeof (b), "%c%c:%c%c.%c%c ", field[1][0], field[1][1],
	      field[1][2], field[1][3], field[1][4], field[1][5]);
  g_strlcpy (utctime, b, sizeof (utctime));
  if (debug)
    g_print ("\nutctime: %s", utctime);
  if ((field[2][0] != 'A') || forcehavepos)
    {
      havepos = FALSE;
      haveposcount = 0;
      return;
    }
  else
    {
      havepos = TRUE;
      haveposcount++;
      if (haveposcount == 3)
	rebuildtracklist ();
    }
/*  Latitude North / South */
  b[0] = field[3][0];
  b[1] = field[3][1];
  b[2] = 0;
  latdegree = atoi (b);


  b[0] = field[3][2];
  b[1] = field[3][3];
  b[2] = localedecimal;
  b[3] = field[3][5];
  b[4] = field[3][6];
  b[5] = field[3][7];
  b[6] = 0;
  if (!posmode)
    {
      gdouble cl;
      cl = latdegree + atof (b) / 60.0;
      if (field[4][0] == 'S')
	cl = cl * -1;
      if ((cl >= -90.0) && (cl <= 90.0))
	current_lat = cl;
      breitri = field[4][0];
      g_snprintf (b, sizeof (b), " %8.5f%s%c", current_lat, gradsym, breitri);
    }

/*  Longitude East / West */
  b[0] = field[5][0];
  b[1] = field[5][1];
  b[2] = field[5][2];
  b[3] = 0;
  longdegree = atoi (b);

  b[0] = field[5][3];
  b[1] = field[5][4];
  b[2] = localedecimal;
  b[3] = field[5][6];
  b[4] = field[5][7];
  b[5] = field[5][8];
  b[6] = 0;
  if (!posmode)
    {
      gdouble cl;
      cl = longdegree + atof (b) / 60.0;
      if (field[6][0] == 'W')
	cl = cl * -1;
      if ((cl >= -180.0) && (cl <= 180.0))
	current_long = cl;

      langri = field[6][0];
      g_snprintf (b, sizeof (b), " %8.5f%s%c", current_long, gradsym, langri);
    }

/*  speed */
  b[0] = field[7][0];
  b[1] = field[7][1];
  b[2] = field[7][2];
  b[3] = localedecimal;
  b[4] = field[7][4];
  b[5] = 0;
  groundspeed = atof (b) * 1.852 * milesconv;
  g_snprintf (b, sizeof (b), " %s: %s", _("Map"), mapfilename);
/*    g_print("Field %s\n",field[8]); */
  b[0] = field[8][0];
  b[1] = field[8][1];
  b[2] = field[8][2];
  b[3] = localedecimal;
  b[4] = field[8][4];
  b[5] = 0;
/*  direction is the course we are driving */
  direction = atof (b);
  direction = direction * M_PI / 180;

  {
    int h, m, s;
    h = m = s = 0;
    if (strcmp (utctime, "n/a") != 0)
      {
	sscanf (utctime, "%d:%d.%d", &h, &m, &s);
	h += zone;
	if (h > 23)
	  h -= 24;
	if (h < 0)
	  h += 24;
	g_snprintf (loctime, sizeof (loctime), "%02d:%02d.%02d", h, m, s);
      }
    else
      g_strlcpy (loctime, "n/a", sizeof (loctime));
  }

}

/*  show satellites signal level */
gint
convertGSV (char *f)
{
  gchar field[50][100], b[500];
  gint i, l, i2, j = 0, start = 0, n, db, anz, az, el;

  memset (b, 0, 100);
  l = strlen (f);
  for (i = 0; i < l; i++)
    {
      if ((f[i] == ',') || (f[i] == '*'))
	{
	  g_strlcpy (field[j], (f + start), 100);
	  field[j][i - start] = 0;
	  start = i + 1;
	  j++;
	}
    }
  if (debug)
    {
      g_print ("\nGSV Fields:\n");
      for (i = 0; i < j; i++)
	g_print ("%d:%s$", i, field[i]);
    }
  if (j > 40)
    {
      g_print ("\nGPGSV: wrong number of fields (%d)", j);
      return FALSE;
    }

  if (field[2][0] == '1')
    satbit = satbit | 1;
  if (field[2][0] == '2')
    satbit = satbit | 2;
  if (field[2][0] == '3')
    satbit = satbit | 4;

  anz = atoi (field[3]);
  b[0] = field[1][0];
  b[1] = 0;
  i2 = atof (b);
  if (mydebug)
    g_print ("\nbits should be:%d  is: %d", i2, satbit);
  g_snprintf (b, sizeof (b), "\nSatellites: %d ", anz);
  if (anz != oldsatsanz)
    newsatslevel = TRUE;
  oldsatsanz = anz;

  for (i = 4; i < j; i += 4)
    {
      n = atoi (field[i]);
      if (n > MAXSATS)
	{
	  fprintf (stderr, "illegal satellite number: %d, ignoring\n", n);
	  continue;
	}
      db = atoi (field[i + 3]);
      el = atoi (field[i + 1]);
      az = atoi (field[i + 2]);
      if (debug)
	fprintf (stderr,
		 "satnumber: %2d elev: %3d azimut: %3d signal %3ddb\n", n, el,
		 az, db);

      satlist[n][0] = n;
      satlist[n][1] = db;
      satlist[n][2] = el;
      satlist[n][3] = az;
    }

  if (((pow (2, i2)) - 1) == satbit)
    {
      satsavail = 0;
      for (i = 0; i < MAXSATS; i++)
	if (satlist[i][0] != 0)
	  {
	    g_snprintf (b, sizeof (b), "% 2d: % 2ddb   ", satlist[i][0],
			satlist[i][1]);
	    satsavail++;
	  }
      satbit = 0;

      memcpy (satlistdisp, satlist, sizeof (satlist));
      memset (satlist, 0, sizeof (satlist));
      newsatslevel = TRUE;
      return TRUE;
    }

  return FALSE;
}


/*  show altitude and satfix */
void
convertGGA (char *f)
{
  gchar field[50][100], b[500];
  gint i, l, j = 0, start = 0;
  gint longdegree, latdegree;
  gchar langri, breitri;

  memset (b, 0, 100);
  l = strlen (f);
  for (i = 0; i < l; i++)
    {
      if ((f[i] == ',') || (f[i] == '*'))
	{
	  g_strlcpy (field[j], (f + start), 100);
	  field[j][i - start] = 0;
	  start = i + 1;
	  j++;
	}
    }
  if (debug)
    {
      g_print ("\nGGA Fields:\n");
      for (i = 0; i < j; i++)
	g_print ("%d:%s$", i, field[i]);
    }

  if (j != 15)
    {
      g_print ("\nGPGGA: wrong number of fields (%d)", j);
      return;
    }

/*   the receiver sends no GPRMC, so we get the data from here */
  if (!haveRMCsentence)
    {
      gint mysecs;

/*       if (debug) */
      g_print (_("got no RMC data, using GGA data\n"));
      g_snprintf (b, sizeof (b), "%c%c", field[1][4], field[1][5]);
      sscanf (b, "%d", &mysecs);
      if (mysecs != NMEAoldsecs)
	{
	  NMEAsecs = mysecs - NMEAoldsecs;
	  if (NMEAsecs < 0)
	    NMEAsecs += 60;
	  NMEAoldsecs = mysecs;
	}
/*       g_print ("\nnmeasecs: %.2f mysecs: %d, nmeaoldsecs: %d", NMEAsecs, */
/* 	       mysecs, NMEAoldsecs); */
      g_snprintf (b, sizeof (b), "%c%c:%c%c.%c%c ", field[1][0], field[1][1],
		  field[1][2], field[1][3], field[1][4], field[1][5]);
      g_strlcpy (utctime, b, sizeof (utctime));

      if (field[6][0] == '0')
	{
	  havepos = FALSE;
	  haveposcount = 0;
	  return;
	}
      else
	{
	  havepos = TRUE;
	  haveposcount++;
	  if (haveposcount == 3)
	    rebuildtracklist ();
	}

/*  Latitude North / South */
      b[0] = field[2][0];
      b[1] = field[2][1];
      b[2] = 0;
      latdegree = atoi (b);


      b[0] = field[2][2];
      b[1] = field[2][3];
      b[2] = localedecimal;
      b[3] = field[2][5];
      b[4] = field[2][6];
      b[5] = field[2][7];
      b[6] = 0;
/*       fprintf(stderr,"\nposmode: %d\n",posmode); */
      if (!posmode)
	{
	  gdouble cl;
	  cl = latdegree + atof (b) / 60.0;
	  if (field[3][0] == 'S')
	    cl = cl * -1;
	  if ((cl >= -90.0) && (cl <= 90.0))
	    current_lat = cl;

	  breitri = field[3][0];
/* 	  fprintf (stderr, "%8.5f%s%c cl:%f\n", current_lat, gradsym, breitri,cl); */
	}

/*  Longitude East / West */
      b[0] = field[4][0];
      b[1] = field[4][1];
      b[2] = field[4][2];
      b[3] = 0;
      longdegree = atoi (b);

      b[0] = field[4][3];
      b[1] = field[4][4];
      b[2] = localedecimal;
      b[3] = field[4][6];
      b[4] = field[4][7];
      b[5] = field[4][8];
      b[6] = 0;

      if (!posmode)
	{
	  gdouble cl;
	  cl = longdegree + atof (b) / 60.0;
	  if (field[5][0] == 'W')
	    cl = cl * -1;
	  if ((cl >= -180.0) && (cl <= 180.0))
	    current_long = cl;

	  langri = field[5][0];
/* 	  fprintf (stderr, "%8.5f%s%c cl:%f\n", current_long, gradsym, langri,cl); */
	}

      if (debug)
	g_print ("\nGGA pos: %f %f\n", current_lat, current_long);
    }

  satfix = g_strtod (field[6], 0);
  numsats = g_strtod (field[7], 0);
  if (havepos)
    {
      havealtitude = TRUE;
      altitude = g_strtod (field[9], 0);
      if (debug)
	{
	  g_print ("\nAltitude: %.1f, Fix: %d", altitude, satfix);
	}
    }
  else
    {
      groundspeed = 0;
      numsats = 0;
    }
  {
    int h, m, s;
    h = m = s = 0;
    if (strcmp (utctime, "n/a") != 0)
      {
	sscanf (utctime, "%d:%d.%d", &h, &m, &s);
	h += zone;
	if (h > 23)
	  h -= 24;
	if (h < 0)
	  h += 24;
	g_snprintf (loctime, sizeof (loctime), "%02d:%02d.%02d", h, m, s);
      }
    else
      g_strlcpy (loctime, "n/a", sizeof (loctime));
  }
}


/*  show estimated position error $PGRME (Garmin only)  */
void
convertRME (char *f)
{
  gchar field[50][100], b[500];
  gint i, l, j = 0, start = 0;

  memset (b, 0, 100);
  l = strlen (f);
  for (i = 0; i < l; i++)
    {
      if ((f[i] == ',') || (f[i] == '*'))
	{
	  g_strlcpy (field[j], (f + start), 100);
	  field[j][i - start] = 0;
	  start = i + 1;
	  j++;
	}
    }
  if (debug)
    {
      g_print ("\nRME Fields:\n");
      for (i = 0; i < j; i++)
	g_print ("%d:%s$", i, field[i]);
    }
  if (havepos)
    {

      precision = g_strtod (field[1], 0);
      if (debug)
	{
	  g_print ("\nRME precision: %.1f", precision);
	}
    }

}

/*  show  HDOP in meters */
void
convertGSA (char *f)
{
  gchar field[50][100], b[500];
  gint i, l, j = 0, start = 0;

  memset (b, 0, 100);
  l = strlen (f);
  for (i = 0; i < l; i++)
    {
      if ((f[i] == ',') || (f[i] == '*'))
	{
	  g_strlcpy (field[j], (f + start), 100);
	  field[j][i - start] = 0;
	  start = i + 1;
	  j++;
	}
    }
  if (debug)
    {
      g_print ("\nGSA Fields:\n");
      for (i = 0; i < j; i++)
	g_print ("%d:%s$", i, field[i]);
    }
  if (havepos)
    {

      gsaprecision = g_strtod (field[15], 0);
      if (debug)
	{
	  g_print ("\nGSA PDOP: %.1f", gsaprecision);
	}
    }

}



void
display_status (char *message)
{
  gchar tok[200];

  if (statuslock)
    return;
  g_snprintf (tok, sizeof (tok), "%s", message);
  gtk_statusbar_pop (GTK_STATUSBAR (status), statusid);
  gtk_statusbar_push (GTK_STATUSBAR (status), statusid, tok);
}


gint
get_position_data_cb (GtkWidget * widget, guint * datum)
{
  gint e = 0, j = 0, i = 0, found = 0, foundGSV = 0, foundGGA = 0, foundGSA =
    0, foundRME = 0;
  gdouble secs = 0, tx, ty, lastdirection;
  typedef struct
  {
    gchar *a1;
    gchar *a2;
    gchar *a3;
  }
  argument;
  argument *argumente;
  char data[4096], tok[1000];
  static int serialtimeoutcount = 0;
  int tilimit;

  if ((timeoutcount > 3) && (debug))
    g_print ("*** %d. timeout getting data from GPS-Receiver!\n",
	     timeoutcount);

  if (haveserial)
    tilimit = 5;
  else
    tilimit = 10;

  if (timeoutcount > tilimit)
    {
      gtk_statusbar_pop (GTK_STATUSBAR (status), statusid);
      gtk_statusbar_push (GTK_STATUSBAR (status), statusid,
			  _("Timeout getting data from GPS-Receiver!"));
      havepos = FALSE;
      haveposcount = 0;
      memset (satlist, 0, sizeof (satlist));
      memset (satlistdisp, 0, sizeof (satlist));
      if (numsats != 0)
	{
	  numsats = 0;
	  gtk_widget_draw (drawing_sats1, NULL);	/* this  calls expose handler */
	  gtk_widget_draw (drawing_sats2, NULL);	/* this  calls expose handler */
	}
    }

  if (haveserial)
    {
      if ((timeoutcount > 8) && gotneverserial)
	{
	  havepos = FALSE;
	  haveposcount = 0;
	  haveserial = FALSE;
	  haveNMEA = FALSE;
	  newsatslevel = TRUE;
	  gtk_timeout_remove (timerto);
	  timerto =
	    gtk_timeout_add (TIMER, (GtkFunction) get_position_data_cb, NULL);

	  gtk_widget_set_sensitive (startgpsbt, TRUE);
	  gtk_widget_draw (drawing_sats1, NULL);	/* this  calls expose handler */
	  gtk_widget_draw (drawing_sats2, NULL);	/* this  calls expose handler */

	  return TRUE;
	}

      if (newdata == TRUE)
	{
	  pthread_mutex_lock (&mutex);
	  g_strlcpy (data, serialdata, sizeof (data));
/* 	  fprintf (stderr, "#########:%s\n", data); */
	  newdata = FALSE;
	  pthread_mutex_unlock (&mutex);
	  timeoutcount = 0;

	  if (posmode)
	    display_status (_("Press middle mouse button for navigation"));
	  else
	    {
	      g_snprintf (nmeamodeandport, sizeof (nmeamodeandport),
			  _("Direct serial connection to %s"), serialdev);
	    }
	  if ((strncmp ((data + 3), "RMC", 3) == 0) && (data[0] == '$'))
	    {
	      havepos = TRUE;
	      gotneverserial = FALSE;
/*  we have the $GPRMC string completed, now parse it */
	      if (checksum (data) == TRUE)
		convertRMC (data);
	    }

	  if ((strncmp ((data + 3), "GSV", 3) == 0) && (data[0] == '$'))
	    {
	      gotneverserial = FALSE;
	      if (checksum (data) == TRUE)
		convertGSV (data);
	    }

	  if ((strncmp ((data + 3), "GGA", 3) == 0) && (data[0] == '$'))
	    {
	      gotneverserial = FALSE;
	      if (checksum (data) == TRUE)
		convertGGA (data);
	    }

	  if ((strncmp ((data + 3), "RME", 3) == 0) && (data[0] == '$'))
	    {
	      gotneverserial = FALSE;
	      if (checksum (data) == TRUE)
		convertRME (data);
	    }

	  if ((strncmp ((data + 3), "GSA", 3) == 0) && (data[0] == '$'))
	    {
	      gotneverserial = FALSE;
	      if (checksum (data) == TRUE)
		convertGSA (data);
	    }


/*  display the position and map in the statusline */
	  if (havepos)
	    {
	      if (posmode)
		display_status (_
				("Press middle mouse button for navigation"));
	      else
		display_status (nmeamodeandport);
	    }
	  else
	    display_status (_("Not enough satellites in view!"));
	}
      else
	{
	  serialtimeoutcount++;
	  if (serialtimeoutcount > (1000.0 / TIMERSERIAL))
	    {
	      timeoutcount++;
	      serialtimeoutcount = 0;
	      if (debug)
		fprintf (stderr, "timeout: %d\n", timeoutcount);
	    }
	}

      return TRUE;
    }


  argumente = NULL;
  if (!haveRMCsentence)
    {
     secs = NMEAsecs;

      if (secs >= 1.0)
	{
	  tx =
	    (2 * R * M_PI / 360) * cos (M_PI * current_lat / 180.0) *
	    (current_long - old_long);
	  ty = (2 * R * M_PI / 360) * (current_lat - old_lat);
#define MINMOVE 4.0
	  if (((fabs (tx)) > MINMOVE) || (((fabs (ty)) > MINMOVE)))
	    {
	      lastdirection = direction;
	      if (ty == 0)
		direction = 0.0;
	      else
		direction = atan (tx / ty);
	      if (!finite (direction))
		direction = lastdirection;
	      if (ty < 0)
		direction = M_PI + direction;
	      if (direction >= (2 * M_PI))
		direction -= 2 * M_PI;
	      if (direction < 0)
		direction += 2 * M_PI;

	      groundspeed = milesconv * sqrt (tx * tx + ty * ty) * 3.6 / secs;
	      old_lat = current_lat;
	      old_long = current_long;
	    }
	  else if (secs > 4.0)
	    groundspeed = 0.0;

	  if (groundspeed > 2000)
	    groundspeed = 0;
	  if (groundspeed < 3.6)
	    groundspeed = 0;

	  if (mydebug)
	    g_print ("\nTime: %f", secs);
	}
/*  display status line */
      if (posmode)
	display_status (_("Press middle mouse button for navigation"));

    }

/*    only if we have neither NMEA nor GARMIN, means no measured position */
  if (!haveNMEA)
    {
/*  display status line */
     display_status (_("No GPS data"));

      return TRUE;
    }

/*  this is the NMEA reading part. data comes from port 2222 served by gpsd */
  FD_ZERO (&readmask);
  FD_SET (sock, &readmask);
  timeout.tv_sec = 0;
  timeout.tv_usec = 100000;
  if (select (FD_SETSIZE, &readmask, NULL, NULL, &timeout) < 0)
    {
      perror ("select() call");
    }
  if (FD_ISSET (sock, &readmask))
    {
      if ((e = read (sock, buffer, 2000)) < 0)
	perror ("read from gpsd connection");
      buffer[e] = 0;
      if ((bigp + e) < MAXBIG)
	{
	  if (mydebug)
	    g_print ("\n!!bigp:%d, e: %d!!", bigp, e);
	  g_strlcat (big, buffer, MAXBIG);
	  if (mydebug)
	    g_print (", strlen big:%d", strlen (big));
	  bigp += e;
	  bigpGSA = bigpRME = bigpGSV = bigpGGA = bigp;

	  for (i = bigp; i > lastp; i--)
	    {
	      if (big[i] == '$')
		{
/*  collect string for position data $GPRMC */
		  if ((big[i + 3] == 'R') && (big[i + 4] == 'M')
		      && (big[i + 5] == 'C'))
		    {
		      found = 0;
		      if (debug)
			g_print ("\n found #RMC#");
		      for (j = i; j <= bigp; j++)
			if (big[j] == 13)
			  {
			    found = j;
			    break;
			  }
		      if (found != 0)
			{
			  strncpy (tok, (big + i), found - i);
			  tok[found - i] = 0;
			  lastp = found;
			  timeoutcount = 0;
/*  we have the $GPRMC string completed, now parse it */
			  if (checksum (tok) == TRUE)
			    convertRMC (tok);
/*  display the position and map in the statusline */
			  if (havepos)
			    {
			      if (posmode)
				display_status (_
						("Press middle mouse button for navigation"));
			      else
				display_status (nmeamodeandport);
			    }
			  else
			    display_status (_
					    ("Not enough satellites in view!"));
			}
		    }

		}
	    }

/*  collect string for satellite data $GPGSV */

	  for (i = bigpGSV; i > lastpGSV; i--)
	    {
	      if (big[i] == '$')
		{

		  if ((big[i + 3] == 'G') && (big[i + 4] == 'S')
		      && (big[i + 5] == 'V'))
		    {
		      foundGSV = 0;
		      if (debug)
			g_print ("\n found #GSV#, bigpGSV: %d", bigpGSV);
		      for (j = i; j <= bigpGSV; j++)
			if (big[j] == 13)
			  {
			    foundGSV = j;
			    break;
			  }
		      if (foundGSV != 0)
			{
			  gint lenstr;
			  lenstr = foundGSV - i;
			  if ((lenstr) > 200)
			    {
			      g_print
				("\nError in line %d, foundGSV=%d,i=%d, diff=%d\n",
				 __LINE__, foundGSV, i, lenstr);
			      lenstr = 200;
			    }
			  if (i > foundGSV)
			    {
			      g_print
				("\nError in line %d, foundGSV=%d,i=%d, diff=%d\n",
				 __LINE__, foundGSV, i, lenstr);
			      lenstr = 0;
			    }
			  if (lenstr < 0)
			    {
			      g_print
				("\nError in line %d, foundGSV=%d,i=%d, lenstr=%d\n",
				 __LINE__, foundGSV, i, lenstr);
			      lenstr = 0;
			    }
			  if (lenstr != 0)
			    {
			      strncpy (tok, (big + i), lenstr);
			      tok[lenstr] = 0;

			      if (checksum (tok) == TRUE)
				{
				  if ((convertGSV (tok)) == TRUE)
				    lastpGSV = foundGSV;
				}
			    }
			}
		    }
		}
	    }


/*  collect string for altitude from  $GPGGA if available*/

	  for (i = bigpGGA; i > lastpGGA; i--)
	    {
	      if (big[i] == '$')
		{

		  if ((big[i + 3] == 'G') && (big[i + 4] == 'G')
		      && (big[i + 5] == 'A'))
		    {
		      foundGGA = 0;
		      if (debug)
			g_print ("\n found #GGA#");
		      timeoutcount = 0;

		      for (j = i; j <= bigpGGA; j++)
			if (big[j] == 13)
			  {
			    foundGGA = j;
			    break;
			  }
		      if (foundGGA != 0)
			{
			  gint lenstr;
			  lenstr = foundGGA - i;
			  if ((lenstr) > 200)
			    {
			      g_print
				("\nError in line %d, foundGGA=%d,i=%d, diff=%d\n",
				 __LINE__, foundGGA, i, lenstr);
			      lenstr = 200;
			    }
			  if (i > foundGGA)
			    {
			      g_print
				("\nError in line %d, foundGGA=%d,i=%d, diff=%d\n",
				 __LINE__, foundGGA, i, lenstr);
			      lenstr = 0;
			    }
			  if (lenstr != 0)
			    {
			      strncpy (tok, (big + i), lenstr);
			      tok[lenstr] = 0;
			      lastpGGA = foundGGA;

			      if (checksum (tok) == TRUE)
				convertGGA (tok);
			      if (havepos)
				{
				  if (posmode)
				    display_status (_
						    ("Press middle mouse button for navigation"));
				  else
				    display_status (nmeamodeandport);
				}
			      else
				display_status (_
						("Not enough satellites in view!"));

			    }
			}
		    }
		}
	    }

/*  collect string for precision from  $PGRME if available*/

	  for (i = bigpRME; i > lastpRME; i--)
	    {
	      if (big[i] == '$')
		{

		  if ((big[i + 1] == 'P') && (big[i + 2] == 'G')
		      && (big[i + 3] == 'R') && (big[i + 4] == 'M')
		      && (big[i + 5] == 'E'))
		    {
		      foundRME = 0;
		      if (debug)
			g_print ("\n found #RME#");
		      for (j = i; j <= bigpRME; j++)
			if (big[j] == 13)
			  {
			    foundRME = j;
			    break;
			  }
		      if (foundRME != 0)
			{
			  gint lenstr;
			  lenstr = foundRME - i;
			  if ((lenstr) > 200)
			    {
			      g_print
				("\nError in line %d, foundRME=%d,i=%d, diff=%d\n",
				 __LINE__, foundRME, i, lenstr);
			      lenstr = 200;
			    }
			  if (i > foundRME)
			    {
			      g_print
				("\nError in line %d, foundRME=%d,i=%d, diff=%d\n",
				 __LINE__, foundRME, i, lenstr);
			      lenstr = 0;
			    }
			  if (lenstr != 0)
			    {
			      strncpy (tok, (big + i), lenstr);
			      tok[lenstr] = 0;
			      lastpRME = foundRME;

			      if (checksum (tok) == TRUE)
				convertRME (tok);
			    }
			}
		    }
		}
	    }

/*  collect string for precision from  $GPGSA if available*/

	  for (i = bigpGSA; i > lastpGSA; i--)
	    {
	      if (big[i] == '$')
		{

		  if ((big[i + 1] == 'G') && (big[i + 2] == 'P')
		      && (big[i + 3] == 'G') && (big[i + 4] == 'S')
		      && (big[i + 5] == 'A'))
		    {
		      foundGSA = 0;
		      if (debug)
			g_print ("\n found #GSA#");
		      for (j = i; j <= bigpGSA; j++)
			if (big[j] == 13)
			  {
			    foundGSA = j;
			    break;
			  }
		      if (foundGSA != 0)
			{
			  gint lenstr;
			  lenstr = foundGSA - i;
			  if ((lenstr) > 200)
			    {
			      g_print
				("\nError in line %d, foundGSA=%d,i=%d, diff=%d\n",
				 __LINE__, foundGSA, i, lenstr);
			      lenstr = 200;
			    }
			  if (i > foundGSA)
			    {
			      g_print
				("\nError in line %d, foundGSA=%d,i=%d, diff=%d\n",
				 __LINE__, foundGSA, i, lenstr);
			      lenstr = 0;
			    }
			  if (lenstr != 0)
			    {
			      strncpy (tok, (big + i), lenstr);
			      tok[lenstr] = 0;
			      lastpGSA = foundGSA;

			      if (checksum (tok) == TRUE)
				convertGSA (tok);
			    }
			}
		    }
		}
	    }



	  if (mydebug)
	    g_print ("\nsize:%d lastp: %d \n%s", e, lastp, buffer);

	}
      else
	{
	  lastp = lastpGGA = lastpGSV = lastpRME = lastpGSA = 0;
	  bigp = e;
	  g_strlcpy (big, buffer, MAXBIG);
	}

    }
  else
    {
      timeoutcount++;
    }

  return (TRUE);
}


/*  test if we need to load another map */
void
testnewmap ()
{
  long long best = 1000000000LL;
  long long bestmap = 9999999999LL;
  gdouble bestscale = 1000000000.0, fact;
  gint i, skip;
  gchar buf[200], mappath[500];

  if (posmode)
    {
      current_long = posmode_x;
      current_lat = posmode_y;
    }
  else
    {
      gdouble d;
/*  test for new route point */
      if (strcmp (targetname, "     "))
	{
	  if (routemode)
	    d =
	      calcdist ((routelist + routepointer)->longitude,
			(routelist + routepointer)->lat);
	  else
	    d = calcdist (target_long, target_lat);

	  if (d < routenearest)
	    {
	      routenearest = d;
	    }
/* 	  g_print */
/* 	    ("\nroutepointer: %d d: %.1f routenearest: %.1f routereach: %0.3f", */
/* 	     routepointer, d, routenearest, ROUTEREACH); */
	  if ((d <= ROUTEREACH) || (d > (ROUTEREACHFACT * routenearest))
	      || forcenextroutepoint)
	    {
	      forcenextroutepoint = FALSE;
	      if ((routepointer != (routeitems - 1)) && (routemode))
		{
		  routenearest = 9999999999.0;
		  routepointer++;
/* let's say the waypoint description */
		  g_strlcpy (mappath, homedir, sizeof (mappath));
		  g_strlcat (mappath, activewpfile, sizeof (mappath));
		  saytargettext (mappath, targetname);

		  setroutetarget (NULL, -1);
		}
	      else
		{
/*  route endpoint reached */
		  if (saytarget)
		    {
		      gtk_label_set_text (GTK_LABEL (targetlabel), targetname);
		      createroute = FALSE;
		      routemode = FALSE;
		      saytarget = FALSE;
		      routepointer = routeitems = 0;
		      switch (voicelang)
			{
			case english:
			  g_snprintf (buf, sizeof (buf),
				      "You reached the target %s",
				      targetname);
			  break;
			case spanish:
			  g_snprintf (buf, sizeof (buf),
				      "usted ha llegado a %s", targetname);
			  break;
			case german:
			  g_snprintf (buf, sizeof (buf),
				      "Sie haben das Ziel %s erreicht",
				      targetname);
			}
		      speech_out_speek (buf);
/* let's say the waypoint description */
		      g_strlcpy (mappath, homedir, sizeof (mappath));
		      g_strlcat (mappath, activewpfile, sizeof (mappath));
		      saytargettext (mappath, targetname);
		    }
		}
	    }
	}
    }

//  calcxy (&posx, &posy, current_long, current_lat, zoom);

  for (i = 0; i < nrmaps; i++)
    {
      skip = TRUE;
      if (displaymap_map && (maps + i)->type == 0)
         skip = FALSE;
      if (displaymap_top && (maps + i)->type == 1)
         skip = FALSE;
      if (displaymap_osm && (maps + i)->type == 2)
         skip = FALSE;

      if (skip)
	continue;

      if(current_long > (maps + i)->lon_min && current_long < (maps + i)->lon_max)
        {
          if(current_lat > (maps + i)->lat_min && current_lat < (maps + i)->lat_max)
            {
	      if (scaleprefered)
		{
		  if (scalewanted > (maps + i)->scale)
		    fact = (gdouble) scalewanted / (maps + i)->scale;
		  else
		    fact = (maps + i)->scale / (gdouble) scalewanted;

		  if (fact < bestscale)
		    {
                      bestscale = fact;
                      bestmap = i;
/* 			bestcentereddist = centereddist; */
		    }
		}
	      else		/* autobestmap */
		{
		  if ((maps + i)->scale < best)
		    {
                      bestmap = i;
                      best = (maps + i)->scale;
		    }
		}
            }
        }
    }

  if (bestmap != 9999999999LL)
    {
      g_strlcpy (mapfilename, (maps + bestmap)->filename,
		 sizeof (mapfilename));
      if ((strcmp (oldfilename, mapfilename)) != 0)
	{
	  g_strlcpy (oldfilename, mapfilename, sizeof (oldfilename));
	  if (debug)
	    g_print ("\nNew map: %s\n", mapfilename);
	  pixelfact = (maps + bestmap)->scale / PIXELFACT;
	  zero_long = (maps + bestmap)->longitude;
	  zero_lat = (maps + bestmap)->lat;
	  mapscale = (maps + bestmap)->scale;
	  xoff = yoff = 0;
	  if (nrmaps > 0)
	    loadmap (mapfilename);
	}
    }
  else
    {
      if (((strcmp (oldfilename, mapfilename)) != 0) && (havedefaultmap))
	{
	  g_strlcpy (oldfilename, mapfilename, sizeof (oldfilename));
	  g_strlcpy (mapfilename, "top_GPSWORLD.jpg", sizeof (mapfilename));
	  pixelfact = 88226037.0 / PIXELFACT;
	  zero_long = 0;
	  zero_lat = 0;
	  mapscale = 88226037;
	  xoff = yoff = 0;
	  loadmap (mapfilename);
	}
    }

}

/*  set the target in routemode */
void
setroutetarget (GtkWidget * widget, gint datum)
{
  gchar buf[1000], buf2[1000], str[200], *tn;

  if (datum != -1)
    routepointer = datum;

  routenearest = 9999999;
  g_strlcpy (targetname, (routelist + routepointer)->name,
	     sizeof (targetname));
  target_lat = (routelist + routepointer)->lat;
  target_long = (routelist + routepointer)->longitude;
  g_snprintf (str, sizeof (str), "%s[%d/%d]", targetname,
	      routepointer + 1, routeitems);
  gtk_label_set_text (GTK_LABEL (targetlabel), str);
  tn = g_strdelimit (targetname, "_", ' ');
  g_strlcpy (buf2, "", sizeof (buf2));
  if (tn[0] == '*')
    {
      g_strlcpy (buf2, "das mobile Ziel ", sizeof (buf2));
      g_strlcat (buf2, (tn + 1), sizeof (buf2));
    }
  else
    g_strlcat (buf2, tn, sizeof (buf2));

  switch (voicelang)
    {
    case english:
      g_snprintf (buf, sizeof (buf), "New target is %s", buf2);
      break;
    case spanish:
      g_snprintf (buf, sizeof (buf), "Destinacin definida: %s", buf2);
      break;
    case german:
      g_snprintf (buf, sizeof (buf), "Neues Ziel ist %s ", buf2);
    }
  speech_out_speek (buf);
  speechcount = 0;
  g_strlcpy (oldangle, "XXX", sizeof (oldangle));
  saytarget = TRUE;
}


gint
posmodeoff_cb (GtkWidget * widget, guint * datum)
{
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (posbt), FALSE);
  return FALSE;
}

gint
lighton (void)
{
  disableisnight = TRUE;
/*   nighttimer = gtk_timeout_add (30000, (GtkFunction) lightoff, 0); */

/*   gtk_widget_restore_default_style(mainwindow); */
  return TRUE;
}

gint
tripreset ()
{

  tripodometer = tripavspeed = triptime = tripmaxspeed = triptmp = 0.0;
  tripavspeedcount = 0;
  trip_lat = current_lat;
  trip_long = current_long;
  triptime = time (NULL);

  return TRUE;
}

/* map_koord.txt is in mappath! */
gint
testconfig_cb (GtkWidget * widget, guint * datum)
{
#ifdef MAKETHISTEST
  gint i;
  for (i = 0; i < nrmaps; i++)
    {
      if ((strncmp ((maps + i)->filename, "map_", 4)))
	if ((strncmp ((maps + i)->filename, "top_", 4)))
          if ((strncmp ((maps + i)->filename, "osm_", 4)))
            {
             GString *error;
             error = g_string_new (NULL);
             g_string_printf (error, "\n%s%d\n%s", _("Error in line "), i + 1,
                              _
                              ("I have found filenames in map_koord.txt which are\n"
                               "not map_* or top_* or osm_* files. Please rename them and change the entries\n"
                               "in map_koord.txt.  Use map_* for Expedia street maps, top_* for topographical\n"
                               "maps and osm_* for OpenStreetMap maps.  Otherwise, the maps will not be displayed!"));
             error_popup ((gpointer *) error->str);
             g_string_free (error, TRUE);
             messageshown = TRUE;
             return FALSE;
            }
    }
#endif

  tripreset ();
  gtk_timeout_add (TRIPMETERTIMEOUT * 1000, (GtkFunction) dotripmeter, NULL);

  return FALSE;
}

gint
watchwp_cb (GtkWidget * widget, guint * datum)
{
  gint angle, i, radarnear;
  gdouble d;
  gchar buf[400], lname[200], l2name[200];
  gdouble ldist = 9999.0, l2dist = 9999.0;
  gdouble tx, ty, lastbearing;

/*  calculate new earth radius */
  earthr = calcR (current_lat);

  foundradar = FALSE;
  radarnear = FALSE;


  for (i = 0; i < maxwp; i++)
    {
/*  test for radar */
      if (((wayp + i)->action) == 1)
	{
	  d = calcdist2 ((wayp + i)->longitude, (wayp + i)->lat);
	  if (d < 0.6)
	    {
	      lastbearing = radarbearing;
	      tx = -current_long + (wayp + i)->longitude;
	      ty = -current_lat + (wayp + i)->lat;
	      radarbearing = atan (tx / ty);
	      if (!finite (radarbearing))
		radarbearing = lastbearing;

	      if (ty < 0)
		radarbearing = M_PI + radarbearing;
	      radarbearing -= direction;
	      if (radarbearing >= (2 * M_PI))
		radarbearing -= 2 * M_PI;
	      if (radarbearing < 0)
		radarbearing += 2 * M_PI;
	      if (radarbearing < 0)
		radarbearing += 2 * M_PI;
	      angle = radarbearing * 180.0 / M_PI;

	      if ((angle < 40) || (angle > 320))
		{
		  foundradar = TRUE;
		  if (d < ldist)
		    {
		      ldist = d;
		      g_strlcpy (lname, (wayp + i)->name, sizeof (lname));
		    }
		  if (d < 0.2)
		    {
		      foundradar = TRUE;
		      radarnear = TRUE;
		      if (d < l2dist)
			{
			  l2dist = d;
			  g_strlcpy (l2name, (wayp + i)->name,
				     sizeof (l2name));
			}
		    }
		}

	    }

	}
    }
  if (!foundradar)
    {
      g_strlcpy (lastradar, "----", sizeof (lastradar));
      g_strlcpy (lastradar2, "----", sizeof (lastradar2));
    }
  else
    {
      if ((strcmp (lname, lastradar)) != 0)
	{
	  g_strlcpy (lastradar, lname, sizeof (lastradar));
	  switch (voicelang)
	    {
	    case english:
	      g_snprintf (buf, sizeof (buf),
			  "Danger, Danger, Radar in %d meters, Your speed is %d",
			  (int) (ldist * 1000.0), (int) groundspeed);
	      break;
	    case spanish:
	      g_snprintf (buf, sizeof (buf),
			  "Atencin Atencin, control de  velocidad en %d metros, Su velocidad es %d",
			  (int) (ldist * 1000.0), (int) groundspeed);
	      break;
	    case german:
	      g_snprintf (buf, sizeof (buf),
			  "Achtung, Achtung, Radar in %d metern, Ihre Geschwindigkeit ist %d",
			  (int) (ldist * 1000.0), (int) groundspeed);
	    }
	  if (displaytext != NULL)
	    free (displaytext);
	  displaytext = strdup (buf + 10);
	  displaytext = g_strdelimit (displaytext, "\n", ' ');
	  displaytext = g_strdelimit (displaytext, "\")", ' ');

	  do_display_dsc = TRUE;
	  textcount = 0;

	  speech_out_speek (buf);
	}

      if (radarnear)
	if ((strcmp (l2name, lastradar2)) != 0)
	  {
	    g_strlcpy (lastradar2, l2name, sizeof (lastradar2));
	    switch (voicelang)
	      {
	      case english:
		g_snprintf (buf, sizeof (buf),
			    "Information, Radar in %d meters",
			    (int) (ldist * 1000.0));
		break;
	      case spanish:
		g_snprintf (buf, sizeof (buf),
			    "Informacin, control de  velocidad en %d metros",
			    (int) (ldist * 1000.0));
		break;
	      case german:
		g_snprintf (buf, sizeof (buf),
			    "Information, Radar in %d meter",
			    (int) (ldist * 1000.0));
	      }
	    speech_out_speek (buf);
	  }

    }

  return TRUE;
}

void
checkinput (gchar * text)
{
  if ((strstr (text, "'")) != NULL)
    mintodecimal (text);
}

void
decimaltomin (gchar * text, gint islat)
{
  gint grad, min, minus = FALSE;
  gdouble dec, rest, minf, sec;
  dec = g_strtod (text, NULL);
  if (dec < 0)
    {
      minus = TRUE;
      dec *= -1.0;
    }
  grad = dec;
  rest = dec - grad;

  minf = (60.0 * rest);
  min = minf;
  rest = minf - min;
  sec = 60.0 * rest;
#if PREFER_MinDec
  /* Hack alert: there should be a 3-way lat/lon format selection in the GUI */
  if (islat)
    g_snprintf (text, 100, "%d%s%.3f'%c", grad, gradsym, minf,
		(minus) ? 'S' : 'N');
  else
    g_snprintf (text, 100, "%d%s%.3f'%c", grad, gradsym, minf,
		(minus) ? 'W' : 'E');
#else
  if (islat)
    g_snprintf (text, 100, "%d%s%.2d'%05.2f''%c", grad, gradsym,
		min, sec, (minus) ? 'S' : 'N');
  else
    g_snprintf (text, 100, "%d%s%.2d'%05.2f''%c", grad, gradsym,
		min, sec, (minus) ? 'W' : 'E');
#endif

}

void
mintodecimal (gchar * text)
{
  gint grad, minus = FALSE;
  gdouble sec;
  gint min;
  gdouble dec;
  gchar s2;
  gint rc;

  /*
   * Handle either DMS or MinDec formats
   */
  rc = sscanf (text, "%d\xc2\xb0%d'%lf''%c", &grad, &min, &sec, &s2);
  if (rc == 4)
    {
      /*   g_strdelimit (s1, ",", '.'); */
      /*   sscanf(s1,"%f",&sec); */
      dec = grad + min / 60.0 + sec / 3600.0;
    }
  else
    {
      gdouble fmin;
      rc = sscanf (text, "%d\xc2\xb0%lf'%c", &grad, &fmin, &s2);
      if (rc != 3)
	{
	  /* TODO: handle bad format gracefully */
	}
      dec = grad + fmin / 60.0;
    }
  if (s2 == 'W')
    minus = TRUE;
  if (s2 == 'S')
    minus = TRUE;
  if (minus)
    dec *= -1.0;
  g_snprintf (text, 100, "%.6f", dec);
/*   g_print ("%s\n", text); */
}

/*  display upper status line */
void
display_status2 ()
{
  gchar s2[100], buf[200], mf[50];
  gint h, m;
  gdouble secs, v;
  secs = g_timer_elapsed (disttimer, 0);
  h = hours;
  m = minutes;
  if (secs >= 300.0)
    {
      g_timer_stop (disttimer);
      g_timer_start (disttimer);
      v = 3600.0 * (olddist - dist) / secs;
      h = dist / v;
      m = 60 * (dist / v - h);
      if (mydebug)
	g_print ("\nsecs: %.0fs,v:%.0f,h:%d,m:%d", secs, v, h, m);
      if ((m < 0) || (h > 99))
	{
	  h = 99;
	  m = 99;
	}
      olddist = dist;
      hours = h;
      minutes = m;
      if (!muteflag)
	if (hours < 99)
	  {
	    switch (voicelang)
	      {
	      case english:
		if (hours > 0)
		  g_snprintf (buf, sizeof (buf),
			      "Arrival in approximatly %d hours and %d minutes",
			      hours, minutes);
		else
		  g_snprintf (buf, sizeof (buf),
			      "Arrival in approximatly %d minutes", minutes);
		break;
	      case spanish:
		if (hours > 0)
		  g_snprintf (buf, sizeof (buf),
			      "Llegada en %d horas y %d minutos",
			      hours, minutes);
		else
		  g_snprintf (buf, sizeof (buf), "Llegada en %d minutos",
			      minutes);
		break;
	      case german:
		if (hours > 0)
		  {
		    if (hours == 1)
		      g_snprintf (buf, sizeof (buf),
				  "Ankunft in circa einer Stunde und %d minuten",
				  minutes);
		    else
		      g_snprintf (buf, sizeof (buf),
				  "Ankunft in circa %d Stunden und %d minuten",
				  hours, minutes);
		  }
		else
		  g_snprintf (buf, sizeof (buf),
			      "Ankunft in zirca %d minuten", minutes);
		speech_out_speek (buf);
	      }
	  }

    }

  if(havepos)
    {
     if (minsecmode)
       {
        g_snprintf (s2, sizeof (s2), "%8.5f", current_lat);
        decimaltomin (s2, 1);
       }
     else
       {
        g_snprintf (s2, sizeof (s2), "%8.5f", fabs (current_lat));
        if (current_lat >= 0)
           g_strlcat (s2, " N", sizeof (s2));
        else
           g_strlcat (s2, " S", sizeof (s2));
       }
     gtk_label_set_text (GTK_LABEL (l1), s2);
    }
  else
     gtk_label_set_text (GTK_LABEL (l1), _("n/a"));

  if(havepos)
    {
     if (minsecmode)
       {
        g_snprintf (s2, sizeof (s2), "%8.5f", current_long);
        decimaltomin (s2, 0);
       }
     else
       {
        g_snprintf (s2, sizeof (s2), "%8.5f", fabs (current_long));
        if (current_long >= 0)
           g_strlcat (s2, " E", sizeof (s2));
        else
           g_strlcat (s2, " W", sizeof (s2));
       }
     gtk_label_set_text (GTK_LABEL (l2), s2);
    }
  else
     gtk_label_set_text (GTK_LABEL (l2), _("n/a"));

  strncpy (mf, mapfilename, 18);
  mf[17] = 0;
  gtk_label_set_text (GTK_LABEL (l3), mf);
  g_snprintf (s2, sizeof (s2), "1:%ld", mapscale);
  gtk_label_set_text (GTK_LABEL (l4), s2);

  if(havepos)
    {
     g_snprintf (s2, sizeof (s2), "%3.0f%s", direction * 180.0 / M_PI, gradsym);
     gtk_label_set_text (GTK_LABEL (l5), s2);
    }
  else
     gtk_label_set_text (GTK_LABEL (l5), _("n/a"));

  if(havepos)
    {
     bearing = angle_to_destination - direction;
     if (bearing < 0)
	bearing += 2 * M_PI;
     if (bearing > (2 * M_PI))
	bearing -= 2 * M_PI;

     g_snprintf (s2, sizeof (s2), "%3.0f%s", bearing * 180.0 / M_PI, gradsym);
     gtk_label_set_text (GTK_LABEL (l6), s2);
    }
  else
     gtk_label_set_text (GTK_LABEL (l6), _("n/a"));

  if (scaleprefered)
    g_snprintf (s2, sizeof (s2), "1:%d", scalewanted);
  else
    g_snprintf (s2, sizeof (s2), _("Auto"));
  gtk_label_set_text (GTK_LABEL (l8), s2);
  if (debug)
    {
      if (havepos)
	g_print ("\n***Position: %f %f***\n", current_lat, current_long);
      else
	g_print ("\n***no valid Position:\n");
    }

  gtk_label_set_text (GTK_LABEL (l7), loctime);
}


/* draw the marker on the map */
gint
drawmarker_cb (GtkWidget * widget, guint * datum)
{
  if ((!disableisnight))
    {
      if (((nightmode == 1) || ((nightmode == 2) && isnight))
	  && (!alreadynightmode))
	{
	  gtk_widget_modify_bg (mainwindow, GTK_STATE_NORMAL, &nightcolor);
	  alreadydaymode = FALSE;
	  alreadynightmode = TRUE;
	  if (debug)
	    fprintf (stderr, "setting to night view\n");
	}
    }
  if (((nightmode == 0) || disableisnight)
      && (!alreadydaymode))
    {
      gtk_widget_modify_bg (mainwindow, GTK_STATE_NORMAL, &defaultcolor);
      if (debug)
	fprintf (stderr, "setting to daylight view\n");
      alreadydaymode = TRUE;
      alreadynightmode = FALSE;
    }


/*  we test if we have to load a new map because we are outside 
the currently loaded map */
  testnewmap ();
/*   g_print("\ndrawmarker_cb %d",drawmarkercounter++); */
  exposed = FALSE;
/* The position calculation is made in expose_cb() */
  gtk_widget_draw (drawing_area, NULL);	/* this  calls expose handler */
  if (!exposed)
    expose_cb (NULL, 0);
  expose_compass (NULL, 0);

  return TRUE;
}

/* Master agent */
gint
masteragent_cb (GtkWidget * widget, guint * datum)
{
  gchar mappath[400];
  gint f;
  struct stat buf;
  gchar buffer[200];

  if (needtosave)
    writeconfig ();


/* Check for changed map_koord.txt and reload if changed */
  g_strlcpy (mappath, mapdir, sizeof (mappath));
  g_strlcat (mappath, "map_koord.txt", sizeof (mappath));

  f = stat (mappath, &buf);
  if (buf.st_mtime != maptxtstamp)
    {
      loadmapconfig ();
      g_print ("\n%s reloaded\n", "map_koord.txt");
      maptxtstamp = buf.st_mtime;
    }

  if (needreloadmapconfig)
    loadmapconfig ();

  testifnight ();

  if (!didrootcheck)
    if (getuid () == 0)
      {
	g_snprintf (buffer, sizeof (buffer),
		    "<span  weight=\"bold\">%s</span>\n%s", _("Warning!"),
		    _("You should not start GpsDrive as user root!!!"));
	error_popup (buffer);
	didrootcheck = TRUE;
      }

/* Check for changed way.txt and reload if changed */
  g_strlcpy (mappath, homedir, sizeof (mappath));

  g_strlcat (mappath, activewpfile, sizeof (mappath));

  f = stat (mappath, &buf);
  if (buf.st_mtime != waytxtstamp)
    {
      loadwaypoints ();
      iszoomed = FALSE;
      g_print ("\n%s reloaded\n", activewpfile);
    }
  if (tracknr > (tracklimit - 100))
    {
      g_print ("tracklimit: %ld", tracklimit);
      track = g_renew (GdkSegment, track, tracklimit + 10000);
      tracklimit += 10000;
    }
  if (trackcoordnr > (trackcoordlimit - 100))
    {
      trackcoord =
	g_renew (trackcoordstruct, trackcoord, trackcoordlimit + 10000);
      trackcoordlimit += 10000;
    }



  return TRUE;
}

/* draw track on image */
gint
storetrack_cb (GtkWidget * widget, guint * datum)
{
  gint i;
  time_t t;

/*    if (posmode) */
/*      return TRUE; */
  if (posmode)
    i = 1;
  else
    i = 2;

/*    g_print ("\nHavepos: %d", havepos); */
  if (!havepos || posmode /*  ||((!simmode &&haveposcount<3)) */ )	/* we have no valid position */
    {
      (trackcoord + trackcoordnr)->longi = 1001.0;
      (trackcoord + trackcoordnr)->lat = 1001.0;
      (trackcoord + trackcoordnr)->alt = 1001.0;
    }
  else
    {
      (trackcoord + trackcoordnr)->longi = current_long;
      (trackcoord + trackcoordnr)->lat = current_lat;
      (trackcoord + trackcoordnr)->alt = altitude;
    }

  time (&t);
  (trackcoord + trackcoordnr)->unixtime = t;

/*  The double storage seems to be silly, but I have to use  */
/*  gdk_draw_segments instead of gdk_draw_lines.   */
/*  gkd_draw_lines is dog slow because of a gdk-bug. */

  if (tracknr == 0)
    {
      if ((trackcoord + trackcoordnr)->longi < 1000.0)
	{
	  (track + tracknr)->x1 = posx;
	  (track + tracknr)->y1 = posy;
	  tracknr++;
	}
    }
  else
    {
      if ((trackcoord + trackcoordnr)->longi < 1000.0)
	{
	  if ((posx != (track + tracknr - 1)->x2)
	      || (posy != (track + tracknr - 1)->y2))
	    {
	      (track + tracknr)->x1 = (track + tracknr - 1)->x2 = posx;
	      (track + tracknr)->y1 = (track + tracknr - 1)->y2 = posy;
	      tracknr += 1;
	    }
	}
      else
	tracknr = tracknr & ((glong) - 2);
    }

  trackcoordnr++;

  return TRUE;
}

int
symboltype (char *ic)
{
  gint symbol=0;
  gchar icon[80];

  g_strlcpy (icon, ic, sizeof (icon));
  g_strup (icon);

  if ((strcmp (icon, "REST")) == 0)
    symbol = 1;
  else if ((strcmp (icon, "MCDONALDS")) == 0)
    symbol = 2;
  else if ((strcmp (icon, "HOTEL")) == 0)
    symbol = 3;
  else if ((strcmp (icon, "BURGERKING")) == 0)
    symbol = 4;
  else if ((strcmp (icon, "SHOP")) == 0)
    symbol = 5;
  else if ((strcmp (icon, "MONU")) == 0)
    symbol = 6;
  else if ((strcmp (icon, "NIGHTCLUB")) == 0)
    symbol = 7;
  else if ((strcmp (icon, "SPEEDTRAP")) == 0)
    symbol = 8;
  else if ((strcmp (icon, "AIRPORT")) == 0)
    symbol = 9;
  else if ((strcmp (icon, "GOLF")) == 0)
    symbol = 10;
  else if ((strcmp (icon, "GASSTATION")) == 0)
    symbol = 11;
  else if ((strcmp (icon, "CAFE")) == 0)
    symbol = 12;
  else if ((strcmp (icon, "GEOCACHE")) == 0)
    symbol = 13;

  return symbol;
}

int
drawicon (gint posxdest, gint posydest, gint symbol)
{
  if (symbol == 0)
    return 0;

  if ((posxdest >= 0) && (posxdest < SCREEN_X))
    {

      if ((posydest >= 0) && (posydest < SCREEN_Y))
	{
	  gdk_draw_pixbuf (drawable, kontext, iconpixbuf[symbol - 1],
			   0, 0,
			   posxdest - 6,
			   posydest - 6, 12, 12, GDK_RGB_DITHER_NONE, 0, 0);
	}
    }

  return symbol;
}


gint
expose_sats_cb (GtkWidget * widget, guint * datum)
{
  gint k, i, yabs, h, j, l;
  gchar t[10], buf[300], txt[10];
#define SATX 5
/*  draw satellite level (field strength) only in NMEA modus*/

  if (haveNMEA && gtk_notebook_get_current_page(GTK_NOTEBOOK (mainnotebook))==3)
    {
      gdk_gc_set_foreground (kontext, &lcd);

      gdk_draw_rectangle (drawable_sats1, kontext, 1, 3, 0, PSIZE + 2,
			  PSIZE + 5);
      gdk_draw_rectangle (drawable_sats2, kontext, 1, 3, 0, PSIZE + 2,
			  PSIZE + 5);
      gdk_gc_set_line_attributes (kontext, 1, 0, 0, 0);
      gdk_gc_set_foreground (kontext, &black);
      gdk_draw_rectangle (drawable_sats1, kontext, 0, 3, 0, PSIZE + 2,
			  PSIZE + 5);
      gdk_draw_rectangle (drawable_sats2, kontext, 0, 3, 0, PSIZE + 2,
			  PSIZE + 5);

      gdk_gc_set_foreground (kontext, &lcd);

      /* if (!satposmode) */
	{
	  if (havepos)
	    gdk_gc_set_foreground (kontext, &green);
	  else
	    gdk_gc_set_foreground (kontext, &red);
	  gdk_gc_set_line_attributes (kontext, 2, 0, 0, 0);
	  for (i = 3; i < (PSIZE + 5); i += 3)
	    gdk_draw_line (drawable_sats1, kontext, 4, i, PSIZE + 4, i);


	  gdk_gc_set_foreground (kontext, &lcd2);
	  gdk_gc_set_line_attributes (kontext, 5, 0, 0, 0);
	  k = 0;
	  for (i = 0; i < 16; i++)
	    {
	      if (i > 5)
		yabs = 2 + PSIZE;
	      else
		yabs = 1 + PSIZE / 2;
	      h = PSIZE / 2 - 2;
	      gdk_draw_line (drawable_sats1, kontext, 6 + 7 * k + SATX, yabs,
			     6 + 7 * k + SATX, yabs - h);
	      k++;
	      if (k > 5)
		k = 0;
	    }
	}
      if (satfix == 1)		/* normal Fix */
	gdk_gc_set_foreground (kontext, &black);
      else
	{
	  if (satfix == 0)	/* no Fix */
	    gdk_gc_set_foreground (kontext, &textback);
	  else			/* Differntial Fix */
	    gdk_gc_set_foreground (kontext, &blue);
	}
      j = k = 0;
#define DEG2RAD M_PI/180.0
      /* if (satposmode) */
	{
	  gdk_gc_set_line_attributes (kontext, 1, 0, 0, 0);
	  gdk_gc_set_foreground (kontext, &lcd2);
	  gdk_draw_arc (drawable_sats2, kontext, 0, 4,
			4, PSIZE, PSIZE, 105 * 64, 330 * 64);
	  gdk_draw_arc (drawable_sats2, kontext, 0, 5 + PSIZE / 4,
			4 + PSIZE / 4, PSIZE / 2, PSIZE / 2, 0, 360 * 64);

	  gdk_gc_set_foreground (kontext, &grey);
	  {
	    /* prints in pango */
	    PangoFontDescription *pfd;
	    PangoLayout *wplabellayout;
	    gint width;

	    wplabellayout =
	      gtk_widget_create_pango_layout (drawing_sats2, "N");
//KCFX  
            pfd = pango_font_description_from_string ("Sans 7");
	    pango_layout_set_font_description (wplabellayout, pfd);

	    gdk_draw_layout_with_colors (drawable_sats2, kontext,
					 0 + (PSIZE) / 2, -2, wplabellayout,
					 &grey, NULL);
	    pango_layout_get_pixel_size (wplabellayout, &width, NULL);
/* 	    printf ("\nw: %d", width);  */
	    if (wplabellayout != NULL)
	      g_object_unref (G_OBJECT (wplabellayout));
	    /* freeing PangoFontDescription, cause it has been copied by prev. call */
	    pango_font_description_free (pfd);

	  }

	  gdk_gc_set_foreground (kontext, &lcd2);

	}

      for (i = 0; i < MAXSATS; i++)
	if (satlistdisp[i][0] != 0)
	  {
	    if ((satlistdisp[i][1] > 30) && (printoutsats))
	      g_print ("%d %d\n", satlistdisp[i][3], satlistdisp[i][2]);
	    /* if (satposmode) */
	      {
		gint x, y;
		gdouble el, az;
		el = (90.0 - satlistdisp[i][2]);
		az = satlistdisp[i][3] * DEG2RAD;

		x = (PSIZE / 2) + sin (az) * (el / 90.0) * (PSIZE / 2);
		y = (PSIZE / 2) - cos (az) * (el / 90.0) * (PSIZE / 2);
		l = (satlistdisp[i][1] / 6);
		if (l > 7)
		  l = 7;
		switch (l & 7)
		  {
		  case 0:
		  case 1:
		    gdk_gc_set_foreground (kontext, &textback);
		    break;
		  case 2:
		  case 3:
		    gdk_gc_set_foreground (kontext, &red);
		    break;
		  case 4:
		  case 5:
		  case 6:
		    gdk_gc_set_foreground (kontext, &yellow);
		    break;
		  case 7:
		    gdk_gc_set_foreground (kontext, &green2);
		    break;
		  }
		gdk_draw_arc (drawable_sats2, kontext, 1, 2 + x,
			      2 + y, 5, 5, 0, 360 * 64);

	      }
              /* else */
	      {
		if (j > 5)
		  yabs = PSIZE + 2;
		else
		  yabs = 1 + PSIZE / 2;
		h = satlistdisp[i][1] - 30;
		if (h < 0)
		  h = 1;
		if (h > 19)
		  h = 19;
		gdk_draw_line (drawable_sats1, kontext, 6 + 7 * k + SATX, yabs,
			       6 + 7 * k + SATX,
			       yabs - (PSIZE / 2) * h / (PSIZE / 2 - 5));
		k++;
		if (k > 5)
		  k = 0;
		j++;
	      }
	  }
      newsatslevel = FALSE;
      g_snprintf (txt, sizeof (txt), "%d/%d", numsats, satsavail);
      gtk_label_set_text (GTK_LABEL (satslabel1), txt);

      if ((precision > 0.0) && (satfix != 0))
	{
	  if (milesflag || nauticflag)
	    g_snprintf (t, sizeof (t), "%.1f ft", precision * 3.2808399);
	  else
	    g_snprintf (t, sizeof (t), "%.1f m", precision);
	}
      else
	g_snprintf (t, sizeof (t), "n/a");

      gtk_label_set_text (GTK_LABEL (satslabel2), t);
      if ((gsaprecision > 0.0) && (satfix != 0))
	{
	  if (milesflag || nauticflag)
	    g_snprintf (t, sizeof (t), "%.1f ft", gsaprecision * 3.2808399);
	  else
	    g_snprintf (t, sizeof (t), "%.1f m", gsaprecision);
	}
      else
	g_snprintf (t, sizeof (t), "n/a");
      gtk_label_set_text (GTK_LABEL (satslabel3), t);

      g_strlcpy (buf, "", sizeof (buf));
      if (debug)
	g_print ("\nSatfix: %d", satfix);
      if (satfix != oldsatfix)
	{
	  if (satfix == 2)
	    {
	      switch (voicelang)
		{
		case english:
		  g_snprintf (buf, sizeof (buf),
			      "Differential GPS signal found");
		  break;
		case spanish:
		  g_snprintf (buf, sizeof (buf), "Destinacin definida: ");
		  break;
		case german:
		  g_snprintf (buf, sizeof (buf),
			      "Ein differenzielles GPS Signal wurde gefunden");
		}
	    }
	  else if ((satfix == 1) && (oldsatfix == 2))
	    {
	      switch (voicelang)
		{
		case english:
		  g_snprintf (buf, sizeof (buf),
			      "No differential GPS signal detected");
		  break;
		case spanish:
		  g_snprintf (buf, sizeof (buf),
			      "No differential GPS signal detected ");
		  break;
		case german:
		  g_snprintf (buf, sizeof (buf),
			      "Kein differenzielles GPS Signal vorhanden");
		}
	    }

	  if (satfix == 0)
	    {
	      switch (voicelang)
		{
		case english:
		  g_snprintf (buf, sizeof (buf), "No sufficent GPS signal");
		  break;
		case spanish:
		  g_snprintf (buf, sizeof (buf),
			      "No sufficent GPS signal detected ");
		  break;
		case german:
		  g_snprintf (buf, sizeof (buf),
			      "Kein ausreichendes GPS Signal vorhanden");
		}
	    }
	  if (satfix == 1)
	    {
	      switch (voicelang)
		{
		case english:
		  g_snprintf (buf, sizeof (buf), "GPS signal good");
		  break;
		case spanish:
		  g_snprintf (buf, sizeof (buf), "GPS signal bueno ");
		  break;
		case german:
		  g_snprintf (buf, sizeof (buf),
			      "Gutes GPS Signal vorhanden");
		}
	    }

	  oldsatfix = satfix;
	  if (!muteflag && sound_gps)
	    speech_out_speek (buf);
	}
    }

  return TRUE;
}


void drawwp(void)
{
  gint posxdest, posydest;
  gint k, k2, i, shownwp = 0;
  gchar txt[200];

/*  draw waypoints */
      for (i = 0; i < maxwp; i++)
	{
         posxdest=(wayp + i)->xpos;
         posydest=(wayp + i)->ypos;

	  if ((posxdest >= 0) && (posxdest < SCREEN_X)
	      && (shownwp < MAXSHOWNWP))
	    {
	      if ((posydest >= 0) && (posydest < SCREEN_Y))
		{
		  shownwp++;

                  gdk_gc_set_line_attributes (kontext, 2, 0, 0, 0);

		  g_strlcpy (txt, (wayp + i)->name, sizeof (txt));

                  if ((drawicon (posxdest, posydest, (wayp + i)->symbol)) == 0)
		    {
/*  draw + sign at destination */
		      gdk_gc_set_foreground (kontext, &red);
		      gdk_draw_line (drawable, kontext, posxdest + 1,
				     posydest + 1 - 5, posxdest + 1,
				     posydest + 1 + 5);
		      gdk_draw_line (drawable, kontext, posxdest + 1 + 5,
				     posydest + 1, posxdest + 1 - 5,
				     posydest + 1);
		    }

		  {
		    /* prints in pango */
		    PangoFontDescription *pfd;
		    PangoLayout *wplabellayout;
		    gint width, height;
		    gchar *tn;

		    gdk_gc_set_foreground (kontext, &darkgrey);
		    gdk_gc_set_function (kontext, GDK_AND);
		    tn = g_strdelimit (txt, "_", ' ');

		    wplabellayout =
		      gtk_widget_create_pango_layout (drawing_area, tn);
		    pfd = pango_font_description_from_string ("Sans 6");
		    pango_layout_set_font_description (wplabellayout, pfd);
		    pango_layout_get_pixel_size (wplabellayout, &width,
						 &height);
/* 		  printf("\nj: %d",height);    */
		    k = width + 4;
		    k2 = height;

		    if (wplabellayout != NULL)
		      g_object_unref (G_OBJECT (wplabellayout));
		    /* freeing PangoFontDescription, cause it has been copied by prev. call */
		    pango_font_description_free (pfd);

		  }
		  gdk_gc_set_function (kontext, GDK_COPY);

		  gdk_gc_set_function (kontext, GDK_AND);

		  gdk_gc_set_foreground (kontext, &textbacknew);
		  gdk_draw_rectangle (drawable, kontext, 1, posxdest + 8,
				      posydest - k2 / 2, k + 1, k2);
		  gdk_gc_set_function (kontext, GDK_COPY);
//		  gdk_gc_set_foreground (kontext, &black);
//		  gdk_gc_set_line_attributes (kontext, 1, 0, 0, 0);
//		  gdk_draw_rectangle (drawable, kontext, 0, posxdest + 9,
//				      posydest - k2 / 2 - 1, k + 2, k2);

/* 		  gdk_gc_set_foreground (kontext, &yellow);  */
		  {
		    /* prints in pango */
		    PangoFontDescription *pfd;
		    PangoLayout *wplabellayout;

		    wplabellayout =
		      gtk_widget_create_pango_layout (drawing_area, txt);
		    pfd = pango_font_description_from_string ("Sans 6");
		    pango_layout_set_font_description (wplabellayout, pfd);

		    gdk_draw_layout_with_colors (drawable, kontext,
						 posxdest + 10,
						 posydest - k2 / 2,
						 wplabellayout, &white, NULL);
		    if (wplabellayout != NULL)
		      g_object_unref (G_OBJECT (wplabellayout));
		    /* freeing PangoFontDescription, cause it has been copied by prev. call */
		    pango_font_description_free (pfd);

		  }

/* 		    gdk_draw_text (drawable, smalltextfont, kontext,
 * 				 posxdest + 13, posydest + 6, txt,
 * 				 strlen (txt));
 */
		}
	    }
	}
    }


void drawscale (void)
    {
      gint pixels;
      gint k, m, l;
      gchar txt[100];
      pixels = 141 / milesconv;
      m = mapscale / (20 * zoom);
      if (m < 1000)
	{
	  if (!nauticflag)
	    g_snprintf (txt, sizeof (txt), "%d%s", m,
			(milesflag) ? "yrds" : "m");
	  else
	    g_snprintf (txt, sizeof (txt), "%.3f%s", m / 1000.0,
			(milesflag) ? "mi" : ((metricflag) ? "km" : "nmi"));

	  if (!metricflag)
	    pixels = pixels * milesconv * 0.9144;
	}
      else
	g_snprintf (txt, sizeof (txt), "%.1f%s", m / 1000.0,
		    (milesflag) ? "mi" : ((metricflag) ? "km" : "nmi"));
/*       l =
 * 	(SCREEN_X - 20) - pixels + (pixels -
 * 				    gdk_text_width (smalltextfont, txt,
 * 						    strlen (txt))) / 2;
 */
      l = (SCREEN_X - 5) - pixels/2 - strlen (txt) * 4;

/*       if (debug) */
/* 	g_print ("%d\n", m); */

      gdk_gc_set_function (kontext, GDK_OR);
      gdk_gc_set_foreground (kontext, &textback);
      gdk_draw_rectangle (drawable, kontext, 1, (SCREEN_X - 15) - pixels,
			  SCREEN_Y - 25, pixels + 15, 25);
      gdk_gc_set_function (kontext, GDK_COPY);

      gdk_gc_set_foreground (kontext, &black);

/* 	  gdk_draw_text (drawable, smalltextfont, kontext, l, SCREEN_Y - 20, txt,
 * 		     strlen (txt));
 */
      {
	/* prints in pango */
	PangoFontDescription *pfd;
	PangoLayout *wplabellayout;

	wplabellayout = gtk_widget_create_pango_layout (drawing_area, txt);
//KCFX  
        pfd = pango_font_description_from_string ("Sans 8");
	pango_layout_set_font_description (wplabellayout, pfd);

	gdk_draw_layout_with_colors (drawable, kontext,
				     l, SCREEN_Y - 15,
				     wplabellayout, &black, NULL);
	if (wplabellayout != NULL)
	  g_object_unref (G_OBJECT (wplabellayout));
	/* freeing PangoFontDescription, cause it has been copied by prev. call */
	pango_font_description_free (pfd);

      }

      gdk_gc_set_line_attributes (kontext, 2, 0, 0, 0);
      gdk_draw_line (drawable, kontext, (SCREEN_X - 10) - pixels,
		     SCREEN_Y - 20 + 5, (SCREEN_X - 10), SCREEN_Y - 20 + 5);
      gdk_draw_line (drawable, kontext, (SCREEN_X - 10) - pixels,
		     SCREEN_Y - 20, (SCREEN_X - 10) - pixels,
		     SCREEN_Y - 20 + 10);
      gdk_draw_line (drawable, kontext, (SCREEN_X - 10),
		     SCREEN_Y - 20, (SCREEN_X - 10), SCREEN_Y - 20 + 10);

/*  draw zoom factor */
      g_snprintf (txt, sizeof (txt), "%dx", zoom);
/*       l = (SCREEN_X - 15) - gdk_text_width (textfont, txt, strlen (txt)) / 2;  */

      gdk_gc_set_function (kontext, GDK_OR);

      gdk_gc_set_foreground (kontext, &mygray);
      gdk_draw_rectangle (drawable, kontext, 1, 0, SCREEN_Y-16, 32, 16);
      gdk_gc_set_function (kontext, GDK_COPY);

      gdk_gc_set_foreground (kontext, &black);

/*       gdk_draw_text (drawable, textfont, kontext, l, 22, txt, strlen (txt));  */
      {
	/* prints in pango */
	PangoFontDescription *pfd;
	PangoLayout *wplabellayout;

	wplabellayout = gtk_widget_create_pango_layout (drawing_area, txt);
//KCFX  
        pfd = pango_font_description_from_string ("Sans 8");
	pango_layout_set_font_description (wplabellayout, pfd);

	gdk_draw_layout_with_colors (drawable, kontext,
				     5, SCREEN_Y-15, wplabellayout, &black, NULL);
	if (wplabellayout != NULL)
	  g_object_unref (G_OBJECT (wplabellayout));
	/* freeing PangoFontDescription, cause it has been copied by prev. call */
	pango_font_description_free (pfd);

      }

      if (savetrack)
	{
/* 	  k =
 * 	    gdk_text_width (smalltextfont, savetrackfn, strlen (savetrackfn));
 */
	  k = 100;
	  gdk_gc_set_foreground (kontext, &white);
	  gdk_draw_rectangle (drawable, kontext, 1, 10,
			      SCREEN_Y - 21, k + 3, 14);
	  gdk_gc_set_foreground (kontext, &red);
	  {
	    /* prints in pango */
	    PangoFontDescription *pfd;
	    PangoLayout *wplabellayout;

	    wplabellayout =
	      gtk_widget_create_pango_layout (drawing_area, savetrackfn);
//KCFX  
            pfd = pango_font_description_from_string ("Sans 7");
	    pango_layout_set_font_description (wplabellayout, pfd);

	    gdk_draw_layout_with_colors (drawable, kontext,
					 14, SCREEN_Y - 22,
					 wplabellayout, &red, NULL);
	    if (wplabellayout != NULL)
	      g_object_unref (G_OBJECT (wplabellayout));
	    /* freeing PangoFontDescription, cause it has been copied by prev. call */
	    pango_font_description_free (pfd);

	  }


/* 	  gdk_draw_text (drawable, smalltextfont, kontext,
 * 			 11, SCREEN_Y - 10, savetrackfn,
 * 			 strlen (savetrackfn));
 */

/*      gdk_draw_text (drawable, textfont, kontext, 10, */
/*  		   SCREEN_Y - 10, savetrackfn, strlen (savetrackfn)); */
	}
    }


void drawarrow(void)
{
  gint posxdest, posydest, posxmarker, posymarker;
  gdouble w;
  GdkPoint poly[16];
  int i;

#define PFSIZE 55
#define PFSIZE2 45

      if (posmode)
	{
	  gdk_gc_set_foreground (kontext, &blue);
	  gdk_gc_set_line_attributes (kontext, 4, 0, 0, 0);
	  gdk_draw_rectangle (drawable, kontext, 0, posx - 10,
			      posy - 10, 20, 20);
	}
      else if(havepos)
	{
/*  draw real position marker */

	  gdk_gc_set_foreground (kontext, &black);
	  gdk_gc_set_line_attributes (kontext, 3, 0, 0, 0);
	  gdk_draw_arc (drawable, kontext, 0, posx - 7, posy - 7, 14,
			14, 0, 360 * 64);
/*  draw pointer to destination */

	  w = angle_to_destination + M_PI;

//	  poly[0].x = posx + (PFSIZE) / 2.3 * (cos (w + M_PI_2));
//	  poly[0].y = posy + (PFSIZE) / 2.3 * (sin (w + M_PI_2));
//	  poly[1].x = posx + (PFSIZE) / 9 * (cos (w + M_PI));
//	  poly[1].y = posy + (PFSIZE) / 9 * (sin (w + M_PI));
//	  poly[2].x = posx + PFSIZE / 10 * (cos (w + M_PI_2));
//	  poly[2].y = posy + PFSIZE / 10 * (sin (w + M_PI_2));
//	  poly[3].x = posx - (PFSIZE) / 9 * (cos (w + M_PI));
//	  poly[3].y = posy - (PFSIZE) / 9 * (sin (w + M_PI));
	  poly[0].x = 24 * (cos (w + M_PI_2));
	  poly[0].y = 24 * (sin (w + M_PI_2));
	  poly[1].x = 6 * (cos (w + M_PI));
	  poly[1].y = 6 * (sin (w + M_PI));
	  poly[2].x = poly[0].x/4;
	  poly[2].y = poly[0].y/4;
	  poly[3].x = - poly[1].x;
	  poly[3].y = - poly[1].y;
          for(i=0;i<=3;i++)
            {poly[i].x += posx; poly[i].y += posy;}
	  poly[4].x = poly[0].x;
	  poly[4].y = poly[0].y;
	  gdk_draw_polygon (drawable, kontext, 1, (GdkPoint *) poly, 5);

/*  draw pointer to direction */
	  gdk_gc_set_foreground (kontext, &red);
	  gdk_draw_arc (drawable, kontext, 0, posx + 2 - 7,
			posy + 2 - 7, 10, 10, 0, 360 * 64);
	  w = direction + M_PI;
//	  poly[0].x = posx + (PFSIZE2) / 2.3 * (cos (w + M_PI_2));
//	  poly[0].y = posy + (PFSIZE2) / 2.3 * (sin (w + M_PI_2));
//	  poly[1].x = posx + (PFSIZE2) / 9 * (cos (w + M_PI));
//	  poly[1].y = posy + (PFSIZE2) / 9 * (sin (w + M_PI));
//	  poly[2].x = posx + PFSIZE2 / 10 * (cos (w + M_PI_2));
//	  poly[2].y = posy + PFSIZE2 / 10 * (sin (w + M_PI_2));
//	  poly[3].x = posx - (PFSIZE2) / 9 * (cos (w + M_PI));
//	  poly[3].y = posy - (PFSIZE2) / 9 * (sin (w + M_PI));
	  poly[0].x = 20 * (cos (w + M_PI_2));
	  poly[0].y = 20 * (sin (w + M_PI_2));
	  poly[1].x = 5 * (cos (w + M_PI));
	  poly[1].y = 5 * (sin (w + M_PI));
	  poly[2].x = poly[0].x/4;
	  poly[2].y = poly[0].y/4;
	  poly[3].x = - poly[1].x;
	  poly[3].y = - poly[1].y;
          for(i=0;i<=3;i++)
            {poly[i].x += posx; poly[i].y += posy;}
	  poly[4].x = poly[0].x;
	  poly[4].y = poly[0].y;
	  gdk_draw_polygon (drawable, kontext, 0, (GdkPoint *) poly, 5);
	}
      if (markwaypoint)
	{
	  calcxy (&posxmarker, &posymarker, wplon, wplat, zoom);

	  gdk_gc_set_foreground (kontext, &green);
	  gdk_gc_set_line_attributes (kontext, 5, 0, 0, 0);
	  gdk_draw_arc (drawable, kontext, 0, posxmarker - 10,
			posymarker - 10, 20, 20, 0, 360 * 64);
	}
/*  If we are in position mode we set direction to zero to see where is the  */
/*  target  */
      if (posmode)
	direction = 0;

/*  now draw marker for destination point */

  calcxy (&posxdest, &posydest, target_long, target_lat, zoom);

  gdk_gc_set_line_attributes (kontext, 4, 0, 0, 0);

  if (crosstoogle)
    gdk_gc_set_foreground (kontext, &blue);
  else
    gdk_gc_set_foreground (kontext, &red);
  crosstoogle = !crosstoogle;
/*  draw + sign at destination */
  gdk_draw_line (drawable, kontext, posxdest + 1,
		 posydest + 1 - 10, posxdest + 1, posydest + 1 - 2);
  gdk_draw_line (drawable, kontext, posxdest + 1,
		 posydest + 1 + 2, posxdest + 1, posydest + 1 + 10);
  gdk_draw_line (drawable, kontext, posxdest + 1 + 10,
		 posydest + 1, posxdest + 1 + 2, posydest + 1);
  gdk_draw_line (drawable, kontext, posxdest + 1 - 2,
		 posydest + 1, posxdest + 1 - 10, posydest + 1);
}


/* draw the marker on the map */
gint
drawmarker (GtkWidget * widget, guint * datum)
{
  gchar s2[100];

/*    g_print("\nsimmode: %d, nmea %d garmin %d",simmode,haveNMEA,haveGARMIN); */

/* separate functions for profiling purposes */

  if(gtk_notebook_get_current_page(GTK_NOTEBOOK (mainnotebook))==0)
    {
     drawtracks ();

     if (wpflag)
        drawwp ();

     if (zoomscale)
        drawscale ();

     drawarrow ();
    }

/* display messages on map */
  display_dsc ();

/* Update status tab text */
  display_status2 ();

/*  if distance is less then 1 km show meters */
  if (milesflag)
    {
      if (dist <= 1.0)
	  g_snprintf (s2, sizeof (s2), "%.0f yrds", dist * 1760.0);
      else
	  if (dist <= 10.0)
	      g_snprintf (s2, sizeof (s2), "%.2f mi", dist);
	  else
	      g_snprintf (s2, sizeof (s2), "%.1f mi", dist);
    }
  if (metricflag)
    {
      if (dist <= 1.0)
	  g_snprintf (s2, sizeof (s2), "%.0f m", dist * 1000.0);
      else
	  if (dist <= 10.0)
	      g_snprintf (s2, sizeof (s2), "%.2f km", dist);
	  else
	      g_snprintf (s2, sizeof (s2), "%.1f km", dist);
    }
  if (nauticflag)
    {
      if (dist <= 1.0)
	  g_snprintf (s2, sizeof (s2), "%.3f nmi", dist);
      else
	  if (dist <= 10.0)
	      g_snprintf (s2, sizeof (s2), "%.2f nmi", dist);
	  else
	      g_snprintf (s2, sizeof (s2), "%.1f nmi", dist);
    }

  if(havepos)
     gtk_label_set_text (GTK_LABEL (distlabel), s2);
  else
     gtk_label_set_text (GTK_LABEL (distlabel), _("n/a"));

  if (milesflag)
    g_snprintf (s2, sizeof (s2), "%3.1f mi/h", groundspeed);
  if (metricflag)
    g_snprintf (s2, sizeof (s2), "%3.1f km/h", groundspeed);
  if (nauticflag)
    g_snprintf (s2, sizeof (s2), "%3.1f knots", groundspeed);

  if(havepos)
     gtk_label_set_text (GTK_LABEL (speedlabel), s2);
  else
     gtk_label_set_text (GTK_LABEL (speedlabel), _("n/a"));

  if (havealtitude)
    {
      if (milesflag || nauticflag)
	{
	  g_snprintf (s2, sizeof (s2), "%.0f ft",
		      altitude * 3.2808399 + normalnull);
	}
      else
	{
	  g_snprintf (s2, sizeof (s2), "%.0f m", altitude + normalnull);
	}
      gtk_label_set_text (GTK_LABEL (altilabel), s2);
    }
  else
     gtk_label_set_text (GTK_LABEL (altilabel), _("n/a"));

  if (newsatslevel)
    expose_sats_cb (NULL, 0);

/* force to say new direction */
  if (!strcmp (oldangle, "XXX"))
    speech_out_cb (NULL, 0);

  return (TRUE);
}


gint
expose_compass (GtkWidget * widget, guint * datum)
{
  static GdkGC *compasskontext = NULL;
  gint l, l2, j;
  gint line_count;
  gchar txt[10], txt2[10], *txtp;
  gdouble w, kurz;
  GdkPoint poly[16];
  static GdkPixbuf *compassimage = NULL;

  if(gtk_notebook_get_current_page(GTK_NOTEBOOK (mainnotebook))!=2)
     return TRUE;

/*   This string means North,East,South,West -- please translate the letters */
  g_strlcpy (txt2, _("NESW"), sizeof (txt2));

  txtp = txt2;

  if (compasskontext == NULL)
    compasskontext = gdk_gc_new (drawable_bearing);
  if (compassimage == NULL)
    compassimage = gdk_pixbuf_new_from_xpm_data ((const char **) compass_xpm);


  gdk_draw_pixbuf (drawable_bearing, compasskontext, compassimage, 0, 0,
		   0, 0, PSIZE, PSIZE, GDK_RGB_DITHER_NONE, 0, 0);

  if(havepos)
    {
  if (foundradar)
    {
      gdk_gc_set_foreground (kontext, &red);
      gdk_gc_set_line_attributes (kontext, 1, 0, 0, 0);
      w = radarbearing + M_PI;
      if (w < 0)
	w += 2 * M_PI;
      if (w > (2 * M_PI))
	w -= 2 * M_PI;
/*  	  g_print ("\nRadarbearing: %g w: %g", radarbearing, w); */
#define KURZW 1.2
      kurz = cos (KURZW);
      poly[0].x = PSIZE / 2 + PSIZE / 2.5 * cos (w);	/* x */
      poly[0].y = PSIZE / 2 + PSIZE / 2.5 * sin (w);	/* y */
      poly[1].x = PSIZE / 2 + PSIZE / 2 * cos (w + M_PI_2);
      poly[1].y = PSIZE / 2 + PSIZE / 2 * sin (w + M_PI_2);
      poly[2].x = PSIZE / 2 + PSIZE / 2.5 * cos (w + M_PI);
      poly[2].y = PSIZE / 2 + PSIZE / 2.5 * sin (w + M_PI);
      poly[3].x = PSIZE / 2 + PSIZE / 2 * kurz * cos (w + M_PI);
      poly[3].y = PSIZE / 2 + PSIZE / 2 * kurz * sin (w + M_PI);
      poly[4].x = PSIZE / 2 + PSIZE / 2 * cos (w + M_PI + KURZW);
      poly[4].y = PSIZE / 2 + PSIZE / 2 * sin (w + M_PI + KURZW);
      poly[5].x = PSIZE / 2 + PSIZE / 2 * cos (w + 2 * M_PI - KURZW);
      poly[5].y = PSIZE / 2 + PSIZE / 2 * sin (w + 2 * M_PI - KURZW);
      poly[6].x = PSIZE / 2 + PSIZE / 2 * kurz * cos (w);
      poly[6].y = PSIZE / 2 + PSIZE / 2 * kurz * sin (w);
      poly[7].x = poly[0].x;
      poly[7].y = poly[0].y;
      gdk_draw_polygon (drawable_bearing, kontext, 1, (GdkPoint *) poly, 8);
    }

  gdk_gc_set_foreground (kontext, &black);

/* compass */
//      /* added by zwerg (Daniel Wernle)
  w = -direction + M_PI;

  j = 0;

  for (line_count = 0; line_count < 12; line_count++)
    {
      gdk_gc_set_foreground (compasskontext, &red);

      if (!(line_count % 3))
	{
	  gdk_gc_set_line_attributes (compasskontext, 2, 0, 0, 0);


	  l = 10;
	  l2 = -18;
	  {
	    /* prints in pango */
	    PangoFontDescription *pfd;
	    PangoLayout *wplabellayout;
	    g_utf8_strncpy (txt, txtp, 1);
	    txtp = g_utf8_next_char (txtp);
	    wplabellayout =
	      gtk_widget_create_pango_layout (drawing_bearing, txt);
//KCFX  
            pfd = pango_font_description_from_string ("Sans 7");
	    pango_layout_set_font_description (wplabellayout, pfd);

	    gdk_draw_layout_with_colors (drawable_bearing, compasskontext,
					 (PSIZE / 2.0 +
					  (PSIZE) / 3.5 *
					  (cos (w + M_PI_2))) - l / 2,
					 (PSIZE / 2.0 +
					  (PSIZE) / 3.5 *
					  (sin (w + M_PI_2))) + l2 / 2,
					 wplabellayout, &black, NULL);
	    if (wplabellayout != NULL)
	      g_object_unref (G_OBJECT (wplabellayout));
	    /* freeing PangoFontDescription, cause it has been copied by prev. call */
	    pango_font_description_free (pfd);

	  }
	  gdk_gc_set_foreground (compasskontext, &red);
	}
      else
	{
	  gdk_gc_set_foreground (compasskontext, &black);
	  gdk_gc_set_line_attributes (compasskontext, 1, 0, 0, 0);
	}

/*       gdk_draw_line (drawable_bearing, compasskontext, */
/* 		     PSIZE / 2.0 + (PSIZE) / 2.75 * (cos (w + M_PI_2)), */
/* 		     PSIZE / 2.0 + (PSIZE) / 2.75 * (sin (w + M_PI_2)), */
/* 		     PSIZE / 2.0 + (PSIZE) / 2.0 * (cos (w + M_PI_2)), */
/* 		     PSIZE / 2.0 + (PSIZE) / 2.0 * (sin (w + M_PI_2))); */

      w = w + M_PI / 6.0;

    }

  w = bearing + M_PI;

#define TRIANGLEFACTOR 0.75
  gdk_gc_set_foreground (compasskontext, &black);

  gdk_gc_set_line_attributes (compasskontext, 1, 0, 0, 0);
/*   gdk_draw_arc (drawable_bearing, compasskontext, 0, 0, 0, PSIZE, PSIZE, */
/* 		0, 360 * 64); */

  poly[0].x = PSIZE / 2 + (PSIZE) / 2.3 * (cos (w + M_PI_2));
  poly[0].y = PSIZE / 2 + (PSIZE) / 2.3 * (sin (w + M_PI_2));
  poly[1].x = PSIZE / 2 + (PSIZE) / 9 * (cos (w + M_PI));
  poly[1].y = PSIZE / 2 + (PSIZE) / 9 * (sin (w + M_PI));
  poly[2].x = PSIZE / 2 + PSIZE / 10 * (cos (w + M_PI_2));
  poly[2].y = PSIZE / 2 + PSIZE / 10 * (sin (w + M_PI_2));
  poly[3].x = PSIZE / 2 - (PSIZE) / 9 * (cos (w + M_PI));
  poly[3].y = PSIZE / 2 - (PSIZE) / 9 * (sin (w + M_PI));
  poly[4].x = poly[0].x;
  poly[4].y = poly[0].y;

  gdk_gc_set_foreground (compasskontext, &black);
  gdk_gc_set_line_attributes (compasskontext, 2, 0, 0, 0);

  gdk_draw_polygon (drawable_bearing, compasskontext, 1,
		    (GdkPoint *) poly, 5);

  gdk_gc_set_foreground (kontext, &black);
    }

//  von Zwerg eingefgt ende

  return TRUE;
}

/* Copy Image from loaded map */
gint
expose_cb (GtkWidget * widget, guint * datum)
{
  gint x, y, oldxoff, oldyoff, xoffmax, yoffmax, ok, okcount, i;
  gdouble tx, ty, lastangle;
/*    g_print("\nexpose_cb %d",exposecounter++);   */

/*   fprintf (stderr, "lat: %f long: %f\n", current_lat, current_long); */
  if (exposed)
    return TRUE;

  errortextmode = FALSE;

/*  We don't need to draw anything if there is no map yet */
      if (!maploaded)
	{
	  display_status (_("No map available for this position!"));
/*        return TRUE; */
	}

      if (posmode)
	{
	  current_long = posmode_x;
	  current_lat = posmode_y;
	}


/*  get pos for current position */
      calcxy (&posx, &posy, current_long, current_lat, zoom);
/*  do this because calcxy already substracted xoff and yoff */
      posx = posx + xoff;
      posy = posy + yoff;
/*  Calculate Angle to destination */
      tx =
	(2 * R * M_PI / 360) * cos (M_PI * current_lat / 180.0) *
	(target_long - current_long);
      ty = (2 * R * M_PI / 360) * (target_lat - current_lat);
      lastangle = angle_to_destination;
      angle_to_destination = atan (tx / ty);
/*        g_print ("\ntx: %f, ty:%f angle_to_dest: %f", tx, ty, */
/*  	       angle_to_destination); */
      if (!finite (angle_to_destination))
	angle_to_destination = lastangle;
      else
	{
/*  correct the value to be < 2*PI */
	  if (ty < 0)
	    angle_to_destination = M_PI + angle_to_destination;
	  if (angle_to_destination >= (2 * M_PI))
	    angle_to_destination -= 2 * M_PI;
	  if (angle_to_destination < 0)
	    angle_to_destination += 2 * M_PI;
	}
      if (mydebug)
	g_print ("\nAngle_To_Destination: %.0f",
		 angle_to_destination * 180 / M_PI);

/*  Calculate distance to destination */
      dist = calcdist (target_long, target_lat);
/*  correct the shift of the map */
      oldxoff = xoff;
      oldyoff = yoff;
/*  now we test if the marker fits into the map and set the shift of the 
little SCREEN_XxSCREEN_Y region in relation to the real 1280x1024 map */
      okcount = 0;
      do
	{
	  ok = TRUE;
	  okcount++;
	  x = posx - xoff;
	  y = posy - yoff;

	  if (x < borderlimit)
	    xoff -= 2 * borderlimit;
	  if (x > (SCREEN_X - borderlimit))
	    xoff += 2 * borderlimit;
	  if (y < borderlimit)
	    yoff -= 2 * borderlimit;
	  if (y > (SCREEN_Y - borderlimit))
	    yoff += 2 * borderlimit;

	  if (x < borderlimit)
	    ok = FALSE;
	  if (x > (SCREEN_X - borderlimit))
	    ok = FALSE;
	  if (y < borderlimit)
	    ok = FALSE;
	  if (y > (SCREEN_Y - borderlimit))
	    ok = FALSE;
	  if (okcount > 20000)
	    {
	      g_print ("\nloop detected, please report!\n");
	      ok = TRUE;
	    }
	}
      while (!ok);

      xoffmax = (640 * zoom) - SCREEN_X_2;
      yoffmax = (512 * zoom) - SCREEN_Y_2;
      if (xoff > xoffmax)
	xoff = xoffmax;
      if (xoff < -xoffmax)
	xoff = -xoffmax;
      if (yoff > yoffmax)
	yoff = yoffmax;
      if (yoff < -yoffmax)
	yoff = -yoffmax;

/*       if ((xoff - 640) / zoom < -1280) */
/* 	xoff = -1280 * zoom + 640; */
/*       if ((xoff + 640) / zoom > 1280) */
/* 	xoff = 1280 * zoom - 640; */

/*       if ((yoff - 512) / zoom < -1024) */
/* 	yoff = -1024 * zoom + 512; */
/*       if ((yoff + 512) / zoom > 1024) */
/* 	yoff = 1024 * zoom - 512; */

/*  we only need to create a new region if the shift is not changed */
      if ((oldxoff != xoff) || (oldyoff != yoff))
	iszoomed = FALSE;

      if (mydebug)
	g_print ("\nx: %d  xoff: %d oldxoff: %d Zoom: %d xoffmax: %d\n", x,
		 xoff, oldxoff, zoom, xoffmax);
      if (mydebug)
	g_print ("\ny: %d  yoff: %d oldyoff: %d Zoom: %d yoffmax: %d\n", y,
		 yoff, oldyoff, zoom, yoffmax);
      posx = posx - xoff;
      posy = posy - yoff;

/*       if (scroll) */
/*       { */
/* 	  xoff=posx+640; */
/* 	  posx=320; */
/* 	  yoff=posy+512; */
/* 	  posx=256; */
/*       } */


/*  zoom from to 1280x1024 map to the SCREEN_XxSCREEN_Y region */
  if (!iszoomed)
    {
      rebuildtracklist ();

      if (tempimage == NULL)
	tempimage = gdk_pixbuf_new (GDK_COLORSPACE_RGB, 0, 8, 1280, 1024);

      if (maploaded)
	{
/* 	  g_print ("\nmap loaded, do gdk_pixbuf_scale\n");  */
	  gdk_pixbuf_scale (image, tempimage, 0, 0, 1280, 1024,
			    640 - xoff - 640 * zoom,
			    512 - yoff - 512 * zoom, zoom, zoom,
			    GDK_INTERP_BILINEAR);

/*       image=gdk_pixbuf_scale_simple(tempimage,640 - xoff - 640 * zoom,
 *   			  512 - yoff - 512 * zoom, 
 *   			  GDK_INTERP_BILINEAR);
 */

	}

      for (i = 0; i < maxwp; i++)
        {
          gint xpos, ypos;
	  calcxy (&xpos, &ypos, (wayp + i)->longitude, (wayp + i)->lat, zoom);
          (wayp + i)->xpos = xpos;
          (wayp + i)->ypos = ypos;
        }

      if (debug)
	g_print ("\nmap zoomed!\n");
      iszoomed = TRUE;
    }

  gdk_draw_pixbuf (drawable, kontext, tempimage,
		   640 - SCREEN_X_2,
		   512 - SCREEN_Y_2, 0, 0,
		   SCREEN_X, SCREEN_Y, GDK_RGB_DITHER_NONE, 0, 0);

  if ((!disableisnight))
    {
      if ((nightmode == 1) || ((nightmode == 2) && isnight))
	{
	  gdk_gc_set_function (kontext, GDK_AND);
	  gdk_gc_set_foreground (kontext, &nightcolor);
	  gdk_draw_rectangle (drawable, kontext, 1, 0, 0, SCREEN_X, SCREEN_Y);
	  gdk_gc_set_function (kontext, GDK_COPY);
	}
    }

  drawmarker (0, 0);

  gdk_draw_pixmap (drawing_area->window, kontext, drawable, 0,
		   0, 0, 0, SCREEN_X, SCREEN_Y);
  exposed = TRUE;

  return TRUE;
}


/*  open serial port or pty master or file for NMEA output */
FILE *
opennmea (const char *name)
{
  struct termios tios;
  FILE *const out = fopen (name, "w");
  if (out == NULL)
    {
      perror (_("can't open NMEA output file"));
      exit (1);
    }

  if (tcgetattr (fileno (out), &tios))
    return out;			/* not a terminal, oh well */

  tios.c_iflag = 0;
  tios.c_oflag = 0;
  tios.c_cflag = CS8 | CLOCAL;
  tios.c_lflag = 0;
  tios.c_cc[VMIN] = 1;
  tios.c_cc[VTIME] = 0;
  cfsetospeed (&tios, B4800);
  tcsetattr (fileno (out), TCSAFLUSH, &tios);
  return out;
}

void
write_nmea_line (const char *line)
{
  int checksum = 0;
  fprintf (nmeaout, "$%s*", line);
  while ('\0' != *line)
    checksum = checksum ^ *line++;
  fprintf (nmeaout, "%02X\r\n", checksum);
  fflush (nmeaout);
}

void
gen_nmea_coord (char *out)
{
  gdouble lat = fabs (current_lat), lon = fabs (current_long);
  g_snprintf (out, sizeof (out), ",%02d%07.5f,%c,%03d%07.5f,%c",
	      (int) floor (lat), 60 * (lat - floor (lat)),
	      (current_lat < 0 ? 'S' : 'N'),
	      (int) floor (lon), 60 * (lon - floor (lon)),
	      (current_long < 0 ? 'W' : 'E'));
}

gint
write_nmea_cb (GtkWidget * widget, guint * datum)
{
  char buffer[180];
  time_t now = time (NULL);
  struct tm *st = gmtime (&now);

  strftime (buffer, sizeof (buffer), "GPGGA,%H%M%S.000", st);
  gen_nmea_coord (buffer + strlen (buffer));
  g_strlcpy (buffer + strlen (buffer), ",1,00,0.0,,M,,,,0000",
	     sizeof (buffer) - strlen (buffer));
  write_nmea_line (buffer);

  g_strlcpy (buffer, "GPGLL", sizeof (buffer));
  gen_nmea_coord (buffer + strlen (buffer));
  strftime (buffer + strlen (buffer), 80, ",%H%M%S.000,A", st);
  write_nmea_line (buffer);

  strftime (buffer, sizeof (buffer), "GPRMC,%H%M%S.000,A", st);
  gen_nmea_coord (buffer + strlen (buffer));
  g_snprintf (buffer + strlen (buffer), sizeof (buffer), ",%.2f,%.2f",
	      groundspeed / milesconv / 1.852, direction * 180.0 / M_PI);
  strftime (buffer + strlen (buffer), 80, ",%d%m%y,,", st);
  write_nmea_line (buffer);

  g_snprintf (buffer, sizeof (buffer), "GPVTG,%.2f,T,,M,%.2f,N,%.2f,K",
	      direction * 180.0 / M_PI,
	      groundspeed / milesconv / 1.852, groundspeed / milesconv);
  write_nmea_line (buffer);

  return TRUE;
}


/*  We load the map */
void
loadmap (char *filename)
{
  gchar mappath[600];
  GdkPixbuf *limage;
  guchar *lpixels, *pixels;
  int i, j, k;

  if (maploaded)
    gdk_pixbuf_unref (image);

  maptype=0;
  if (!(strncmp (filename, "top_", 4)))
    maptype = 1;
  if (!(strncmp (filename, "osm_", 4)))
    maptype = 2;

  if ((strcmp (filename, "top_GPSWORLD.jpg")) == 0)
    {
      g_snprintf (mappath, sizeof (mappath), "%s/gpsdrive/%s", DATADIR,
		  "top_GPSWORLD.jpg");
      limage = gdk_pixbuf_new_from_file (mappath, NULL);
      if (limage == NULL)
	havedefaultmap = FALSE;
    }
  else
    {
      g_strlcpy (mappath, mapdir, sizeof (mappath));
      g_strlcat (mappath, filename, sizeof (mappath));
      limage = gdk_pixbuf_new_from_file (mappath, NULL);
    }

  if (limage == NULL)
    {
      GString *error;
      error = g_string_new (NULL);
      g_string_sprintf (error, "\n%s\n%s\n",
			_(" Mapfile could not be loaded:"), mappath);
      error_popup ((gpointer *) error->str);
      g_string_free (error, TRUE);
      maploaded = FALSE;
      return;
    }


  if (!gdk_pixbuf_get_has_alpha (limage))
    image = limage;
  else
    {
      image = gdk_pixbuf_new (GDK_COLORSPACE_RGB, 0, 8, 1280, 1024);
      if (image == NULL)
	{
	  fprintf (stderr,
		   "can't get image  gdk_pixbuf_new (GDK_COLORSPACE_RGB, 0, 8, 1280, 1024)\n");
	  exit (1);
	}
      lpixels = gdk_pixbuf_get_pixels (limage);
      pixels = gdk_pixbuf_get_pixels (image);
      if (pixels == NULL)
	{
	  fprintf (stderr,
		   "can't get pixels pixels = gdk_pixbuf_get_pixels (image);\n");
	  exit (1);
	}
      j = k = 0;
      for (i = 0; i < (1280 * 1024); i++)
	{
	  memcpy ((pixels + j), (lpixels + k), 3);
	  j += 3;
	  k += 4;
	}
      gdk_pixbuf_unref (limage);

    }

  expose_cb (NULL, NULL);
  iszoomed = FALSE;
/*        zoom = 1; */
  xoff = yoff = 0;
  rebuildtracklist ();
  if (!maploaded)
    display_status (_("Map found!"));

  maploaded = TRUE;
}


gint
zoom_cb (GtkWidget * widget, guint datum)
{

  if (iszoomed == FALSE)	/* needed to be sure the old zoom is made */
    return TRUE;
  iszoomed = FALSE;
  if (datum == 1)
    {
      if (zoom >= 64)
	{
	  iszoomed = TRUE;
	  return TRUE;
	}
      zoom *= 2;
      xoff *= 2;
      yoff *= 2;
    }
  else if(datum == 2)
    {
      if (zoom <= 1)
	{
	  zoom = 1;
	  iszoomed = TRUE;
	}
      else
	{
	  zoom /= 2;
	  xoff /= 2;
	  yoff /= 2;
	}
    }
  else
    {
     guint newzoom;

     switch(datum)
       {
       case 3: newzoom=1; break;
       case 4: newzoom=2; break;
       case 5: newzoom=4; break;
       case 6: newzoom=8; break;
       case 7: newzoom=16; break;
       case 8: newzoom=32; break;
       case 9: newzoom=64; break;
       default: newzoom=zoom;
       }

     if(zoom<newzoom)
       {
        zoom *= (newzoom/zoom);
        xoff *= (newzoom/zoom);
        yoff *= (newzoom/zoom);
       }
     if(zoom>newzoom)
       {
        zoom /= (zoom/newzoom);
        xoff /= (zoom/newzoom);
        yoff /= (zoom/newzoom);
       }
    }

  return TRUE;
}


gint
scalerbt_cb (GtkWidget * widget, guint datum)
{
  gint val, oldval, old2val;
  gchar oldfilename[200];

  g_strlcpy (oldfilename, mapfilename, sizeof (oldfilename));
  val = (GTK_ADJUSTMENT (adj)->value);
  old2val = val;

  do
    {
      oldval = val;
      if (datum == 1)
	{
	  gtk_adjustment_set_value (GTK_ADJUSTMENT (adj), val + 1);
	}
      else
	{
	  gtk_adjustment_set_value (GTK_ADJUSTMENT (adj), val - 1);
	}
      val = (GTK_ADJUSTMENT (adj)->value);

      testnewmap ();
    }
  while (((strcmp (oldfilename, mapfilename)) == 0) && (val != oldval));

  if ((strcmp (oldfilename, mapfilename)) == 0)
    val = old2val;
  gtk_adjustment_set_value (GTK_ADJUSTMENT (adj), val);
  expose_cb (NULL, 0);

  needtosave = TRUE;

  return TRUE;
}

/*  destroy sel_target window */
gint
sel_targetweg_cb (GtkWidget * widget, guint datum)
{
/*   gtk_timeout_remove (selwptimeout); */
  gtk_widget_destroy (GTK_WIDGET (gotowindow));
  setwpactive = FALSE;

  return FALSE;
}

/*  cancel sel_route window */
gint
sel_routecancel_cb (GtkWidget * widget, guint datum)
{
  gtk_widget_destroy (GTK_WIDGET (routewindow));

  gtk_label_set_text (GTK_LABEL (targetlabel), targetname);

  createroute = FALSE;
  routemode = FALSE;
  routepointer = routeitems = 0;
  gtk_widget_set_sensitive (create_route_button, TRUE);
  return FALSE;
}

/*  destroy sel_route window but continue routing*/
gint
sel_routeclose_cb (GtkWidget * widget, guint datum)
{
  gtk_widget_destroy (GTK_WIDGET (routewindow));
  gtk_widget_set_sensitive (create_route_button, TRUE);
  return FALSE;
}

gint
do_route_cb (GtkWidget * widget, guint datum)
{

  gtk_widget_destroy (GTK_WIDGET (routewindow));
  gtk_widget_set_sensitive (create_route_button, TRUE);
  createroute = FALSE;
  routemode = TRUE;
  setroutetarget (NULL, -1);
  return FALSE;
}

gint
wpfileselect_cb (GtkWidget * widget, guint datum)
{
  if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (setupfn[datum])))
    if ((strcmp (activewpfile, (names + datum)->n)))
      {
	g_strlcpy (activewpfile, (names + datum)->n, sizeof (activewpfile));
	if (debug)
	  g_print ("\nactivewpfile: %s", activewpfile);
	loadwaypoints ();
	iszoomed = FALSE;
      }
  needtosave = TRUE;
  return TRUE;
}


gint
setup_cb (GtkWidget * widget, guint datum)
{
  GtkWidget *notebook, *vbox, *cancel;
  GtkWidget *window = NULL;
  gint i;

  gtk_widget_set_sensitive (setupbt, FALSE);

  mainsetup ();
  infos ();
  trip ();

  window = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (window), _("GpsDrive Control"));
  gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);
  gtk_window_set_transient_for (GTK_WINDOW (window), GTK_WINDOW (mainwindow));

  cancel = gtk_button_new_from_stock (GTK_STOCK_CLOSE);
  GTK_WIDGET_SET_FLAGS (cancel, GTK_CAN_DEFAULT);
  gtk_window_set_default (GTK_WINDOW (window), cancel);
/*   GTK_WIDGET_SET_FLAGS (cancel, GTK_HAS_FOCUS); */


  gtk_signal_connect ((GTK_OBJECT (window)), "delete_event",
		      GTK_SIGNAL_FUNC (removesetutc), 0);
  gtk_signal_connect_object ((GTK_OBJECT (window)), "delete_event",
			     GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT (window));
  gtk_signal_connect ((GTK_OBJECT (window)), "destroy",
		      GTK_SIGNAL_FUNC (removesetutc), 0);
  gtk_signal_connect_object ((GTK_OBJECT (window)), "destroy",
			     GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT (window));



  gtk_signal_connect ((GTK_OBJECT (cancel)), "clicked",
		      GTK_SIGNAL_FUNC (removesetutc), 0);

  gtk_signal_connect_object ((GTK_OBJECT (cancel)), "clicked",
			     GTK_SIGNAL_FUNC (gtk_widget_destroy),
			     GTK_OBJECT (window));

  gtk_container_border_width (GTK_CONTAINER (window), 0);
  vbox = gtk_vbox_new (FALSE, 0);
/*     table = gtk_table_new(2,1,TRUE); */
/*   gtk_container_add (GTK_CONTAINER (window), vbox); */
  gtk_box_pack_start (GTK_BOX
		      (GTK_DIALOG (window)->vbox), vbox, TRUE, TRUE, 2);

  /* Create a new notebook, place the position of the tabs */
  settingsnotebook = notebook = gtk_notebook_new ();
  gtk_notebook_set_scrollable (GTK_NOTEBOOK (notebook), TRUE);
  gtk_notebook_set_tab_pos (GTK_NOTEBOOK (notebook), GTK_POS_TOP);
  gtk_notebook_set_show_border (GTK_NOTEBOOK (notebook), TRUE);
  gtk_notebook_popup_enable (GTK_NOTEBOOK (notebook));
/*     gtk_table_attach_defaults(GTK_TABLE(table), notebook, 0,1,0,1); */
  gtk_box_pack_start (GTK_BOX (vbox), notebook, TRUE, TRUE, 0);
/*   gtk_box_pack_start (GTK_BOX (vbox), cancel, FALSE, FALSE, 0); */
  gtk_box_pack_start (GTK_BOX
		      (GTK_DIALOG (window)->action_area),
		      cancel, TRUE, TRUE, 2);

  gtk_widget_show (notebook);
/*   g_print("\nmod_setupcounter: %d",mod_setupcounter); */
//KCFX
  for (i = 0; i <= mod_setupcounter; i++)
    {
      if (i > 4)
	setupfunction[i] ();

      gtk_widget_show_all (setupentry[i]);
      gtk_notebook_append_page (GTK_NOTEBOOK (notebook), setupentry[i],
				setupentrylabel[i]);
    }
  gtk_notebook_set_page (GTK_NOTEBOOK (notebook), lastnotebook);
  gtk_widget_show_all (window);

  return TRUE;
}



/*  switching between kilometers and miles */
gint
miles_cb (GtkWidget * widget, guint datum)
{
/*      1=miles, 2=metric, 3=nautic */
  switch (datum)
    {
    case 1:
      milesconv = KM2MILES;
      milesflag = TRUE;
      nauticflag = FALSE;
      metricflag = FALSE;
      break;
    case 2:
      milesconv = 1.0;
      milesflag = FALSE;
      nauticflag = FALSE;
      metricflag = TRUE;
      break;
    case 3:
      milesconv = KM2NAUTIC;
      milesflag = FALSE;
      nauticflag = TRUE;
      metricflag = FALSE;
      break;

    }
  needtosave = TRUE;

  return TRUE;
}

/*  switching nightmode */
gint
night_cb (GtkWidget * widget, guint datum)
{

  switch (datum)
    {
    case 0:
      nightmode = 0;
      break;
    case 1:
      nightmode = 1;
      break;
    case 2:
      nightmode = 2;
      break;

    }

  needtosave = TRUE;
  return TRUE;
}


/*  switching decimal or degree, minutes, seconds mode */
gint
minsec_cb (GtkWidget * widget, guint datum)
{
  minsecmode = !minsecmode;
  needtosave = TRUE;
  return TRUE;
}

gint
serialdev_cb (GtkWidget * widget, guint datum)
{
  G_CONST_RETURN gchar *s;

  s = g_strstrip ((char *) gtk_entry_get_text (GTK_ENTRY (serialbt)));
  g_strlcpy (serialdev, s, sizeof (serialdev));
  needtosave = TRUE;
  return TRUE;
}


gint
mapdir_cb (GtkWidget * widget, guint datum)
{
  G_CONST_RETURN gchar *s;

  s = g_strstrip ((char *) gtk_entry_get_text (GTK_ENTRY (mapdirbt)));
  g_strlcpy (mapdir, s, sizeof (mapdir));
  needtosave = TRUE;
  needreloadmapconfig = TRUE;
  gtk_timeout_add (2000, (GtkFunction) loadmapconfig, 0);
  return TRUE;
}


gint
maptoggle_cb (GtkWidget * widget, guint datum)
{
  displaymap_map = !displaymap_map;
  if (displaymap_map)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (maptogglebt), TRUE);
  else
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (maptogglebt), FALSE);
  needtosave = TRUE;
  return TRUE;
}

gint
dotripmeter (GtkWidget * widget, guint datum)
{
  gdouble d;

  d = calcdist (trip_long, trip_lat);
  trip_long = current_long;
  trip_lat = current_lat;
  if (!((d >= 0.0) && (d < (1000.0 * TRIPMETERTIMEOUT / 3600.0))))
    {
      fprintf (stderr,
	       _("\ndistance jump is more then 1000km/h speed, ignoring\n"));
      return TRUE;
    }
/* we want always have metric system stored */
  d /= milesconv;
  tripodometer += d;
  if (groundspeed * milesconv > tripmaxspeed)
    tripmaxspeed = groundspeed / milesconv;
  tripavspeedcount++;
  tripavspeed += groundspeed / milesconv;
  return TRUE;
}

gint
bestmap_cb (GtkWidget * widget, guint datum)
{
  if (datum == 1)
    scaleprefered = !scaleprefered;
  if (!scaleprefered)
    {
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (bestmapbt), TRUE);
      gtk_widget_set_sensitive (scalerrbt, FALSE);
      gtk_widget_set_sensitive (scalerlbt, FALSE);
      if (scaler)
	gtk_widget_set_sensitive (scaler, FALSE);
    }
  else
    {
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (bestmapbt), FALSE);
      gtk_widget_set_sensitive (scalerrbt, TRUE);
      gtk_widget_set_sensitive (scalerlbt, TRUE);
      if (scaler)
	gtk_widget_set_sensitive (scaler, TRUE);
    }
  needtosave = TRUE;
  return TRUE;
}

gint
savetrack_cb (GtkWidget * widget, guint datum)
{
  savetrack = !savetrack;
  if (savetrack)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (savetrackbt), TRUE);
  else
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (savetrackbt), FALSE);
  needtosave = TRUE;
  return TRUE;
}

gint
topotoggle_cb (GtkWidget * widget, guint datum)
{
  displaymap_top = !displaymap_top;
  if (displaymap_top)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (topotogglebt), TRUE);
  else
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (topotogglebt), FALSE);
  needtosave = TRUE;
  return TRUE;
}

gint
osmtoggle_cb (GtkWidget * widget, guint datum)
{
  displaymap_osm = !displaymap_osm;
  if (displaymap_osm)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (osmtogglebt), TRUE);
  else
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (osmtogglebt), FALSE);
  needtosave = TRUE;
  return TRUE;
}


gint
mute_cb (GtkWidget * widget, guint datum)
{
  muteflag = !muteflag;
  if (muteflag)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (mutebt), TRUE);
  else
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (mutebt), FALSE);
  needtosave = TRUE;
  return TRUE;
}

gint
track_cb (GtkWidget * widget, guint datum)
{
  trackflag = !trackflag;
  if (trackflag)
    {
      gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (trackbt), TRUE);
      rebuildtracklist ();
    }
  else
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (trackbt), FALSE);
  needtosave = TRUE;
  return TRUE;
}

gint
wp_cb (GtkWidget * widget, guint datum)
{
  wpflag = !wpflag;
  if (wpflag)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (wpbt), TRUE);
  else
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (wpbt), FALSE);
  needtosave = TRUE;
  return TRUE;
}

gint
pos_cb (GtkWidget * widget, guint datum)
{
  posmode = !posmode;
  if (posmode)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (posbt), TRUE);
  else
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (posbt), FALSE);
  posmode_x = current_long;
  posmode_y = current_lat;

  return TRUE;
}

/*  if a waypoint is selected set the target_* variables */
gint
setwp_cb (GtkWidget * widget, guint datum)
{
  gchar b[100], buf[1000], buf2[1000];
  gchar *p, *tn;
  p = b;

  deleteline = datum;
  if (dontsetwp)
    return TRUE;

  gtk_clist_get_text (GTK_CLIST (mylist), datum, 0, &p);
  if (createroute)
    {
/*        g_print ("\nroute: %s", p); */
      thisrouteline = atol (p) - 1;
      insertroutepoints ();
      return TRUE;
    }
  thisline = atol (p);
/*    g_print ("%d\n", thisline); */
  gtk_clist_get_text (GTK_CLIST (mylist), datum, 1, &p);
  g_strlcpy (targetname, p, sizeof (targetname));

  gtk_label_set_text (GTK_LABEL (targetlabel), targetname);
  gtk_clist_get_text (GTK_CLIST (mylist), datum, 2, &p);
  checkinput (p);
  target_lat = atof (p);
  gtk_clist_get_text (GTK_CLIST (mylist), datum, 3, &p);
  checkinput (p);
  target_long = atof (p);
/*    gtk_timeout_add (5000, (GtkFunction) sel_targetweg_cb, widget); */
  g_timer_stop (disttimer);
  g_timer_start (disttimer);
  olddist = dist;
/*   posmode = FALSE; */
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (posbt), FALSE);

  tn = g_strdelimit (targetname, "_", ' ');
  g_strlcpy (buf2, "", sizeof (buf2));
  if (tn[0] == '*')
    {
      g_strlcpy (buf2, "das mobile Ziel ", sizeof (buf2));
      g_strlcat (buf2, (tn + 1), sizeof (buf2));
    }
  else
    g_strlcat (buf2, tn, sizeof (buf2));

  switch (voicelang)
    {
    case english:
      g_snprintf (buf, sizeof (buf), "New target is %s", buf2);
      break;
    case spanish:
      g_snprintf (buf, sizeof (buf), "Destinacin definida: %s", buf2);
      break;
    case german:
      g_snprintf (buf, sizeof (buf), "Neues Ziel ist %s", buf2);
    }
  speech_out_speek (buf);
  saytarget = TRUE;
  routenearest = 9999999;

  return TRUE;
}

gint
delwp_cb (GtkWidget * widget, guint datum)
{
  gint i, j;
  gchar *p;

  i = deleteline;
  if (debug)
    g_print ("\nremove line %d", i);
  gtk_clist_get_text (GTK_CLIST (mylist), i, 0, &p);
  j = atol (p) - 1;
  gtk_clist_remove (GTK_CLIST (mylist), i);
  if (debug)
    g_print ("\nremove entry %d", j);

  for (i = j; i < (maxwp - 1); i++)
    *(wayp + i) = *(wayp + i + 1);
  maxwp--;
  savewaypoints ();
  gtk_clist_get_text (GTK_CLIST (mylist), deleteline, 0, &p);
  thisline = atol (p);

  return TRUE;
}

gint
jumpwp_cb (GtkWidget * widget, guint datum)
{
  gint i;
  gchar *p;

  i = deleteline;
  gtk_clist_get_text (GTK_CLIST (mylist), i, 2, &p);
  current_lat = atof (p);
  gtk_clist_get_text (GTK_CLIST (mylist), i, 3, &p);
  current_long = atof (p);

  if (!posmode)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (posbt), TRUE);
  reinsertwp_cb (NULL, 0);
  sel_targetweg_cb (NULL, 0);
  return TRUE;
}


/*  set reference point for map calibration */
gint
setrefpoint_cb (GtkWidget * widget, guint datum)
{
  gchar b[100];
  gchar *p;
  p = b;
  gtk_clist_get_text (GTK_CLIST (mylist), datum, 1, &p);
  gtk_entry_set_text (GTK_ENTRY (dltext4), p);
  gtk_clist_get_text (GTK_CLIST (mylist), datum, 2, &p);
  gtk_entry_set_text (GTK_ENTRY (dltext1), p);

  gtk_clist_get_text (GTK_CLIST (mylist), datum, 3, &p);
  gtk_entry_set_text (GTK_ENTRY (dltext2), p);

  return TRUE;
}



gint
scaler_cb (GtkAdjustment * adj, gdouble * datum)
{
  gchar s2[100];
  scalewanted = nlist[(gint) rint (adj->value)];
  g_snprintf (s2, sizeof (s2), "1:%d", scalewanted);
  gtk_label_set_text (GTK_LABEL (l8), s2);
  if (debug)
    g_print ("\nScaler: %d", scalewanted);
  needtosave = TRUE;

  return TRUE;
}

/*  Let user select a destination from the waypoint list */

gint
key_cb (GtkWidget * widget, GdkEventKey * event)
{
  gdouble lat, lon;
  gint x, y;
  GdkModifierType state;

/*    g_print ("\nevent:%x key:%c\n",event->keyval,event->keyval); */
  if ((toupper (event->keyval)) == 'X')
    {
      wplat = current_lat;
      wplon = current_long;
      addwaypoint_cb (NULL, NULL);
    }

// xxxxxxxxxxxxxxxxxxxxxxxxxxx

  if ((toupper (event->keyval)) == 'Y')
    {

      gdk_window_get_pointer (drawing_area->window, &x, &y, &state);

      calcxytopos (x, y, &lat, &lon, zoom);


/*  Add mouse position as waypoint */
      wplat = lat;
      wplon = lon;
      addwaypoint_cb (NULL, 0);


    }
// xxxxxxxxxxxxxxxxxxxxxxxxxx

  if (((toupper (event->keyval)) == 'J') && routemode)
    {
      forcenextroutepoint = TRUE;
    }

  if ((toupper (event->keyval)) == 'N')
    {
      if (nightmode != 0)
	{
/*  light on for 30 seconds  */
	  if (disableisnight == TRUE)
	    {
/* 	      gtk_timeout_remove (nighttimer); */
	      disableisnight = FALSE;
	    }
	  else
	    lighton ();
	}
    }

/*   From Russell Mirov: */
  if (event->keyval == 0xFF52)
     scalerbt_cb (NULL, 1);	/* RNM */
  if (event->keyval == 0xFF54)
     scalerbt_cb (NULL, 2);	/* RNM */

  return 0;
}

gint
mapclick_cb (GtkWidget * widget, GdkEventButton * event)
{
  gint x, y;
  gdouble lon, lat, vali;
  GdkModifierType state;

/*   printf("\n bin in mapclick\n"); */

  if (event->button)
    gdk_window_get_pointer (event->window, &x, &y, &state);
  else
    {
      x = event->x;
      y = event->y;
      state = event->state;
    }
  if (state == 0)
    return 0;
  calcxytopos (x, y, &lat, &lon, zoom);

/*        g_print ("\nstate: %x x:%d y:%d", state, x, y); */
      vali = (GTK_ADJUSTMENT (adj)->value);
/*  Left mouse button + shift key */
      if ((state & (GDK_BUTTON1_MASK | GDK_SHIFT_MASK)) ==
	  (GDK_BUTTON1_MASK | GDK_SHIFT_MASK))
	{
	  scalerbt_cb (NULL, 2);
	  return TRUE;
	}
/*  Add mouse position as waypoint */
/*  Left mouse button + control key */
      if ((state & (GDK_BUTTON1_MASK | GDK_CONTROL_MASK)) ==
	  (GDK_BUTTON1_MASK | GDK_CONTROL_MASK))
	{
	  wplat = lat;
	  wplon = lon;
	  addwaypoint_cb (NULL, 0);
	  return TRUE;
	}
/*  Add current position as waypoint */
/*  Right mouse button + control key */
      if ((state & (GDK_BUTTON3_MASK | GDK_CONTROL_MASK)) ==
	  (GDK_BUTTON3_MASK | GDK_CONTROL_MASK))
	{
	  wplat = current_lat;
	  wplon = current_long;

	  addwaypoint_cb (NULL, 0);
	  return TRUE;
	}
/*  Right mouse button + shift key */
      if ((state & (GDK_BUTTON3_MASK | GDK_SHIFT_MASK)) ==
	  (GDK_BUTTON3_MASK | GDK_SHIFT_MASK))
	{
	  scalerbt_cb (NULL, 1);
	  return TRUE;
	}

/*  Left mouse button */
      if ((state & GDK_BUTTON1_MASK) == GDK_BUTTON1_MASK)
	{
	  if (posmode)
	    {
	      posmode_x = lon;
	      posmode_y = lat;
	      rebuildtracklist ();
              gtk_timeout_add (10000, (GtkFunction) posmodeoff_cb, 0);
	    }
	}
/*  Middle mouse button */
      if ((state & GDK_BUTTON2_MASK) == GDK_BUTTON2_MASK)
	{
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (posbt), FALSE);

	  rebuildtracklist ();
	}
/*  Right mouse button */
      if ((state & GDK_BUTTON3_MASK) == GDK_BUTTON3_MASK)
	{
/* set  as target */
/* only if RIGHT mouse button clicked */
	  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (posbt), FALSE);
	  rebuildtracklist ();
	  g_strlcpy (targetname, _("SELECTED"), sizeof (targetname));
	  gtk_label_set_text (GTK_LABEL (targetlabel), targetname);
	  target_lat = lat;
	  target_long = lon;
	  g_timer_stop (disttimer);
	  g_timer_start (disttimer);
	  olddist = dist;
	}

/*    g_print ("\nx: %d, y: %d", x, y); */
  return TRUE;
}


gint
addwaypointchange_cb (GtkWidget * widget, guint datum)
{
  gchar *s;
  gdouble lo, la;

  s = g_strstrip ((char *) gtk_entry_get_text (GTK_ENTRY (addwaypoint1)));
  checkinput (s);
  lo = g_strtod (s, NULL);
  if ((lo > -181) && (lo < 181))
    wplon = lo;
  s = g_strstrip ((char *) gtk_entry_get_text (GTK_ENTRY (addwaypoint2)));
  checkinput (s);
  la = g_strtod (s, NULL);
  if ((la > -181) && (la < 181))
    wplat = la;

  return TRUE;
}

gint
addwaypoint (GtkWidget * widget, guint datum)
{
  gint i;
  G_CONST_RETURN gchar *s, *s2;

  s = gtk_entry_get_text (GTK_ENTRY (wptext1));
  s2 = gtk_entry_get_text (GTK_ENTRY (GTK_COMBO (wptext2)->entry));
  i = maxwp;
  (wayp + i)->lat = wplat;
  (wayp + i)->longitude = wplon;
  g_strdelimit ((char *) s, " ", '_');
/*  limit waypoint name to 20 chars */
  g_strlcpy ((wayp + i)->name, s, 40);
  (wayp + i)->name[20] = 0;
  g_strlcpy ((wayp + i)->typ, s2, 40);

  {
   gint xpos, ypos;
   calcxy (&xpos, &ypos, (wayp + i)->longitude, (wayp + i)->lat, zoom);
   (wayp + i)->xpos = xpos;
   (wayp + i)->ypos = ypos;
  }

  (wayp + i)->symbol=symboltype((wayp + i)->typ);

  maxwp++;
  if (maxwp >= wpsize)
    {
     wpsize += 1000;
     wayp = g_renew (wpstruct, wayp, wpsize);
    }
  savewaypoints ();
  gtk_widget_destroy (GTK_WIDGET (datum));
  markwaypoint = FALSE;
  return TRUE;
}

/*  destroy sel_target window */
gint
addwaypointdestroy_cb (GtkWidget * widget, guint datum)
{

  gtk_widget_destroy (GTK_WIDGET (addwaypointwindow));
  markwaypoint = FALSE;

  return FALSE;
}

gint
addwaypointbutton_cb (GtkWidget * widget, gpointer datum)
{
 wplat = current_lat;
 wplon = current_long;

 return addwaypoint_cb (widget, datum);
}

gint
addwaypoint_cb (GtkWidget * widget, gpointer datum)
{
  GtkWidget *window, *l1, *l2, *t1, *t2, *hbox3, *hbox4, *hbox5;
  GtkWidget *vbox, *hbox, *hbox2, *button, *button2, *label, *label2;
  gchar buff[40];
  GList *list = NULL;

  list = g_list_append (list, "Geocache");
  list = g_list_append (list, "Rest");
  list = g_list_append (list, "Mcdonalds");
  list = g_list_append (list, "Hotel");
  list = g_list_append (list, "BurgerKing");
  list = g_list_append (list, "Shop");
  list = g_list_append (list, "Monu");
  list = g_list_append (list, "Nightclub");
  list = g_list_append (list, "SpeedTrap");
  list = g_list_append (list, "Airport");
  list = g_list_append (list, "Golf");
  list = g_list_append (list, "GasStation");
  list = g_list_append (list, "Cafe");

  addwaypointwindow = window = gtk_dialog_new ();
  gtk_window_set_transient_for (GTK_WINDOW (window), GTK_WINDOW (mainwindow));
  gotowindow = window;
  markwaypoint = TRUE;

  gtk_window_set_modal (GTK_WINDOW (window), TRUE);
  gtk_window_set_title (GTK_WINDOW (window), _("Add waypoint name"));



  button = gtk_button_new_from_stock (GTK_STOCK_APPLY);
  button2 = gtk_button_new_from_stock (GTK_STOCK_CANCEL);

  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  GTK_WIDGET_SET_FLAGS (button2, GTK_CAN_DEFAULT);
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
		      GTK_SIGNAL_FUNC (addwaypoint), GTK_OBJECT (window));
  gtk_signal_connect (GTK_OBJECT (button2), "clicked",
		      GTK_SIGNAL_FUNC (addwaypointdestroy_cb), 0);
  gtk_signal_connect (GTK_OBJECT (window),
		      "delete_event",
		      GTK_SIGNAL_FUNC (addwaypointdestroy_cb), 0);

  vbox = gtk_vbox_new (TRUE, 2);
  gtk_box_pack_start (GTK_BOX
		      (GTK_DIALOG (window)->vbox), vbox, TRUE, TRUE, 2);

  hbox = gtk_hbox_new (TRUE, 2);
  hbox2 = gtk_hbox_new (TRUE, 2);
  gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 2);
  gtk_box_pack_start (GTK_BOX (hbox), button2, TRUE, TRUE, 2);

  addwaypoint1 = t1 = gtk_entry_new_with_max_length (20);
  g_snprintf (buff, sizeof (buff), "%.5f", wplon);
  if (minsecmode)
    decimaltomin (buff, 0);
  gtk_entry_set_text (GTK_ENTRY (t1), buff);
  l1 = gtk_label_new (_("Longitude"));
  addwaypoint2 = t2 = gtk_entry_new_with_max_length (20);
  g_snprintf (buff, sizeof (buff), "%.5f", wplat);
  if (minsecmode)
    decimaltomin (buff, 1);
  gtk_entry_set_text (GTK_ENTRY (t2), buff);
  l2 = gtk_label_new (_("Latitude"));

  gtk_signal_connect (GTK_OBJECT (t1),
		      "changed", GTK_SIGNAL_FUNC (addwaypointchange_cb),
		      (gpointer) 1);
  gtk_signal_connect (GTK_OBJECT (t2),
		      "changed", GTK_SIGNAL_FUNC (addwaypointchange_cb),
		      (gpointer) 2);

  hbox3 = gtk_hbox_new (TRUE, 2);
  hbox4 = gtk_hbox_new (TRUE, 2);
  hbox5 = gtk_hbox_new (TRUE, 2);

  gtk_box_pack_start (GTK_BOX (hbox3), l2, TRUE, TRUE, 2);
  gtk_box_pack_start (GTK_BOX (hbox3), t2, TRUE, TRUE, 2);
  gtk_box_pack_start (GTK_BOX (hbox4), l1, TRUE, TRUE, 2);
  gtk_box_pack_start (GTK_BOX (hbox4), t1, TRUE, TRUE, 2);
  gtk_box_pack_start (GTK_BOX (vbox), hbox3, TRUE, TRUE, 2);
  gtk_box_pack_start (GTK_BOX (vbox), hbox4, TRUE, TRUE, 2);


  wptext1 = gtk_entry_new ();
  label = gtk_label_new (_(" Waypoint name: "));
  gtk_window_set_default (GTK_WINDOW (window), button);
  gtk_window_set_focus (GTK_WINDOW (window), wptext1);

  gtk_box_pack_start (GTK_BOX (hbox2), label, TRUE, TRUE, 2);
  gtk_box_pack_start (GTK_BOX (hbox2), wptext1, TRUE, TRUE, 2);
  gtk_box_pack_start (GTK_BOX (vbox), hbox2, TRUE, TRUE, 2);


/*   wptext2 = gtk_entry_new (); */
  wptext2 = gtk_combo_new ();
  gtk_combo_set_popdown_strings (GTK_COMBO (wptext2), (GList *) list);

  label2 = gtk_label_new (_(" Waypoint type: "));

  gtk_box_pack_start (GTK_BOX (hbox5), label2, TRUE, TRUE, 2);
  gtk_box_pack_start (GTK_BOX (hbox5), wptext2, TRUE, TRUE, 2);
  gtk_box_pack_start (GTK_BOX (vbox), hbox5, TRUE, TRUE, 2);

/*   gtk_box_pack_start (GTK_BOX (vbox), hbox, TRUE, TRUE, 2); */
  gtk_box_pack_start (GTK_BOX
		      (GTK_DIALOG (window)->action_area),
		      hbox, TRUE, TRUE, 2);


  gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);
  gtk_widget_show_all (window);
  return TRUE;
}


void
insertwaypoints (gint mobile)
{
  gint i, j;
  gchar *text[5], text0[20], text1[20], text2[20], text3[20];

/*  insert waypoint into the clist */

  if (!mobile)
    for (i = 0; i < maxwp; i++)
      {
	(wayp + i)->dist = calcdist ((wayp + i)->longitude, (wayp + i)->lat);

	text[1] = (wayp + i)->name;

	g_snprintf (text0, sizeof (text0), "%02d", i + 1);
	g_snprintf (text1, sizeof (text1), "%8.5f", (wayp + i)->lat);
	if (minsecmode)
	  decimaltomin (text1, 1);
	g_snprintf (text2, sizeof (text2), "%8.5f", (wayp + i)->longitude);
	if (minsecmode)
	  decimaltomin (text2, 0);
	g_snprintf (text3, sizeof (text3), "%9.3f", (wayp + i)->dist);
	text[0] = text0;
	text[2] = text1;
	text[3] = text2;
	text[4] = text3;
	j = gtk_clist_append (GTK_CLIST (mylist), (gchar **) text);
	gtk_clist_set_foreground (GTK_CLIST (mylist), j, &black);
      }

/*  we want te columns sorted by distance from current position */
  gtk_clist_set_sort_column (GTK_CLIST (mylist), (gint) sortcolumn);
  gtk_clist_sort (GTK_CLIST (mylist));
}

gint
setsortcolumn (GtkWidget * w, gpointer datum)
{
  sortflag = !sortflag;
  sortcolumn = (gint) datum;

  if (sortflag)
    gtk_clist_set_sort_type (GTK_CLIST (mylist), GTK_SORT_ASCENDING);
  else
    gtk_clist_set_sort_type (GTK_CLIST (mylist), GTK_SORT_DESCENDING);

  if (w != messagewindow)
    reinsertwp_cb (NULL, 0);
  else
    {
      gtk_clist_set_sort_column (GTK_CLIST (mylist), (gint) sortcolumn);
      gtk_clist_sort (GTK_CLIST (mylist));
    }
  return TRUE;
}


void
insertroutepoints ()
{
  gint i, j;
  gchar *text[5], text0[20], text1[20], text2[20], text3[20];

  i = thisrouteline;
  (wayp + i)->dist = calcdist ((wayp + i)->longitude, (wayp + i)->lat);
  text[1] = (wayp + i)->name;
  g_snprintf (text0, sizeof (text0), "%d", i + 1);
  g_snprintf (text1, sizeof (text1), "%8.5f", (wayp + i)->lat);
  if (minsecmode)
    decimaltomin (text1, 1);
  g_snprintf (text2, sizeof (text2), "%8.5f", (wayp + i)->longitude);
  if (minsecmode)
    decimaltomin (text2, 0);
  g_snprintf (text3, sizeof (text3), "%9.3f", (wayp + i)->dist);
  text[0] = text0;
  text[2] = text1;
  text[3] = text2;
  text[4] = text3;
  j = gtk_clist_append (GTK_CLIST (myroutelist), (gchar **) text);
  gtk_clist_set_foreground (GTK_CLIST (myroutelist), j, &black);
  g_strlcpy ((routelist + routeitems)->name, (wayp + i)->name, 40);
  (routelist + routeitems)->lat = (wayp + i)->lat;
  (routelist + routeitems)->longitude = (wayp + i)->longitude;
  routeitems++;
  gtk_widget_set_sensitive (select_route_button, TRUE);

}

void
insertallroutepoints ()
{
  gint i, j;
  gchar *text[5], text0[20], text1[20], text2[20], text3[20];

  for (i = 0; i < maxwp; i++)
    {
      (wayp + i)->dist = calcdist ((wayp + i)->longitude, (wayp + i)->lat);
      text[1] = (wayp + i)->name;
      g_snprintf (text0, sizeof (text0), "%d", i + 1);
      g_snprintf (text1, sizeof (text1), "%8.5f", (wayp + i)->lat);
      if (minsecmode)
	decimaltomin (text1, 1);
      g_snprintf (text2, sizeof (text2), "%8.5f", (wayp + i)->longitude);
      if (minsecmode)
	decimaltomin (text2, 0);
      g_snprintf (text3, sizeof (text3), "%9.3f", (wayp + i)->dist);
      text[0] = text0;
      text[2] = text1;
      text[3] = text2;
      text[4] = text3;
      j = gtk_clist_append (GTK_CLIST (myroutelist), (gchar **) text);
      gtk_clist_set_foreground (GTK_CLIST (myroutelist), j, &black);
      g_strlcpy ((routelist + routeitems)->name, (wayp + i)->name, 40);
      (routelist + routeitems)->lat = (wayp + i)->lat;
      (routelist + routeitems)->longitude = (wayp + i)->longitude;
      routeitems++;
    }
  gtk_widget_set_sensitive (select_route_button, TRUE);

}

gint
reinsertwp_cb (GtkWidget * widget, guint datum)
{
  gint i, j, k, val;
  gchar *p;
  GtkAdjustment *ad;

/*  update routine for select target window */
  k = 0;
  ad = gtk_clist_get_vadjustment (GTK_CLIST (mylist));
  val = (GTK_ADJUSTMENT (ad)->value);

  gtk_clist_freeze (GTK_CLIST (mylist));
  gtk_clist_clear (GTK_CLIST (mylist));
  insertwaypoints (FALSE);
  for (i = 0; i < maxwp; i++)
    {
      gtk_clist_get_text (GTK_CLIST (mylist), i, 0, &p);
      j = atol (p);
      if (thisline == j)
	{
	  k = i;
	  break;
	}
    }
  gtk_adjustment_set_value (GTK_ADJUSTMENT (ad), val);
  dontsetwp = TRUE;
  gtk_clist_select_row (GTK_CLIST (mylist), k, 0);
  dontsetwp = FALSE;
  gtk_clist_thaw (GTK_CLIST (mylist));
  return TRUE;
}

gint
sel_target_cb (GtkWidget * widget, guint datum)
{
  GtkWidget *window;
  gchar *tabeltitel1[] = { "#",
    _("Waypoint"), _("Latitude"), _("Longitude"), _("Distance"),
    NULL
  };
  GtkWidget *scrwindow, *vbox, *button, *hbox, *deletebt, *gotobt;

  if (setwpactive)
    return TRUE;


  setwpactive = TRUE;
  window = gtk_dialog_new ();
/*    gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, TRUE); */
  gotowindow = window;
  gtk_window_set_transient_for (GTK_WINDOW (window), GTK_WINDOW (mainwindow));

  if (datum == 1)
    {
      gtk_window_set_modal (GTK_WINDOW (window), TRUE);
      gtk_window_set_title (GTK_WINDOW (window), _("Select reference point"));
    }
  else
    gtk_window_set_title (GTK_WINDOW (window),
			  _("Please select your destination"));
  gtk_window_set_default_size (GTK_WINDOW (window), real_screen_x,
                               real_screen_y);

  mylist = gtk_clist_new_with_titles (5, tabeltitel1);
  if (datum == 1)
    gtk_signal_connect (GTK_OBJECT (GTK_CLIST (mylist)),
			"select-row",
			GTK_SIGNAL_FUNC (setrefpoint_cb),
			GTK_OBJECT (mylist));
  else
    {
      gtk_signal_connect (GTK_OBJECT (GTK_CLIST (mylist)),
			  "select-row",
			  GTK_SIGNAL_FUNC (setwp_cb), GTK_OBJECT (mylist));
/*       gtk_signal_connect (GTK_OBJECT (mylist), "button-release-event", */
/* 			  GTK_SIGNAL_FUNC (click_clist), NULL); */
    }

  gtk_signal_connect (GTK_OBJECT
		      (GTK_CLIST (mylist)),
		      "click-column", GTK_SIGNAL_FUNC (setsortcolumn), 0);

  if (datum != 1)
    {
      if (routemode)
	create_route_button = gtk_button_new_with_label (_("Edit route"));
      else
	create_route_button = gtk_button_new_with_label (_("Create route"));
      GTK_WIDGET_SET_FLAGS (create_route_button, GTK_CAN_DEFAULT);
      gtk_signal_connect (GTK_OBJECT (create_route_button), "clicked",
			  GTK_SIGNAL_FUNC (create_route_cb), 0);
    }

  deletebt = gtk_button_new_from_stock (GTK_STOCK_DELETE);
  GTK_WIDGET_SET_FLAGS (deletebt, GTK_CAN_DEFAULT);
  gtk_signal_connect (GTK_OBJECT (deletebt), "clicked",
		      GTK_SIGNAL_FUNC (delwp_cb), 0);

  gotobt = gtk_button_new_from_stock (GTK_STOCK_JUMP_TO);
  GTK_WIDGET_SET_FLAGS (gotobt, GTK_CAN_DEFAULT);
  gtk_signal_connect (GTK_OBJECT (gotobt), "clicked",
		      GTK_SIGNAL_FUNC (jumpwp_cb), 0);

/*   button = gtk_button_new_with_label (_("Close")); */
  button = gtk_button_new_from_stock (GTK_STOCK_CLOSE);
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_window_set_default (GTK_WINDOW (window), button);
  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
			     GTK_SIGNAL_FUNC
			     (sel_targetweg_cb), GTK_OBJECT (window));
  gtk_signal_connect_object (GTK_OBJECT (window),
			     "delete_event",
			     GTK_SIGNAL_FUNC
			     (sel_targetweg_cb), GTK_OBJECT (window));

  insertwaypoints (FALSE);
  gtk_clist_set_column_justification (GTK_CLIST (mylist), 4,
				      GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_justification (GTK_CLIST (mylist), 0,
				      GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_auto_resize (GTK_CLIST (mylist), 0, TRUE);
  gtk_clist_set_column_auto_resize (GTK_CLIST (mylist), 1, TRUE);
  gtk_clist_set_column_auto_resize (GTK_CLIST (mylist), 2, TRUE);
  gtk_clist_set_column_auto_resize (GTK_CLIST (mylist), 3, TRUE);
  gtk_clist_set_column_auto_resize (GTK_CLIST (mylist), 4, TRUE);

  scrwindow = gtk_scrolled_window_new (NULL, NULL);
  gtk_container_add (GTK_CONTAINER (scrwindow), mylist);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW
				  (scrwindow),
				  (GtkPolicyType)
				  GTK_POLICY_AUTOMATIC,
				  (GtkPolicyType) GTK_POLICY_AUTOMATIC);
  vbox = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX
		      (GTK_DIALOG (window)->vbox), vbox, TRUE, TRUE, 2);
  gtk_box_pack_start (GTK_BOX (vbox), scrwindow, TRUE, TRUE, 0);
  hbox = gtk_hbutton_box_new ();
  gtk_box_pack_start (GTK_BOX
		      (GTK_DIALOG (window)->action_area),
		      hbox, TRUE, TRUE, 2);

  if (datum != 1)
    {
      gtk_box_pack_start (GTK_BOX (hbox), create_route_button, TRUE, TRUE,
			  0);
      gtk_box_pack_start (GTK_BOX (hbox), deletebt, TRUE, TRUE, 0);
      gtk_box_pack_start (GTK_BOX (hbox), gotobt, TRUE, TRUE, 0);
    }
  gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, TRUE, 0);
/*    gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER); */

/*   I remove this, because you can sort by mouseclick now */
/*   selwptimeout = gtk_timeout_add (30000, (GtkFunction) reinsertwp_cb, 0); */

  gtk_widget_show_all (window);

  return TRUE;
}


gint
create_route_cb (GtkWidget * widget, guint datum)
{
  GtkWidget *window;
  gchar *tabeltitel1[] = { "#",
    _("Waypoint"), _("Latitude"), _("Longitude"), _("Distance"),
    NULL
  };
  GtkWidget *scrwindow, *vbox, *button, *button3, *hbox, *hbox2, *l1;
  gint i, j;
  gchar *text[5], text0[20], text1[20], text2[20], text3[20];

  createroute = TRUE;
  window = gtk_dialog_new ();
  routewindow = window;
/*    gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, TRUE); */
  gtk_window_set_transient_for (GTK_WINDOW (window), GTK_WINDOW (mainwindow));

  gtk_window_set_title (GTK_WINDOW (window), _("Define route"));
  gtk_window_set_default_size (GTK_WINDOW (window), 320, 320);
  myroutelist = gtk_clist_new_with_titles (5, tabeltitel1);
  gtk_signal_connect (GTK_OBJECT (GTK_CLIST (myroutelist)),
		      "select-row",
		      GTK_SIGNAL_FUNC (setroutetarget),
		      GTK_OBJECT (myroutelist));

  select_route_button = gtk_button_new_with_label (_("Start route"));
  gtk_widget_set_sensitive (select_route_button, FALSE);

  GTK_WIDGET_SET_FLAGS (select_route_button, GTK_CAN_DEFAULT);
  gtk_signal_connect (GTK_OBJECT (select_route_button), "clicked",
		      GTK_SIGNAL_FUNC (do_route_cb), 0);
  gtk_window_set_default (GTK_WINDOW (window), select_route_button);

  create_route2_button =
    gtk_button_new_with_label (_("Take all WP as route"));
  GTK_WIDGET_SET_FLAGS (create_route2_button, GTK_CAN_DEFAULT);
  gtk_signal_connect (GTK_OBJECT (create_route2_button), "clicked",
		      GTK_SIGNAL_FUNC (insertallroutepoints), 0);

  button = gtk_button_new_with_label (_("Abort route"));
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
			     GTK_SIGNAL_FUNC
			     (sel_routecancel_cb), GTK_OBJECT (window));
  gtk_signal_connect_object (GTK_OBJECT (window),
			     "delete_event",
			     GTK_SIGNAL_FUNC
			     (sel_routeclose_cb), GTK_OBJECT (window));

/*   button3 = gtk_button_new_with_label (_("Close")); */
  button3 = gtk_button_new_from_stock (GTK_STOCK_CLOSE);
  GTK_WIDGET_SET_FLAGS (button3, GTK_CAN_DEFAULT);
  gtk_signal_connect_object (GTK_OBJECT (button3), "clicked",
			     GTK_SIGNAL_FUNC
			     (sel_routeclose_cb), GTK_OBJECT (window));


  gtk_clist_set_column_justification (GTK_CLIST (myroutelist), 4,
				      GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_justification (GTK_CLIST (myroutelist), 0,
				      GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_auto_resize (GTK_CLIST (myroutelist), 0, TRUE);
  gtk_clist_set_column_auto_resize (GTK_CLIST (myroutelist), 1, TRUE);
  gtk_clist_set_column_auto_resize (GTK_CLIST (myroutelist), 2, TRUE);
  gtk_clist_set_column_auto_resize (GTK_CLIST (myroutelist), 3, TRUE);
  gtk_clist_set_column_auto_resize (GTK_CLIST (myroutelist), 4, TRUE);

  scrwindow = gtk_scrolled_window_new (NULL, NULL);
  gtk_container_add (GTK_CONTAINER (scrwindow), myroutelist);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW
				  (scrwindow),
				  (GtkPolicyType)
				  GTK_POLICY_AUTOMATIC,
				  (GtkPolicyType) GTK_POLICY_AUTOMATIC);
  vbox = gtk_vbox_new (FALSE, 2);
/*   gtk_container_add (GTK_CONTAINER (window), vbox); */
  gtk_box_pack_start (GTK_BOX
		      (GTK_DIALOG (window)->vbox), vbox, TRUE, TRUE, 2);

  gtk_box_pack_start (GTK_BOX (vbox), scrwindow, TRUE, TRUE, 2);
  hbox = gtk_hbox_new (TRUE, 2);
  hbox2 = gtk_hbox_new (TRUE, 2);
  if (!routemode)
    l1 = gtk_label_new (_("Click on waypoints list\nto add waypoints"));
  else
    l1 = gtk_label_new (_("Click on list item\nto select next waypoint"));
  gtk_box_pack_start (GTK_BOX (vbox), l1, FALSE, FALSE, 2);
/*   gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 2); */
  gtk_box_pack_start (GTK_BOX
		      (GTK_DIALOG (window)->action_area),
		      hbox, TRUE, TRUE, 2);

  gtk_box_pack_start (GTK_BOX (hbox), select_route_button, TRUE, TRUE, 2);
  gtk_box_pack_start (GTK_BOX (hbox), create_route2_button, TRUE, TRUE, 2);
  gtk_box_pack_start (GTK_BOX (hbox), button, TRUE, TRUE, 2);
  gtk_box_pack_start (GTK_BOX (vbox), hbox2, FALSE, FALSE, 2);
  gtk_box_pack_start (GTK_BOX (hbox), button3, TRUE, TRUE, 2);
  gtk_widget_set_sensitive (create_route_button, FALSE);

  if (routemode)
    {
      gtk_widget_set_sensitive (select_route_button, FALSE);
      gtk_clist_clear (GTK_CLIST (myroutelist));
      for (i = 0; i < routeitems; i++)
	{
	  (routelist + i)->dist =
	    calcdist ((routelist + i)->longitude, (routelist + i)->lat);
	  text[1] = (routelist + i)->name;
	  g_snprintf (text0, sizeof (text0), "%d", i + 1);
	  g_snprintf (text1, sizeof (text1), "%8.5f", (routelist + i)->lat);
	  g_snprintf (text2, sizeof (text2), "%8.5f",
		      (routelist + i)->longitude);
	  g_snprintf (text3, sizeof (text3), "%9.3f", (routelist + i)->dist);
	  text[0] = text0;
	  text[2] = text1;
	  text[3] = text2;
	  text[4] = text3;
	  j = gtk_clist_append (GTK_CLIST (myroutelist), (gchar **) text);
	  gtk_clist_set_foreground (GTK_CLIST (myroutelist), j, &black);
	}
    }
  else
    routeitems = 0;

  gtk_widget_show_all (window);

  return TRUE;
}



void
usage ()
{

/*** Mod by Arms */
  g_print ("%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s",
	   "\nCopyright (c) 2001-2004 Fritz Ganter <ganter@ganter.at>"
	   "\n              Website: http://www.gpsdrive.de"
           "\nModifications for ipaq specific version"
	   "\nCopyright (c) 2007 Andrew M. Bishop <amb@gedanken.demon.co.uk>"
	   "\n              Website: http://www.geganken.demon.co.uk/gpsdrive-ipaq/\n\n",
	   _("-v    show version\n"),
	   _("-h    print this help\n"),
	   _("-d    turn on debug info\n"),
	   _("-D    turn on lot of debug info\n"),
	   _("-e    use Festival-Lite (flite) for speech output\n"),
	   _("-t    set serial device for GPS i.e. /dev/ttyS1\n"),
	   _("-o    serial device, pty master, or file for NMEA *output*\n"),
	   _("-n    Disable use of direct serial connection\n"),
	   _("-l X  Select language of the voice,\n"
	     "      X may be english, spanish or german\n"),
	   ("-b X  Servername for NMEA server (if gpsd runs on another host)\n"),
	   _
	   ("-i    ignore NMEA checksum (risky, only for broken GPS receivers\n"),
	   _("-F    force display of position even it is invalid\n"),
	   _("-E    print out data received from direct serial connection\n"),
	   _
	   ("-W x  set x to 1 to switch WAAS/EGNOS on, set to 0 to switch off\n"),
	   _("-H X  correct altitude, adding this value to altitude\n"),
	   _("-z    don't display zoom factor and scale\n\n"));

}

/*  load the definitions of the map files */

void map_calcxytopos(gint posx, gint posy, gdouble *lat, gdouble *lon, gint i)
{
  int px, py;
  gdouble pixelfactloc;
  gdouble map_lat, map_long;

  map_lat=(maps + i)->lat;
  map_long=(maps + i)->longitude;

  pixelfactloc = (maps + i)->scale / PIXELFACT;

  px = - posx * pixelfactloc;
  py =   posy * pixelfactloc;

  if ((maps + i)->type == 0)
    {
      *lat = map_lat  - py / (Ra[(int) (100 + map_lat)] * M_PI / 180.0);

      *lon = map_long - px / (Ra[(int) (100 + map_lat)] * M_PI / 180.0 * cos (M_PI / 180.0 * map_lat));
    }
  else if ((maps + i)->type == 1)
    {
      *lat = map_lat  - py / (Ra[(int) (100 + 0)] * M_PI / 180.0);

      *lon = map_long - px / (Ra[(int) (100 + 0)] * M_PI / 180.0);
    }
  else
    {
      *lat = 90 * ( atan( tan(M_PI_4*(1+map_lat/90.0)) * pow(M_E, -py / (Ra[(int) (100 + 0)] * M_PI / 360.0 * (180 / M_PI))) ) / M_PI_4 - 1);

      *lon = map_long - px / (Ra[(int) (100 + 0)] * M_PI / 360.0);
    }
}


gint
loadmapconfig ()
{
  gchar mappath[400];
  FILE *st;
  gint i;
  gchar buf[1512], s1[40], s2[40], s3[40], filename[100];
  gint p, e;

  if (mapdir[strlen (mapdir) - 1] != '/')
    g_strlcat (mapdir, "/", sizeof (mapdir));

  g_strlcpy (mappath, mapdir, sizeof (mappath));
  g_strlcat (mappath, "map_koord.txt", sizeof (mappath));
  st = fopen (mappath, "r");
  if (st == NULL)
    {
      mkdir (homedir, 0777);
      st = fopen (mappath, "w+");
      if (st == NULL)
	{
	  perror (mappath);
	  return FALSE;
	}
      st = freopen (mappath, "r", st);
      if (st == NULL)
	{
	  perror (mappath);
	  return FALSE;
	}

    }
  if (nrmaps > 0)
    g_free (maps);

  maps = g_new (mapsstruct, 1);
  i = nrmaps = 0;
  while ((p = fgets (buf, 1512, st) != 0))
    {
      e = sscanf (buf, "%s %s %s %s", filename, s1, s2, s3);
      if (e == 4)
	{
	  g_strdelimit (s1, ",", '.');
	  g_strdelimit (s2, ",", '.');
	  g_strdelimit (s3, ",", '.');
	  g_strlcpy ((maps + i)->filename, filename, 200);
	  (maps + i)->lat = g_strtod (s1, NULL);
	  (maps + i)->longitude = g_strtod (s2, NULL);
	  (maps + i)->scale = strtol (s3, NULL, 0);

          if (!(strncmp ((maps + i)->filename, "map_", 4)))
             (maps + i)->type = 0;
          if (!(strncmp ((maps + i)->filename, "top_", 4)))
             (maps + i)->type = 1;
          if (!(strncmp ((maps + i)->filename, "osm_", 4)))
             (maps + i)->type = 2;

          map_calcxytopos(borderlimit-640, 512-borderlimit, &((maps + i)->lat_min), &((maps + i)->lon_min), i);
          map_calcxytopos(640-borderlimit, borderlimit-512, &((maps + i)->lat_max), &((maps + i)->lon_max), i);

          if(debug)
             printf("map %3d : lat(%8.5f %8.5f %8.5f) lon(%8.5f %8.5f %8.5f), %8ld\n",
                    i,
                    (maps + i)->lat_min,(maps + i)->lat,(maps + i)->lat_max,
                    (maps + i)->lon_min,(maps + i)->longitude,(maps + i)->lon_max,
                    (maps + i)->scale);

	  i++;
	  nrmaps = i;
	  maps = g_renew (mapsstruct, maps, (i + 2));
	}
    }
  fclose (st);
  needreloadmapconfig = FALSE;
  return FALSE;
}


/*  load the waypoint from way.txt, if success we display the sel target window */
void
savewaypoints ()
{
  gchar mappath[400], la[20], lo[20];
  FILE *st;
  gint i, e;


  g_strlcpy (mappath, homedir, sizeof (mappath));
  g_strlcat (mappath, activewpfile, sizeof (mappath));

  st = fopen (mappath, "w+");
  if (st == NULL)
    {
      perror (mappath);
    }
  else
    {
      for (i = 0; i < maxwp; i++)
	{
	  g_snprintf (la, sizeof (la), "%10.6f", (wayp + i)->lat);
	  g_snprintf (lo, sizeof (lo), "%10.6f", (wayp + i)->longitude);
	  g_strdelimit (la, ",", '.');
	  g_strdelimit (lo, ",", '.');

	  e =
	    fprintf (st, "%-22s %10s %11s %s\n", (wayp + i)->name, la, lo,
		     (wayp + i)->typ);
	}
      fclose (st);
    }

}


/*  load the waypoint from way.txt, if success we display the sel target window */
void
loadwaypoints ()
{
  gchar mappath[400];
  FILE *st;
  gint i, e, p, action;
  gchar buf[512], slat[80], slong[80], typ[40];
  struct stat buf2;

  if (waytxtstamp == 0)
    wayp = g_new (wpstruct, wpsize);

  g_strlcpy (mappath, homedir, sizeof (mappath));
  g_strlcat (mappath, activewpfile, sizeof (mappath));

  maxwp = 0;
  st = fopen (mappath, "r");
  if (st == NULL)
    {
      perror (mappath);
    }
  else
    {
      i = 0;
      while ((p = fgets (buf, 512, st) != 0))
	{
	  e =
	    sscanf (buf, "%s %s %s %s %d\n", (wayp + i)->name, slat,
		    slong, typ, &action);
	  (wayp + i)->lat = g_strtod (slat, NULL);
	  (wayp + i)->longitude = g_strtod (slong, NULL);
/*  limit waypoint name to 20 chars */
	  (wayp + i)->name[20] = 0;
	  g_strlcpy ((wayp + i)->typ, "", 40);
	  (wayp + i)->action = 0;
          (wayp + i)->symbol=0;

             {
              gint xpos, ypos;
              calcxy (&xpos, &ypos, (wayp + i)->longitude, (wayp + i)->lat, zoom);
              (wayp + i)->xpos = xpos;
              (wayp + i)->ypos = ypos;
             }

	  if (e >= 3)
	    {
	      (wayp + i)->dist = 0;

	      if (e >= 4)
		g_strlcpy ((wayp + i)->typ, typ, 40);

              (wayp + i)->symbol=symboltype((wayp + i)->typ);

	      if (e >= 6)
		(wayp + i)->action = action;

              if ((strncmp ((wayp + i)->name, "R-", 2)) == 0)
                 (wayp + i)->action = 1;

	      i++;
	      maxwp = i;
/*
		{
		  g_snprintf (s, sizeof(s), "%s %d", _("Show _WP"), maxwp);
		  if (GTK_IS_BUTTON (GTK_BUTTON (wpbt)))
		    gtk_button_set_label (GTK_BUTTON (wpbt), s);
		  else
		    g_print ("kein button!\n");
		}
*/
	      if (maxwp >= wpsize)
		{
		  wpsize += 1000;
		  wayp = g_renew (wpstruct, wayp, wpsize);
		}

	    }
	}
      fclose (st);

/* Check for changed way.txt file */
      stat (mappath, &buf2);
      waytxtstamp = buf2.st_mtime;

    }

}



gint
initgps ()
{
  struct sockaddr_in server;
  struct hostent *server_data;

/*  We test for gpsd serving */
  {
/*  open socket to port */
    if (sock != -1)
      {
	close (sock);
	sock = -1;
      }
    sock = socket (AF_INET, SOCK_STREAM, 0);
    if (sock < 0)
      {
	perror (_("can't open socket for port "));
	fprintf (stderr, "error: %d\n", errno);
	haveNMEA = FALSE;
	newsatslevel = TRUE;
	memset (satlist, 0, sizeof (satlist));
	memset (satlistdisp, 0, sizeof (satlist));
	numsats = satsavail = 0;
	if (satsimage != NULL)
	  g_object_unref (satsimage);
	satsimage = NULL;
	gtk_widget_draw (drawing_sats1, NULL);	/* this  calls expose handler */
	gtk_widget_draw (drawing_sats2, NULL);	/* this  calls expose handler */
	return 0;
      }
    server.sin_family = AF_INET;
/*  We retrieve the IP address of the server from its name: */
    if ((server_data = gethostbyname (SERVERNAME)) == NULL)
      {
	fprintf (stderr, _("\nCannot connect to %s: unknown host\n"),
		 SERVERNAME);
	exit (1);
      }
    memcpy (&server.sin_addr, server_data->h_addr, server_data->h_length);
    server.sin_port = htons (SERVERPORT2);

/*  We initiate the connection  */
    if (connect (sock, (struct sockaddr *) &server, sizeof server) < 0)
      {
	server.sin_port = htons (SERVERPORT);	/* We try second port */
/*  We initiate the connection  */
	if (connect (sock, (struct sockaddr *) &server, sizeof server) < 0)
	  {
	    haveNMEA = FALSE;
	  }
	else
	  {
	    haveNMEA = TRUE;
	    g_strlcpy (nmeamodeandport, _("NMEA Mode, Port 2222"),
		       sizeof (nmeamodeandport));
	    g_strlcat (nmeamodeandport, "/", sizeof (nmeamodeandport));
	    g_strlcat (nmeamodeandport, gpsdservername,
		       sizeof (nmeamodeandport));
	  }
      }
    else
      {
	g_strlcpy (nmeamodeandport, _("NMEA Mode, Port 2947"),
		   sizeof (nmeamodeandport));
	g_strlcat (nmeamodeandport, "/", sizeof (nmeamodeandport));
	g_strlcat (nmeamodeandport, gpsdservername, sizeof (nmeamodeandport));
	write (sock, "R\n", 2);
	haveNMEA = TRUE;
      }


  }

  return FALSE;			/* to remove timer */
}


/*  on a USR2 signal, re-start the GPS connection  */

void
usr2handler (int sig)
{
  g_print ("\ngot SIGUSR2\n");
  initgps ();
}


/*  Main program */
int
main (int argc, char *argv[])
{
  GtkWidget *vbig, *vbox, *vbox2, *vbox4, *hbig, *vmenubig;
  GtkWidget *zoomin, *zoomout, *zoom1, *zoom2, *zoom4, *zoom8, *zoom16, *zoom32, *zoom64,
            *zoombox, *zoombox2, *zoombox3, *zoombox4, *zoombox5, *zoombox6;
  GtkWidget *wpbox, *bearingbox;
  GtkWidget *statusbox, *statusbox1, *statusbox2, *statusbox3, *statusbox4;
  GtkWidget *quit, *vboxlow, *hboxlow;
  GtkWidget *sel_target, *addwaypoint;
  gchar maintitle[100];
/*   GdkColor farbe;   */
  GdkRectangle rectangle = {
    0, 0, SCREEN_X, SCREEN_Y
  };
  const gchar *hd;

/*** Mod by Arms */
  gint i, h, w;
  gchar s1[100],*p, *localestring, **lstr, lstr2[200];
  /*** Mod by Arms */
  struct tm *lt;
  time_t local_time, gmt_time;
  gdouble f;

  tzset ();
  gmt_time = time (NULL);

/*   printf("dbtypelist: %d, auxicons.name: %d\n",sizeof(dbtypelist[0]),sizeof(auxicons->name)); */
/*   exit(0); */

  lt = gmtime (&gmt_time);
  local_time = mktime (lt);
  zone = lt->tm_isdst + (gmt_time - local_time) / 3600;
/*   fprintf(stderr,"\n zeitzone: %d\n",zone); */

/*   zone = st->tm_gmtoff / 3600; */
/*  initialize variables */
/*  Hamburg */
  srand (gmt_time);
  f = 0.02 * (0.5 - rand () / (RAND_MAX + 1.0));
  current_lat = zero_lat = 53.623672 + f;
  f = 0.02 * (0.5 - rand () / (RAND_MAX + 1.0));
  current_long = zero_long = 10.055441 + f;
/*    zero_lat and zero_long are overwritten by gpsdriverc,  */
  tripreset ();

  g_strlcpy (dgpsserver, "dgps.wsrcc.com", sizeof (dgpsserver));
  g_strlcpy (dgpsport, "2104", sizeof (dgpsport));
  g_strlcpy (gpsdservername, "127.0.0.1", sizeof (gpsdservername));
  direction = angle_to_destination = 0;
  g_strlcpy (targetname, "     ", sizeof (targetname));
  g_strlcpy (utctime, "n/a", sizeof (utctime));
  g_strlcpy (oldangle, "none", sizeof (oldangle));
  pixelfact = MAPSCALE / PIXELFACT;
  g_strlcpy (oldfilename, "", sizeof (oldfilename));
  maploaded = FALSE;
  haveNMEA = FALSE;
  havepos = FALSE;
  haveposcount = debug = 0;
  zoom = 1;
  milesflag = iszoomed = FALSE;
  sel_target = addwaypoint = NULL;

  signal (SIGUSR2, usr2handler);
  timer = g_timer_new ();
  disttimer = g_timer_new ();
  g_timer_start (timer);
  g_timer_start (disttimer);
  memset (satlist, 0, sizeof (satlist));
  memset (satlistdisp, 0, sizeof (satlist));
  buffer = g_new (char, 2010);
  big = g_new (char, MAXBIG + 10);


  timeoutcount = lastp = bigp = bigpRME = bigpGSA = bigpGSV = bigpGGA = 0;
  lastp = lastpGGA = lastpGSV = lastpRME = lastpGSA = 0;
  gcount = xoff = yoff = 0;
  hours = minutes = 99;
  milesconv = 1.0;
/* set default color to navyblue */
  g_strlcpy (bluecolor, "navyblue", sizeof (bluecolor));
  g_strlcpy (trackcolor, "green3", sizeof (trackcolor));
  g_strlcpy (messagename, "", sizeof (messagename));
  g_strlcpy (messageack, "", sizeof (messageack));
  g_strlcpy (messagesendtext, "", sizeof (messagesendtext));

  g_strlcpy (lastradar, "", sizeof (lastradar));
  g_strlcpy (lastradar2, "", sizeof (lastradar2));
  g_strlcpy (activewpfile, "way.txt", sizeof (activewpfile));
  g_strlcpy (loctime, "n/a", sizeof (loctime));
  voicelang = english;
  track = g_new0 (GdkSegment, 10000);
  tracknr = 0;
  trackcoord = g_new0 (trackcoordstruct, 10000);
  trackcoordnr = 0;
  tracklimit = trackcoordlimit = 10000;
  routelist = g_new0 (wpstruct, 100);



  earthr = calcR (current_lat);
/*    homedir is the directory where the maps and other  */
/*  files are stored (~/.gpsdrive) */
  hd = g_get_home_dir ();
  g_strlcpy (homedir, hd, sizeof (homedir));
  g_strlcat (homedir, "/.gpsdrive/", sizeof (homedir));
  g_strlcpy (mapdir, homedir, sizeof (mapdir));

/*  all default values must be set BEFORE readconfig! */
  g_strlcpy (setpositionname, "", sizeof (setpositionname));
  g_strlcpy (serialdev, "/dev/ttyS3", sizeof (serialdev));

/*  I18l */

/*  Detect the language for voice output */
  localestring = setlocale (LC_ALL, "");
  if (localestring == NULL)
    localestring = setlocale (LC_MESSAGES, "");
  if (localestring != NULL)
    {
      lstr = g_strsplit (localestring, ";", 50);
      g_strlcpy (lstr2, "", 50);
      for (i = 0; i < 50; i++)
	if (lstr[i] != NULL)
	  {
	    if ((strstr (lstr[i], "LC_MESSAGES")) != NULL)
	      {
		g_strlcpy (lstr2, lstr[i], 50);
		break;
	      }
	  }
	else
	  {
	    g_strlcpy (lstr2, lstr[i - 1], 50);
	    break;
	  }
      g_strfreev (lstr);
    }
  if ((strstr (lstr2, "de_")) != NULL)
    voicelang = german;
  else if ((strstr (lstr2, "es_")) != NULL)
    voicelang = spanish;
  else
    voicelang = english;

  readconfig ();

  real_screen_x = 640;
  real_screen_y = 512;
  target_long = current_long + 0.00001;
  target_lat = current_lat + 0.00001;
  gdk_color_parse (trackcolor, &trackcolorv);

/*  load waypoints before locale is set! */
/*  Attention! In this file the decimal point is always a '.' !! */

/*  setting defaults if setting is not yet in configuraton file */
  if ((milesflag + metricflag + nauticflag) == 0)
    metricflag = TRUE;



/* PORTING */
  p = bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
  bind_textdomain_codeset (PACKAGE, "utf8");
  p = textdomain (GETTEXT_PACKAGE);
  p = textdomain (NULL);
/*    needed for right decimal delimiter ('.' or ',') */
  mylocale = NULL;
  localedecimal = '.';
  mylocale = localeconv ();
  if (mylocale != NULL)
    localedecimal = (char) mylocale->decimal_point[0];

/*    Setting locale for correct Umlauts */
  gtk_set_locale ();
/*  initialization for GTK+ */


  gtk_init (&argc, &argv);
/* Needed 4 hours to find out that this is IMPORTANT!!!! */
  gdk_rgb_init ();
  h = gdk_screen_height ();
  w = gdk_screen_width ();

  /* parse cmd args */
  do
    {
/*** Mod by Arms */
      i = getopt (argc, argv, "W:ESA:ab:c:zx1qivdDFepH:hnf:l:t:s:o:r:?");
      switch (i)
	{
	case 'E':
	  nmeaverbose = TRUE;
	  break;
	case 'd':
	  debug = TRUE;
	  break;
	case 'D':
	  mydebug = TRUE;
	  debug = TRUE;
	  break;
	case 'e':
	  useflite = TRUE;
	  break;
	case 'i':
	  ignorechecksum = TRUE;
	  g_print ("\nWARNING: NMEA checksum test switched off!\n\n");
	  break;
	case 'v':
	  printf ("\nCopyright (c) 2001-2004 Fritz Ganter <ganter@ganter.at>\n"
                  "Website: www.gpsdrive.de\n\n"
                  "Modifications for ipaq specific version\n"
                  "Copyright (c) 2007 Andrew M. Bishop <amb@gedanken.demon.co.uk>\n"
                  "Website: http://www.geganken.demon.co.uk/gpsdrive-ipaq/\n"
		  "\nVersion %s\n\n", VERSION);
	  exit (0);
	  break;
	case 't':
	  g_strlcpy (serialdev, optarg, sizeof (serialdev));
	  break;
	case 'A':
	  alarm_dist = strtod (optarg, NULL);
	  break;
	case 'b':
	  g_strlcpy (gpsdservername, optarg, sizeof (gpsdservername));
	  break;
	case 'c':
	  g_strlcpy (setpositionname, optarg, sizeof (setpositionname));
	  break;
	case 'f':
	case 'n':
	  disableserialcl = TRUE;
	  break;
	case 's':
	  h = strtol (optarg, NULL, 0);
	  break;
	case 'W':
	  switch (strtol (optarg, NULL, 0))
	    {
	    case 0:
	      egnosoff = TRUE;
	      break;
	    case 1:
	      egnoson = TRUE;
	      break;
	    }
	  break;
	case 'l':
	  if (!strcmp (optarg, "english"))
	    voicelang = english;
	  else if (!strcmp (optarg, "german"))
	    voicelang = german;
	  else if (!strcmp (optarg, "spanish"))
	    voicelang = spanish;
	  else
	    {
	      usage ();
	      g_print (_
		       ("\nYou can only choose between english, spanish and german\n\n"));
	      exit (0);
	    }
	  break;
	case 'o':
	  nmeaout = opennmea (optarg);
	  break;
	case 'h':
	  usage ();
	  exit (0);
	  break;
	case 'H':
	  normalnull = strtol (optarg, NULL, 0);
	  break;
	case '?':
	  usage ();
	  exit (0);
	  break;
/*** Mod by Arms */
	case 'r':
	  w = strtol (optarg, NULL, 0);
	  break;
	case 'z':
	  zoomscale = FALSE;
	  break;
	case 'F':
	  forcehavepos = TRUE;
	  break;

	}
    }
  while (i != -1);

  iconpixbuf[0] = gdk_pixbuf_new_from_xpm_data ((const char **) rest_xpm);
  iconpixbuf[1] =
    gdk_pixbuf_new_from_xpm_data ((const char **) mcdonalds_xpm);
  iconpixbuf[2] = gdk_pixbuf_new_from_xpm_data ((const char **) hotel_xpm);
  iconpixbuf[3] =
    gdk_pixbuf_new_from_xpm_data ((const char **) burgerking_xpm);
  iconpixbuf[4] = gdk_pixbuf_new_from_xpm_data ((const char **) shop_xpm);
  iconpixbuf[5] = gdk_pixbuf_new_from_xpm_data ((const char **) monu_xpm);
  iconpixbuf[6] = gdk_pixbuf_new_from_xpm_data ((const char **) girls_xpm);
  iconpixbuf[7] =
    gdk_pixbuf_new_from_xpm_data ((const char **) speedtrap_xpm);
  iconpixbuf[8] = gdk_pixbuf_new_from_xpm_data ((const char **) airport_xpm);
  iconpixbuf[9] = gdk_pixbuf_new_from_xpm_data ((const char **) golf_xpm);
  iconpixbuf[10] = gdk_pixbuf_new_from_xpm_data ((const char **) fuel_xpm);
  iconpixbuf[11] = gdk_pixbuf_new_from_xpm_data ((const char **) cafe_xpm);
  iconpixbuf[12] =
    gdk_pixbuf_new_from_xpm_data ((const char **) geocache_xpm);


/*  Build array for earth radii */
  for (i = -100; i <= 100; i++)
    Ra[i + 100] = calcR (i);

/*** Mod by Arms (move) */
/*    g_print ("\nHhe: %d\n", h); */


/* parse args moved up */

  if (debug)
     printf ("\nCopyright (c) 2001-2004 Fritz Ganter <ganter@ganter.at>\n"
             "Website: www.gpsdrive.de\n\n"
             "Modifications for ipaq specific version\n"
             "Copyright (c) 2007 Andrew M. Bishop <amb@gedanken.demon.co.uk>\n"
             "Website: http://www.geganken.demon.co.uk/gpsdrive-ipaq/\n"
             "\nVersion %s\n\n", VERSION);

/* Create toplevel window */

  if (w == 0)
     real_screen_x = 220;
  else if(w>640)
     real_screen_x = 640 - 8;
  else
     real_screen_x = w - 8;
  if(h>480)
     real_screen_y = 480 - 70;
  else
     real_screen_y = h - 70;

  if (real_screen_x < real_screen_y)
    borderlimit = real_screen_x / 5;
  else
    borderlimit = real_screen_y / 5;

  if (borderlimit < 30)
    borderlimit = 30;

  SCREEN_X_2 = SCREEN_X / 2;
  SCREEN_Y_2 = SCREEN_Y / 2;
  PSIZE = 50;
  posx = SCREEN_X_2;
  posy = SCREEN_Y_2;

/*  load mapfile configurations */
/*  Attention! In this file the decimal point is that what locale says, 
i.e. '.' in english, ',' in german!! */
  loadmapconfig ();

//KCFX

  mainwindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);

  g_snprintf (maintitle, sizeof (maintitle), "%s v%s", "GpsDrive", VERSION);

  gtk_window_set_title (GTK_WINDOW (mainwindow), maintitle);
  gtk_container_set_border_width (GTK_CONTAINER (mainwindow), 0);
  gtk_window_set_position (GTK_WINDOW (mainwindow), GTK_WIN_POS_CENTER);
  gtk_signal_connect (GTK_OBJECT (mainwindow), "delete_event",
		      GTK_SIGNAL_FUNC (quit_program), NULL);

  gtk_signal_connect (GTK_OBJECT (mainwindow), "key_press_event",
		      GTK_SIGNAL_FUNC (key_cb), NULL);

  status = gtk_statusbar_new ();
  statusid = gtk_statusbar_get_context_id (GTK_STATUSBAR (status), "main");

  if (!useflite)
    havespeechout = FALSE;
  else
    havespeechout = TRUE;

  if (havespeechout)
    gtk_statusbar_push (GTK_STATUSBAR (status), statusid,
			_("Using speech output"));

/*** Mod by Arms */
  vbig = gtk_vbox_new (FALSE, 0);
  vmenubig = gtk_vbox_new (FALSE, 0);
/*** Mod by Arms */
  hbig = gtk_hbox_new (FALSE, 0);

/*  Quit button */
/* PORTING */
/*   quit = gtk_button_new_with_label (_("Quit")); */
  quit = gtk_button_new_from_stock (GTK_STOCK_QUIT);
  gtk_button_set_use_underline (GTK_BUTTON (quit), TRUE);

  gtk_signal_connect (GTK_OBJECT (quit),
		      "clicked", GTK_SIGNAL_FUNC (quit_program), 0);
/*    GTK_WIDGET_SET_FLAGS (quit, GTK_CAN_DEFAULT); */

  mutebt = gtk_check_button_new_with_label (_("M_ute"));
  gtk_button_set_use_underline (GTK_BUTTON (mutebt), TRUE);
  if (muteflag)
     gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (mutebt), TRUE);

  gtk_signal_connect (GTK_OBJECT (mutebt),
                      "clicked", GTK_SIGNAL_FUNC (mute_cb), (gpointer) 1);

  loadwaypoints ();

  for (i = 0; i < maxwp; i++)
    {
      if (strlen (setpositionname) > 0)
	{
	  if (!(strcasecmp ((wayp + i)->name, setpositionname)))
	    {
	      current_lat = (wayp + i)->lat;
	      current_long = (wayp + i)->longitude;
	      target_long = current_long + 0.00001;
	      target_lat = current_lat + 0.00001;
	    }
	  if (!(strcasecmp ((wayp + i)->name, _("HomeBase"))))
	    {
	      alarm_lat = (wayp + i)->lat;
	      alarm_long = (wayp + i)->longitude;
	    }
	}
    }

  posbt = gtk_check_button_new_with_label (_("Pos. _mode"));
  gtk_button_set_use_underline (GTK_BUTTON (posbt), TRUE);

  gtk_signal_connect (GTK_OBJECT (posbt),
		      "clicked", GTK_SIGNAL_FUNC (pos_cb), (gpointer) 1);

  trackbt = gtk_check_button_new_with_label (_("Show _Track"));
  gtk_button_set_use_underline (GTK_BUTTON (trackbt), TRUE);
  if (trackflag)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (trackbt), TRUE);
  gtk_signal_connect (GTK_OBJECT (trackbt),
		      "clicked", GTK_SIGNAL_FUNC (track_cb), (gpointer) 1);

/* PORTING */
  setupbt = gtk_button_new_from_stock (GTK_STOCK_PREFERENCES);

  gtk_signal_connect (GTK_OBJECT (setupbt),
		      "clicked", GTK_SIGNAL_FUNC (setup_cb), (gpointer) 0);

  startgpsbt = gtk_button_new_with_label (_("Start GPSD"));
  gtk_signal_connect (GTK_OBJECT (startgpsbt),
		      "clicked", GTK_SIGNAL_FUNC (startgpsd), (gpointer) 0);

  savetrackfile (TRUE);
  g_snprintf (s1, sizeof (s1), "%s", _("Save track"));
  savetrackbt = gtk_check_button_new_with_label (s1);
  if (savetrack)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (savetrackbt), TRUE);
  gtk_signal_connect (GTK_OBJECT (savetrackbt),
		      "clicked", GTK_SIGNAL_FUNC (savetrack_cb),
		      (gpointer) 1);

  g_snprintf (s1, sizeof (s1), "%s", savetrackfn);
  lab1 = gtk_label_new (s1);

  /************************ zoom tab start ***********************/

  zoomin = gtk_button_new_from_stock (GTK_STOCK_ZOOM_IN);
  gtk_signal_connect (GTK_OBJECT (zoomin),
		      "clicked", GTK_SIGNAL_FUNC (zoom_cb), (gpointer) 1);

  zoomout = gtk_button_new_from_stock (GTK_STOCK_ZOOM_OUT);
  gtk_signal_connect (GTK_OBJECT (zoomout),
		      "clicked", GTK_SIGNAL_FUNC (zoom_cb), (gpointer) 2);

  zoom1 = gtk_button_new_with_label ("x1");
  gtk_signal_connect (GTK_OBJECT (zoom1),
		      "clicked", GTK_SIGNAL_FUNC (zoom_cb), (gpointer) 3);

  zoom2 = gtk_button_new_with_label ("x2");
  gtk_signal_connect (GTK_OBJECT (zoom2),
		      "clicked", GTK_SIGNAL_FUNC (zoom_cb), (gpointer) 4);

  zoom4 = gtk_button_new_with_label ("x4");
  gtk_signal_connect (GTK_OBJECT (zoom4),
		      "clicked", GTK_SIGNAL_FUNC (zoom_cb), (gpointer) 5);

  zoom8 = gtk_button_new_with_label ("x8");
  gtk_signal_connect (GTK_OBJECT (zoom8),
		      "clicked", GTK_SIGNAL_FUNC (zoom_cb), (gpointer) 6);

  zoom16 = gtk_button_new_with_label ("x16");
  gtk_signal_connect (GTK_OBJECT (zoom16),
		      "clicked", GTK_SIGNAL_FUNC (zoom_cb), (gpointer) 7);

  zoom32 = gtk_button_new_with_label ("x32");
  gtk_signal_connect (GTK_OBJECT (zoom32),
		      "clicked", GTK_SIGNAL_FUNC (zoom_cb), (gpointer) 8);

  zoom64 = gtk_button_new_with_label ("x64");
  gtk_signal_connect (GTK_OBJECT (zoom64),
		      "clicked", GTK_SIGNAL_FUNC (zoom_cb), (gpointer) 9);

  scalerrbt = gtk_button_new_with_label (_("Map Out"));
  gtk_signal_connect (GTK_OBJECT (scalerrbt),
		      "clicked", GTK_SIGNAL_FUNC (scalerbt_cb), (gpointer) 1);

  scalerlbt = gtk_button_new_with_label (_("Map In"));
  gtk_signal_connect (GTK_OBJECT (scalerlbt),
		      "clicked", GTK_SIGNAL_FUNC (scalerbt_cb), (gpointer) 2);

  lf3 = gtk_frame_new (_("Map file"));
  lf4 = gtk_frame_new (_("Map scale"));
  lf8 = gtk_frame_new (_("Pref. scale"));

  l3 = gtk_label_new (_("---"));
  gtk_container_add (GTK_CONTAINER (lf3), l3);
  l4 = gtk_label_new (_("---"));
  gtk_container_add (GTK_CONTAINER (lf4), l4);
  l8 = gtk_label_new (_("---"));
  gtk_container_add (GTK_CONTAINER (lf8), l8);

  adj = gtk_adjustment_new (12, 0, 29, 1, 4, 0.034);
  scaler = gtk_hscale_new (GTK_ADJUSTMENT (adj));
  gtk_signal_connect (GTK_OBJECT (adj), "value_changed",
                      GTK_SIGNAL_FUNC (scaler_cb), NULL);
  gtk_scale_set_draw_value (GTK_SCALE (scaler), FALSE);

  frame_maptype = gtk_frame_new (_("Map type"));

  bestmapbt = gtk_check_button_new_with_label (_("Auto _best map"));
  gtk_button_set_use_underline (GTK_BUTTON (bestmapbt), TRUE);

  if (!scaleprefered)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (bestmapbt), TRUE);
  gtk_signal_connect (GTK_OBJECT (bestmapbt),
		      "clicked", GTK_SIGNAL_FUNC (bestmap_cb), (gpointer) 1);

  maptogglebt = gtk_check_button_new_with_label (_("Street map"));
  if (displaymap_map)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (maptogglebt), TRUE);

  gtk_signal_connect (GTK_OBJECT (maptogglebt),
		      "clicked", GTK_SIGNAL_FUNC (maptoggle_cb),
		      (gpointer) 1);

  topotogglebt = gtk_check_button_new_with_label (_("Topo map"));
  if (displaymap_top)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (topotogglebt), TRUE);

  gtk_signal_connect (GTK_OBJECT (topotogglebt),
		      "clicked", GTK_SIGNAL_FUNC (topotoggle_cb),
		      (gpointer) 1);

  osmtogglebt = gtk_check_button_new_with_label (_("OSM map"));
  if (displaymap_osm)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (osmtogglebt), TRUE);

  gtk_signal_connect (GTK_OBJECT (osmtogglebt),
		      "clicked", GTK_SIGNAL_FUNC (osmtoggle_cb),
		      (gpointer) 1);

  zoombox = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (zoombox), zoomin, FALSE, FALSE, 0);

  zoombox2 = gtk_hbox_new (TRUE, 0);
  gtk_box_pack_start (GTK_BOX (zoombox2), zoom1, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (zoombox2), zoom2, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (zoombox2), zoom4, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (zoombox2), zoom8, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (zoombox2), zoom16, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (zoombox2), zoom32, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (zoombox2), zoom64, TRUE, TRUE, 0);

  gtk_box_pack_start (GTK_BOX (zoombox), zoombox2, FALSE, FALSE, 0);

  gtk_box_pack_start (GTK_BOX (zoombox), zoomout, FALSE, FALSE, 0);

  zoombox3 = gtk_hbox_new (TRUE, 0);
  gtk_box_pack_start (GTK_BOX (zoombox3), scalerlbt, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (zoombox3), scalerrbt, TRUE, TRUE, 0);

  gtk_box_pack_start (GTK_BOX (zoombox), zoombox3, FALSE, FALSE, 0);

  gtk_box_pack_start (GTK_BOX (zoombox), scaler, FALSE, FALSE, 0);

  zoombox4 = gtk_vbox_new (TRUE, 0);
  gtk_box_pack_start (GTK_BOX (zoombox4), bestmapbt, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (zoombox4), maptogglebt, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (zoombox4), topotogglebt, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (zoombox4), osmtogglebt, FALSE, FALSE, 0);
  gtk_container_add (GTK_CONTAINER (frame_maptype), zoombox4);

  zoombox5 = gtk_vbox_new (TRUE, 0);
  gtk_box_pack_start (GTK_BOX (zoombox5), lf4, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (zoombox5), lf8, FALSE, FALSE, 0);

  zoombox6 = gtk_hbox_new (TRUE, 0);
  gtk_box_pack_start (GTK_BOX (zoombox6), frame_maptype, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (zoombox6), zoombox5, TRUE, TRUE, 0);

  gtk_box_pack_start (GTK_BOX (zoombox), zoombox6, FALSE, FALSE, 0);

  gtk_box_pack_start (GTK_BOX (zoombox), lf3, FALSE, FALSE, 0);


  /************************ zoom tab end ***********************/


  /************************ wp tab start ***********************/

  sel_target = gtk_button_new_from_stock (GTK_STOCK_FIND);
  gtk_signal_connect (GTK_OBJECT (sel_target),
                      "clicked",
                      GTK_SIGNAL_FUNC (sel_target_cb), (gpointer) 2);

  addwaypoint = gtk_button_new_from_stock (GTK_STOCK_ADD);
  gtk_signal_connect (GTK_OBJECT (addwaypoint),
		      "clicked", GTK_SIGNAL_FUNC (addwaypointbutton_cb), (gpointer) 0);

  wpbt = gtk_check_button_new_with_label (_("Show _WP"));
  gtk_button_set_use_underline (GTK_BUTTON (wpbt), TRUE);
  if (wpflag)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (wpbt), TRUE);
  gtk_signal_connect (GTK_OBJECT (wpbt),
		      "clicked", GTK_SIGNAL_FUNC (wp_cb), (gpointer) 1);

  frame_target = gtk_frame_new (_("Target"));
  targetlabel = gtk_label_new ("---");
  gtk_container_add (GTK_CONTAINER (frame_target), targetlabel);

  frame_dist = gtk_frame_new (_("Distance"));
  distlabel = gtk_label_new ("---");
  gtk_container_add (GTK_CONTAINER (frame_dist), distlabel);

  frame_bearing = gtk_frame_new (_("Bearing"));
  drawing_bearing = gtk_drawing_area_new ();
  gtk_drawing_area_size (GTK_DRAWING_AREA (drawing_bearing), PSIZE + 2,
			 PSIZE + 2);
  gtk_signal_connect (GTK_OBJECT (drawing_bearing),
		      "expose_event", GTK_SIGNAL_FUNC (expose_compass), NULL);

  l6 = gtk_label_new (_("0000"));

  bearingbox = gtk_hbox_new (TRUE, 0);
  gtk_box_pack_start (GTK_BOX (bearingbox), drawing_bearing, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (bearingbox), l6, FALSE, FALSE, 0);
  gtk_container_add (GTK_CONTAINER (frame_bearing), bearingbox);

  wpbox = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (wpbox), sel_target, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (wpbox), addwaypoint, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (wpbox), wpbt, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (wpbox), frame_target, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (wpbox), frame_dist, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (wpbox), frame_bearing, FALSE, FALSE, 0);

  /************************ wp tab end ***********************/


  /************************ status tab start ***********************/

  statusbox1 = gtk_frame_new (_("GPS Info"));
  satsvbox = gtk_vbox_new (FALSE, 0);
  satshbox = gtk_hbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (statusbox1), satshbox);

  /* Area for field strength, we have data only in NMEA mode */

  drawing_sats1 = gtk_drawing_area_new ();
  gtk_drawing_area_size (GTK_DRAWING_AREA (drawing_sats1), PSIZE + 10,
			 PSIZE + 6);
  gtk_signal_connect (GTK_OBJECT (drawing_sats1), "expose_event",
		      GTK_SIGNAL_FUNC (expose_sats_cb), NULL);

  drawing_sats2 = gtk_drawing_area_new ();
  gtk_drawing_area_size (GTK_DRAWING_AREA (drawing_sats2), PSIZE + 10,
			 PSIZE + 6);
  gtk_signal_connect (GTK_OBJECT (drawing_sats2), "expose_event",
		      GTK_SIGNAL_FUNC (expose_sats_cb), NULL);

  gtk_box_pack_start (GTK_BOX (satshbox), drawing_sats1, TRUE, TRUE,
		      0);
  gtk_box_pack_start (GTK_BOX (satshbox), drawing_sats2, TRUE, TRUE,
		      0);
  gtk_box_pack_start (GTK_BOX (satshbox), satsvbox, TRUE, TRUE,
		      0);

  satslabel1 = gtk_label_new (_("n/a"));
  satslabel1frame = gtk_frame_new (_("Sats useful/visible"));
  gtk_container_add (GTK_CONTAINER (satslabel1frame), satslabel1);
  gtk_label_set_text (GTK_LABEL (satslabel1), _("n/a"));
  gtk_box_pack_start (GTK_BOX (satsvbox), satslabel1frame, TRUE, FALSE,
		      0);

  satslabel2 = gtk_label_new (_("n/a"));
  satslabel2frame = gtk_frame_new (_("Precision (RME)"));
  gtk_container_add (GTK_CONTAINER (satslabel2frame), satslabel2);
  gtk_label_set_text (GTK_LABEL (satslabel2), _("n/a"));
  gtk_box_pack_start (GTK_BOX (satsvbox), satslabel2frame, TRUE, FALSE,
		      0);

  satslabel3 = gtk_label_new (_("n/a"));
  satslabel3frame = gtk_frame_new (_("Precision (GSA)"));
  gtk_container_add (GTK_CONTAINER (satslabel3frame), satslabel3);
  gtk_label_set_text (GTK_LABEL (satslabel3), _("n/a"));
  gtk_box_pack_start (GTK_BOX (satsvbox), satslabel3frame, TRUE, FALSE,
		      0);

  lf1 = gtk_frame_new (_("Latitude"));
  lf2 = gtk_frame_new (_("Longitude"));
  frame_altitude = gtk_frame_new (_("Altitude"));
  frame_speed = gtk_frame_new (_("Speed"));
  lf5 = gtk_frame_new (_("Heading"));
  lf7 = gtk_frame_new (_("GPS Time."));

  l1 = gtk_label_new (_("000,00000 N"));
  gtk_container_add (GTK_CONTAINER (lf1), l1);
  l2 = gtk_label_new (_("000,00000 E"));
  gtk_container_add (GTK_CONTAINER (lf2), l2);
  altilabel = gtk_label_new (_("n/a"));
  gtk_container_add (GTK_CONTAINER (frame_altitude), altilabel);
  speedlabel = gtk_label_new (_("---"));
  gtk_container_add (GTK_CONTAINER (frame_speed), speedlabel);
  l5 = gtk_label_new (_("0000"));
  gtk_container_add (GTK_CONTAINER (lf5), l5);
  l7 = gtk_label_new (_("---"));
  gtk_container_add (GTK_CONTAINER (lf7), l7);

  statusbox2 = gtk_hbox_new (TRUE, 0);
  gtk_box_pack_start (GTK_BOX (statusbox2), lf1, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (statusbox2), lf2, TRUE, TRUE, 0);

  statusbox3 = gtk_hbox_new (TRUE, 0);
  gtk_box_pack_start (GTK_BOX (statusbox3), frame_altitude, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (statusbox3), lf5, TRUE, TRUE, 0);

  statusbox4 = gtk_hbox_new (TRUE, 0);
  gtk_box_pack_start (GTK_BOX (statusbox4), frame_speed, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (statusbox4), lf7, TRUE, TRUE, 0);

  statusbox = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (statusbox), statusbox1, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (statusbox), statusbox2, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (statusbox), statusbox3, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (statusbox), statusbox4, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (statusbox), status, FALSE, FALSE, 0);

  /************************ status tab end ***********************/

/*    if we want NMEA mode, gpsd must be running and we connect to port 2222 */
/*    An alternate gpsd server may be on 2947, we try it also */

  initgps ();

  if ((!disableserial) && (!disableserialcl))
    {
     haveserial = gpsserialinit ();
     if (haveserial)
       {
        haveNMEA = TRUE;
        gtk_widget_set_sensitive (startgpsbt, FALSE);
       }
    }

  /*  Area for map */
  dframe = gtk_frame_new (NULL);
  gtk_frame_set_shadow_type (GTK_FRAME (dframe), GTK_SHADOW_IN);
  drawing_area = gtk_drawing_area_new ();
  gtk_drawing_area_size (GTK_DRAWING_AREA (drawing_area), SCREEN_X, SCREEN_Y);
/*** Mod by Arms */
  gtk_container_add (GTK_CONTAINER (dframe), drawing_area);

  gtk_box_pack_start (GTK_BOX (vbig), dframe, TRUE, TRUE, 0);
  gtk_widget_add_events (GTK_WIDGET (drawing_area), GDK_BUTTON_PRESS_MASK);
  gtk_signal_connect_object (GTK_OBJECT (drawing_area),
			     "button-press-event",
			     GTK_SIGNAL_FUNC (mapclick_cb),
			     GTK_OBJECT (drawing_area));
/* Area for navigation pointer */
/*** Mod by Arms */

  frame_toogles = gtk_frame_new (NULL);
  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (frame_toogles), vbox4);

/*** Lots of Mods by Arms */
  vbox = gtk_vbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox), startgpsbt, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox), setupbt, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox), quit, FALSE, FALSE, 0);
  hboxlow = vbox2 = NULL;
  vboxlow = gtk_vbox_new (FALSE, 0);
  hboxlow = gtk_hbox_new (TRUE, 0);
  gtk_box_pack_start (GTK_BOX (vboxlow), frame_toogles, FALSE, TRUE,
                      0);
  gtk_box_pack_start (GTK_BOX (hboxlow), vbox, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (hboxlow), vboxlow, TRUE, TRUE,
                      0);

  gtk_box_pack_start (GTK_BOX (vbox4), mutebt, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox4), posbt, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox4), trackbt, FALSE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox4), savetrackbt, FALSE, FALSE, 0);
//KCFX

/*    gtk_box_pack_start (GTK_BOX (vbig), table1, FALSE, FALSE, 1); */
/*  all position calculations are made in the expose callback */
  gtk_signal_connect (GTK_OBJECT (drawing_area),
		      "expose_event", GTK_SIGNAL_FUNC (expose_cb), NULL);

/*   if pdamode is set, we use gtk-notebook add arrange the elements */
/*   in pdamode, extrawinmenu is also set! */
  mainnotebook = NULL;
     {
      GtkWidget *l1, *l2, *l3, *l4, *l5;
      l1 = gtk_label_new (_("Map"));
      l2 = gtk_label_new (_("Zoom"));
      l3 = gtk_label_new (_("WayPoint"));
      l4 = gtk_label_new (_("Status"));
      l5 = gtk_label_new (_("Menu"));
//KCFX
      mainnotebook = gtk_notebook_new ();
      gtk_notebook_set_tab_pos (GTK_NOTEBOOK (mainnotebook), GTK_POS_TOP);
      gtk_box_pack_start (GTK_BOX (hbig), vbig, TRUE, TRUE, 0);
      gtk_container_add (GTK_CONTAINER (mainwindow), mainnotebook);
      gtk_widget_show_all (hboxlow);
      gtk_widget_show_all (statusbox);
      gtk_widget_show_all (hbig);
      gtk_widget_show_all (vbig);
      gtk_notebook_append_page (GTK_NOTEBOOK (mainnotebook), hbig, l1);
      gtk_notebook_append_page (GTK_NOTEBOOK (mainnotebook), zoombox, l2);
      gtk_notebook_append_page (GTK_NOTEBOOK (mainnotebook), wpbox, l3);
      gtk_notebook_append_page (GTK_NOTEBOOK (mainnotebook), statusbox, l4);
      gtk_notebook_append_page (GTK_NOTEBOOK (mainnotebook), hboxlow, l5);
      gtk_notebook_set_page (GTK_NOTEBOOK (mainnotebook), 0);
      gtk_widget_show_all (mainnotebook);
    }

/*  Now show all Widgets */
  gtk_widget_show_all (mainwindow);

/*  now we know the drawables */
  gtk_notebook_set_page (GTK_NOTEBOOK (mainnotebook), 0);

  drawable = gdk_pixmap_new (mainwindow->window, SCREEN_X, SCREEN_Y, -1);
/* gtk_widget_set_double_buffered(drawable, FALSE);  */
/*    drawable = drawing_area->window; */
  gtk_notebook_set_page (GTK_NOTEBOOK (mainnotebook), 3);

  drawable_sats1 = drawing_sats1->window;
  drawable_sats2 = drawing_sats2->window;

  gtk_notebook_set_page (GTK_NOTEBOOK (mainnotebook), 2);
  drawable_bearing = drawing_bearing->window;

//KCFX
  kontext = gdk_gc_new (mainwindow->window);
  //  else 
  //    kontext = gdk_gc_new (mainnotebook->window); 

  gdk_gc_set_clip_origin (kontext, 0, 0);
  rectangle.width = SCREEN_X;
  rectangle.height = SCREEN_Y;

  gdk_gc_set_clip_rectangle (kontext, &rectangle);
  cmap = gdk_colormap_get_system ();
  gdk_color_alloc (cmap, &red);
  gdk_color_alloc (cmap, &black);
  gdk_color_alloc (cmap, &blue);
  gdk_color_alloc (cmap, &nightcolor);
  gdk_color_alloc (cmap, &lcd);
  gdk_color_alloc (cmap, &lcd2);
  gdk_color_alloc (cmap, &green);
  gdk_color_alloc (cmap, &green2);
  gdk_color_alloc (cmap, &white);
  gdk_color_alloc (cmap, &mygray);
  gdk_color_alloc (cmap, &yellow);
  gdk_color_alloc (cmap, &darkgrey);
  gdk_color_alloc (cmap, &grey);
  gdk_color_alloc (cmap, &textback);
  gdk_color_alloc (cmap, &textbacknew);
  gdk_color_alloc (cmap, &orange2);
  gdk_color_alloc (cmap, &orange);
  gdk_color_alloc (cmap, &trackcolorv);

/* fill window with color */
  gdk_gc_set_function (kontext, GDK_COPY);
  gdk_gc_set_foreground (kontext, &lcd2);
  gdk_draw_rectangle (drawing_area->window, kontext, 1, 0, 0, SCREEN_X,
		      SCREEN_Y);
  {
    GtkStyle *style;
    style = gtk_rc_get_style (mainwindow);
    defaultcolor = style->bg[GTK_STATE_NORMAL];
  }

  gtk_notebook_set_page (GTK_NOTEBOOK (mainnotebook), 1);

  cursor = gdk_cursor_new (GDK_CROSS);
  gtk_notebook_set_page (GTK_NOTEBOOK (mainnotebook), 0);

  gdk_window_set_cursor (drawing_area->window, cursor);

  if (haveNMEA)
    {
      gtk_button_set_label (GTK_BUTTON (startgpsbt), _("Stop GPSD"));
      gpson = TRUE;
    }

  g_strlcpy (mapfilename, "***", sizeof (mapfilename));
/*  set the timers */
  if (haveserial)
    timerto =
      gtk_timeout_add (TIMERSERIAL, (GtkFunction) get_position_data_cb, NULL);
  else
    timerto =
      gtk_timeout_add (TIMER, (GtkFunction) get_position_data_cb, NULL);
  gtk_timeout_add (WATCHWPTIMER, (GtkFunction) watchwp_cb, NULL);

  gtk_timeout_add (REDRAWTIMER, (GtkFunction) drawmarker_cb, NULL);

/*  if we started in simulator mode we have a little move roboter */

  if (nmeaout)
    gtk_timeout_add (1000, (GtkFunction) write_nmea_cb, NULL);
  gtk_timeout_add (10000, (GtkFunction) testconfig_cb, 0);
//  gtk_timeout_add (600000, (GtkFunction) speech_saytime_cb, 0);
  gtk_timeout_add (1000, (GtkFunction) storetrack_cb, 0);
  gtk_timeout_add (10000, (GtkFunction) masteragent_cb, 0);

  if (havespeechout)
    {
      speech_saytime_cb (NULL, 1);
      gtk_timeout_add (SPEECHOUTINTERVAL, (GtkFunction) speech_out_cb, 0);
    }
/*  To set the right sensitive flags */
  bestmap_cb (NULL, 0);
  needtosave = FALSE;

  /*  Mainloop */

  gtk_main ();


  g_timer_destroy (timer);
  writeconfig ();

  gpsserialquit ();
  unlink ("/tmp/cammain.pid");
  unlink ("/tmp/gpsdrivetext.out");
  unlink ("/tmp/gpsdrivepos");
  if (savetrack)
    savetrackfile (FALSE);
  g_free (routelist);
  if (sock != -1)
    close (sock);
  fprintf (stderr, _("\n\nThank you for using GpsDrive!\n\n"));
  return 0;
}
